//----------------------------------------------------------
//
// File: AWAREVBX.H
//
// Copyright (C) 1994 FarPoint Technologies.
// All rights reserved.
//
//----------------------------------------------------------

#ifndef _AWAREVBX_H
#define _AWAREVBX_H

#include "..\..\..\include\fp_base.h"


// Class representing AwareText10 control in AWARE.VBX file

class CAwareText : public CVBControl
{
  public:

#ifdef fpMFC

    BOOL Create(DWORD dwStyle, const RECT& rect,
                CWnd* pParentWnd, UINT nID,
                CFile* pFile = NULL, BOOL bAutoDelete = FALSE)
    {
      return CVBControl::Create(
               "AWARE.VBX;AwareText10;",
               dwStyle, rect,
               pParentWnd, nID,
               pFile, bAutoDelete
             );
    }

#elif fpOWL

    CAwareText(TWindow* parent, int id,
        const char far* title,
        int x, int y, int w, int h,
        long initLen = 0, void far* initData = 0,
        TModule* module = 0)
    : CVBControl(parent, id, "AWARE.VBX", "AwareText10",
          title, x, y, w, h, initLen, initData, module) {};

    CAwareText(TWindow* parent, int resourceId, TModule* module = 0)
    : CVBControl(parent, resourceId, module) {};

#endif

    CStringProperty About() {return CStringProperty(this,99);}
    CEnumProperty AlignTextH() {return CEnumProperty(this,60);}
    CEnumProperty AlignTextV() {return CEnumProperty(this,61);}
    CBoolProperty AllowNull() {return CBoolProperty(this,62);}
    CBoolProperty AutoAdvance() {return CBoolProperty(this,64);}
    CBoolProperty AutoBeep() {return CBoolProperty(this,65);}
    CEnumProperty AutoCase() {return CEnumProperty(this,66);}
    CColorProperty BackColor() {return CColorProperty(this,2);}
    CColorProperty BorderColor() {return CColorProperty(this,37);}
    CColorProperty BorderGrayAreaColor() {return CColorProperty(this,100);}
    CEnumProperty BorderStyle() {return CEnumProperty(this,36);}
    CShortProperty BorderWidth() {return CShortProperty(this,38);}
    CBoolProperty ButtonDefaultAction() {return CBoolProperty(this,50);}
    CBoolProperty ButtonDisable() {return CBoolProperty(this,41);}
    CBoolProperty ButtonHide() {return CBoolProperty(this,42);}
    CShortProperty ButtonIncrement() {return CShortProperty(this,43);}
    CShortProperty ButtonIndex() {return CShortProperty(this,44);}
    CShortProperty ButtonMax() {return CShortProperty(this,46);}
    CShortProperty ButtonMin() {return CShortProperty(this,45);}
    CEnumProperty ButtonStyle() {return CEnumProperty(this,47);}
    CLongProperty ButtonWidth() {return CLongProperty(this,48);}
    CBoolProperty ButtonWrap() {return CBoolProperty(this,49);}
    CEnumProperty CaretInsert() {return CEnumProperty(this,67);}
    CEnumProperty CaretOverWrite() {return CEnumProperty(this,68);}
    CLongProperty CharPositionLeft() {return CLongProperty(this,69);}
    CLongProperty CharPositionRight() {return CLongProperty(this,70);}
    CStringProperty CharValidationText() {return CStringProperty(this,93);}
    CEnumProperty ControlType() {return CEnumProperty(this,91);}
    CLongProperty CurrentPosition() {return CLongProperty(this,71);}
    CColorProperty DropShadowColor() {return CColorProperty(this,53);}
    CShortProperty DropShadowWidth() {return CShortProperty(this,54);}
    CBoolProperty Enabled() {return CBoolProperty(this,19);}
    CBoolProperty FontBold() {return CBoolProperty(this,10);}
    CBoolProperty FontItalic() {return CBoolProperty(this,11);}
    CStringProperty FontName() {return CStringProperty(this,9);}
    CFloatProperty FontSize() {return CFloatProperty(this,14);}
    CBoolProperty FontStrikethru() {return CBoolProperty(this,12);}
    CBoolProperty FontUnderline() {return CBoolProperty(this,13);}
    CColorProperty ForeColor() {return CColorProperty(this,3);}
    CLongProperty Height() {return CLongProperty(this,7);}
    CBoolProperty HideSelection() {return CBoolProperty(this,73);}
    CFloatProperty IncHoriz() {return CFloatProperty(this,97);}
    CShortProperty Index() {return CShortProperty(this,1);}
    CColorProperty InvalidColor() {return CColorProperty(this,75);}
    CEnumProperty InvalidOption() {return CEnumProperty(this,76);}
    CBoolProperty IsNull() {return CBoolProperty(this,77);}
    CBoolProperty IsValid() {return CBoolProperty(this,78);}
    CLongProperty Left() {return CLongProperty(this,4);}
    CShortProperty MarginBottom() {return CShortProperty(this,82);}
    CShortProperty MarginLeft() {return CShortProperty(this,79);}
    CShortProperty MarginRight() {return CShortProperty(this,81);}
    CShortProperty MarginTop() {return CShortProperty(this,80);}
    CLongProperty MaxLength() {return CLongProperty(this,94);}
    CEnumProperty MousePointer() {return CEnumProperty(this,8);}
    CBoolProperty MultiLine() {return CBoolProperty(this,95);}
    CStringProperty Name() {return CStringProperty(this,0);}
    CEnumProperty NoSpecialKeys() {return CEnumProperty(this,63);}
    CColorProperty NullColor() {return CColorProperty(this,83);}
    CEnumProperty OnFocusAlignH() {return CEnumProperty(this,84);}
    CEnumProperty OnFocusAlignV() {return CEnumProperty(this,85);}
    CBoolProperty OnFocusInvert3D() {return CBoolProperty(this,51);}
    CBoolProperty OnFocusNoSelect() {return CBoolProperty(this,86);}
    CEnumProperty OnFocusPosition() {return CEnumProperty(this,87);}
    CBoolProperty OnFocusShadow() {return CBoolProperty(this,52);}
    CShortProperty Parent() {return CShortProperty(this,20);}
    CStringProperty PasswordChar() {return CStringProperty(this,96);}
    CBoolProperty Redraw() {return CBoolProperty(this,98);}
    CLongProperty SelLength() {return CLongProperty(this,88);}
    CLongProperty SelStart() {return CLongProperty(this,89);}
    CStringProperty SelText() {return CStringProperty(this,90);}
    CShortProperty TabIndex() {return CShortProperty(this,15);}
    CShortProperty TabStop() {return CShortProperty(this,16);}
    CStringProperty Tag() {return CStringProperty(this,21);}
    CStringProperty Text() {return CStringProperty(this,92);}
    CShortProperty ThreeDFrameWidth() {return CShortProperty(this,35);}
    CColorProperty ThreeDInsideHighlightColor() {return CColorProperty(this,28);}
    CColorProperty ThreeDInsideShadowColor() {return CColorProperty(this,29);}
    CEnumProperty ThreeDInsideStyle() {return CEnumProperty(this,27);}
    CShortProperty ThreeDInsideWidth() {return CShortProperty(this,30);}
    CColorProperty ThreeDOutsideHighlightColor() {return CColorProperty(this,32);}
    CColorProperty ThreeDOutsideShadowColor() {return CColorProperty(this,33);}
    CEnumProperty ThreeDOutsideStyle() {return CEnumProperty(this,31);}
    CShortProperty ThreeDOutsideWidth() {return CShortProperty(this,34);}
    CEnumProperty ThreeDText() {return CEnumProperty(this,55);}
    CColorProperty ThreeDTextHighlightColor() {return CColorProperty(this,56);}
    CShortProperty ThreeDTextOffset() {return CShortProperty(this,58);}
    CColorProperty ThreeDTextShadowColor() {return CColorProperty(this,57);}
    CLongProperty Top() {return CLongProperty(this,5);}
    CEnumProperty UserEntry() {return CEnumProperty(this,72);}
    CBoolProperty Visible() {return CBoolProperty(this,22);}
    CLongProperty Width() {return CLongProperty(this,6);}
    CShortProperty hWnd() {return CShortProperty(this,74);}

};

#ifdef fpMFC

inline void AFXAPI
DDX_VBControl(CDataExchange* pDX, int nIDC, CAwareText*& rpAwareText)
{
  CVBControl* pControl = (CVBControl*)rpAwareText;
  DDX_VBControl(pDX, nIDC, pControl);
  rpAwareText = (CAwareText*)pControl;
}
#endif

// AwareText event indices
#define EVENT_TXT_ADVANCE 0
#define EVENT_TXT_BUTTONHIT 1
#define EVENT_TXT_CHANGE 2
#define EVENT_TXT_CHANGEMODE 3
#define EVENT_TXT_CLICK 4
#define EVENT_TXT_DBLCLICK 5
#define EVENT_TXT_GOTFOUCS 8
#define EVENT_TXT_INVALIDDATA 9
#define EVENT_TXT_KEYDOWN 10
#define EVENT_TXT_KEYPRESS 11
#define EVENT_TXT_KEYUP 12
#define EVENT_TXT_LOSTFOCUS 13
#define EVENT_TXT_MOUSEDOWN 14
#define EVENT_TXT_MOUSEMOVE 15
#define EVENT_TXT_MOUSEUP 16
#define EVENT_TXT_USERERROR 17

// AwareText property indices
#define PROP_TXT_ABOUT 99
#define PROP_TXT_ACTION 59
#define PROP_TXT_ALIGNTEXTH 60
#define PROP_TXT_ALIGNTEXTV 61
#define PROP_TXT_ALLOWNULL 62
#define PROP_TXT_AUTOADVANCE 64
#define PROP_TXT_AUTOBEEP 65
#define PROP_TXT_AUTOCASE 66
#define PROP_TXT_BACKCOLOR 2
#define PROP_TXT_BORDERCOLOR 37
#define PROP_TXT_BORDERGRAYAREACOLOR 100
#define PROP_TXT_BORDERSTYLE 36
#define PROP_TXT_BORDERWIDTH 38
#define PROP_TXT_BUTTONDEFAULTACTION 50
#define PROP_TXT_BUTTONDISABLE 41
#define PROP_TXT_BUTTONHIDE 42
#define PROP_TXT_BUTTONINCREMENT 43
#define PROP_TXT_BUTTONINDEX 44
#define PROP_TXT_BUTTONMAX 46
#define PROP_TXT_BUTTONMIN 45
#define PROP_TXT_BUTTONSTYLE 47
#define PROP_TXT_BUTTONWIDTH 48
#define PROP_TXT_BUTTONWRAP 49
#define PROP_TXT_CARETINSERT 67
#define PROP_TXT_CARETOVERWRITE 68
#define PROP_TXT_CHARPOSITIONLEFT 69
#define PROP_TXT_CHARPOSITIONRIGHT 70
#define PROP_TXT_CHARVALIDATIONTEXT 93
#define PROP_TXT_CONTROLTYPE 91
#define PROP_TXT_CURRENTPOSITION 71
#define PROP_TXT_DROPSHADOWCOLOR 53
#define PROP_TXT_DROPSHADOWWIDTH 54
#define PROP_TXT_ENABLED 19
#define PROP_TXT_FONTBOLD 10
#define PROP_TXT_FONTITALIC 11
#define PROP_TXT_FONTNAME 9
#define PROP_TXT_FONTSIZE 14
#define PROP_TXT_FONTSTRIKETHRU 12
#define PROP_TXT_FONTUNDERLINE 13
#define PROP_TXT_FORECOLOR 3
#define PROP_TXT_HEIGHT 7
#define PROP_TXT_HIDESELECTION 73
#define PROP_TXT_INCHORIZ 97
#define PROP_TXT_INDEX 1
#define PROP_TXT_INVALIDCOLOR 75
#define PROP_TXT_INVALIDOPTION 76
#define PROP_TXT_ISNULL 77
#define PROP_TXT_ISVALID 78
#define PROP_TXT_LEFT 4
#define PROP_TXT_MARGINBOTTOM 82
#define PROP_TXT_MARGINLEFT 79
#define PROP_TXT_MARGINRIGHT 81
#define PROP_TXT_MARGINTOP 80
#define PROP_TXT_MAXLENGTH 94
#define PROP_TXT_MOUSEPOINTER 8
#define PROP_TXT_MULTILINE 95
#define PROP_TXT_NAME 0
#define PROP_TXT_NOSPECIALKEYS 63
#define PROP_TXT_NULLCOLOR 83
#define PROP_TXT_ONFOCUSALIGNH 84
#define PROP_TXT_ONFOCUSALIGNV 85
#define PROP_TXT_ONFOCUSINVERT3D 51
#define PROP_TXT_ONFOCUSNOSELECT 86
#define PROP_TXT_ONFOCUSPOSITION 87
#define PROP_TXT_ONFOCUSSHADOW 52
#define PROP_TXT_PARENT 20
#define PROP_TXT_PASSWORDCHAR 96
#define PROP_TXT_REDRAW 98
#define PROP_TXT_SELLENGTH 88
#define PROP_TXT_SELSTART 89
#define PROP_TXT_SELTEXT 90
#define PROP_TXT_TABINDEX 15
#define PROP_TXT_TABSTOP 16
#define PROP_TXT_TAG 21
#define PROP_TXT_TEXT 92
#define PROP_TXT_THREEDFRAMEWIDTH 35
#define PROP_TXT_THREEDINSIDEHIGHLIGHTCOLOR 28
#define PROP_TXT_THREEDINSIDESHADOWCOLOR 29
#define PROP_TXT_THREEDINSIDESTYLE 27
#define PROP_TXT_THREEDINSIDEWIDTH 30
#define PROP_TXT_THREEDOUTSIDEHIGHLIGHTCOLOR 32
#define PROP_TXT_THREEDOUTSIDESHADOWCOLOR 33
#define PROP_TXT_THREEDOUTSIDESTYLE 31
#define PROP_TXT_THREEDOUTSIDEWIDTH 34
#define PROP_TXT_THREEDTEXT 55
#define PROP_TXT_THREEDTEXTHIGHLIGHTCOLOR 56
#define PROP_TXT_THREEDTEXTOFFSET 58
#define PROP_TXT_THREEDTEXTSHADOWCOLOR 57
#define PROP_TXT_TOP 5
#define PROP_TXT_USERENTRY 72
#define PROP_TXT_VISIBLE 22
#define PROP_TXT_WIDTH 6
#define PROP_TXT_HWND 74

#ifdef fpMFC


// AwareText event macros
#define TXT_ADVANCE_DIRECTION(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define TXT_ADVANCE_AUTOADVANCE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define TXT_BUTTONHIT_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define TXT_BUTTONHIT_NEWINDEX(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define TXT_CHANGEMODE_EDITMODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define TXT_CLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define TXT_DBLCLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define TXT_INVALIDDATA_NEXTWND(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define TXT_KEYDOWN_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,1)
#define TXT_KEYDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define TXT_KEYPRESS_KEYASCII(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define TXT_KEYUP_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define TXT_KEYUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define TXT_MOUSEDOWN_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define TXT_MOUSEDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define TXT_MOUSEDOWN_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define TXT_MOUSEDOWN_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define TXT_MOUSEMOVE_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define TXT_MOUSEMOVE_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define TXT_MOUSEMOVE_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define TXT_MOUSEMOVE_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define TXT_MOUSEUP_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define TXT_MOUSEUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define TXT_MOUSEUP_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define TXT_MOUSEUP_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define TXT_USERERROR_ERRORCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define TXT_USERERROR_AUTOBEEP(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)

#elif fpOWL


// AwareText event macros
#define TXT_ADVANCE_DIRECTION(event) VBX_EVENTARGNUM(event,int,0)
#define TXT_ADVANCE_AUTOADVANCE(event) VBX_EVENTARGNUM(event,int,1)
#define TXT_BUTTONHIT_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define TXT_BUTTONHIT_NEWINDEX(event) VBX_EVENTARGNUM(event,int,1)
#define TXT_CHANGEMODE_EDITMODE(event) VBX_EVENTARGNUM(event,int,0)
#define TXT_CLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define TXT_DBLCLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define TXT_INVALIDDATA_NEXTWND(event) VBX_EVENTARGNUM(event,int,0)
#define TXT_KEYDOWN_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define TXT_KEYDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define TXT_KEYPRESS_KEYASCII(event) VBX_EVENTARGNUM(event,int,0)
#define TXT_KEYUP_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define TXT_KEYUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define TXT_MOUSEDOWN_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define TXT_MOUSEDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define TXT_MOUSEDOWN_X(event) VBX_EVENTARGNUM(event,float,2)
#define TXT_MOUSEDOWN_Y(event) VBX_EVENTARGNUM(event,float,3)
#define TXT_MOUSEMOVE_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define TXT_MOUSEMOVE_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define TXT_MOUSEMOVE_X(event) VBX_EVENTARGNUM(event,float,2)
#define TXT_MOUSEMOVE_Y(event) VBX_EVENTARGNUM(event,float,3)
#define TXT_MOUSEUP_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define TXT_MOUSEUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define TXT_MOUSEUP_X(event) VBX_EVENTARGNUM(event,float,2)
#define TXT_MOUSEUP_Y(event) VBX_EVENTARGNUM(event,float,3)
#define TXT_USERERROR_ERRORCODE(event) VBX_EVENTARGNUM(event,int,0)
#define TXT_USERERROR_AUTOBEEP(event) VBX_EVENTARGNUM(event,int,1)

#endif


// AwareText property values
#define TXT_ACTION_COPY 0
#define TXT_ACTION_CUT 1
#define TXT_ACTION_PASTE 2
#define TXT_ACTION_CLEAR 3
#define TXT_ACTION_UNDO 4
#define TXT_ACTION_SET_NULL 5
#define TXT_ALIGNTEXTH_LEFT 0
#define TXT_ALIGNTEXTH_CENTER 1
#define TXT_ALIGNTEXTH_RIGHT 2
#define TXT_ALIGNTEXTV_TOP 0
#define TXT_ALIGNTEXTV_CENTER 1
#define TXT_ALIGNTEXTV_BOTTOM 2
#define TXT_AUTOCASE_NONE 0
#define TXT_AUTOCASE_UPPER 1
#define TXT_AUTOCASE_LOWER 2
#define TXT_AUTOCASE_PROPER 3
#define TXT_AUTOCASE_PROPER_W_UPPER 4
#define TXT_BORDERSTYLE_NO_BORDER 0
#define TXT_BORDERSTYLE_SINGLE_LINE 1
#define TXT_BORDERSTYLE_ROUNDED 2
#define TXT_BORDERSTYLE_DASH 3
#define TXT_BORDERSTYLE_DOT 4
#define TXT_BORDERSTYLE_DASH_DOT 5
#define TXT_BORDERSTYLE_DASH_DOT_DOT 6
#define TXT_BUTTONSTYLE_NONE 0
#define TXT_BUTTONSTYLE_SPIN 1
#define TXT_BUTTONSTYLE_POP_UP 2
#define TXT_BUTTONSTYLE_DROP_DOWN 3
#define TXT_BUTTONSTYLE_SLIDE 4
#define TXT_CARETINSERT_SINGLE 0
#define TXT_CARETINSERT_DOUBLE 1
#define TXT_CARETINSERT_BLOCK 2
#define TXT_CARETINSERT_UNDERLINE 3
#define TXT_CARETINSERT_TRIANGLE 4
#define TXT_CARETOVERWRITE_SINGLE 0
#define TXT_CARETOVERWRITE_DOUBLE 1
#define TXT_CARETOVERWRITE_BLOCK 2
#define TXT_CARETOVERWRITE_UNDERLINE 3
#define TXT_CARETOVERWRITE_TRIANGLE 4
#define TXT_CONTROLTYPE_NORMAL 0
#define TXT_CONTROLTYPE_READ_ONLY 1
#define TXT_CONTROLTYPE_STATIC 2
#define TXT_INVALIDOPTION_SHOW_DATA 0
#define TXT_INVALIDOPTION_HIDE_DATA 1
#define TXT_INVALIDOPTION_CLEAR_DATA 2
#define TXT_MOUSEPOINTER_DEFAULT 0
#define TXT_MOUSEPOINTER_ARROW 1
#define TXT_MOUSEPOINTER_CROSS 2
#define TXT_MOUSEPOINTER_I_BEAM 3
#define TXT_MOUSEPOINTER_ICON 4
#define TXT_MOUSEPOINTER_SIZE 5
#define TXT_MOUSEPOINTER_SIZE_NE_SW 6
#define TXT_MOUSEPOINTER_SIZE_N_S 7
#define TXT_MOUSEPOINTER_SIZE_NW_SE 8
#define TXT_MOUSEPOINTER_SIZE_W_E 9
#define TXT_MOUSEPOINTER_UP_ARROW 10
#define TXT_MOUSEPOINTER_HOURGLASS 11
#define TXT_MOUSEPOINTER_NO_DROP 12
#define TXT_NOSPECIALKEYS_ALL_KEYS_ENABLED 0
#define TXT_NOSPECIALKEYS_AWARE_KEYS_DISABLED 1
#define TXT_NOSPECIALKEYS_EDIT_KEYS_DISABLED 2
#define TXT_NOSPECIALKEYS_ALL_KEYS_DISABLED 3
#define TXT_ONFOCUSALIGNH_DEFAULT 0
#define TXT_ONFOCUSALIGNH_LEFT 1
#define TXT_ONFOCUSALIGNH_CENTER 2
#define TXT_ONFOCUSALIGNH_RIGHT 3
#define TXT_ONFOCUSALIGNV_DEFAULT 0
#define TXT_ONFOCUSALIGNV_TOP 1
#define TXT_ONFOCUSALIGNV_CENTER 2
#define TXT_ONFOCUSALIGNV_BOTTOM 3
#define TXT_ONFOCUSPOSITION_END 0
#define TXT_ONFOCUSPOSITION_BEGINNING 1
#define TXT_ONFOCUSPOSITION_PREVIOUS 2
#define TXT_ONFOCUSPOSITION_CARET 3
#define TXT_THREEDINSIDESTYLE_NONE 0
#define TXT_THREEDINSIDESTYLE_LOWERED 1
#define TXT_THREEDINSIDESTYLE_RAISED 2
#define TXT_THREEDOUTSIDESTYLE_NONE 0
#define TXT_THREEDOUTSIDESTYLE_LOWERED 1
#define TXT_THREEDOUTSIDESTYLE_RAISED 2
#define TXT_THREEDTEXT_NONE 0
#define TXT_THREEDTEXT_ETCHED 1
#define TXT_THREEDTEXT_EMBOSSED 2
#define TXT_THREEDTEXT_ETCHED_W_SHADING 3
#define TXT_THREEDTEXT_EMBOSSED_W_SHADING 4
#define TXT_USERENTRY_FORMATTED 0
#define TXT_USERENTRY_FREE_FORMAT 1

// Class representing AwareMask10 control in AWARE.VBX file

class CAwareMask : public CVBControl
{
  public:

#ifdef fpMFC

    BOOL Create(DWORD dwStyle, const RECT& rect,
                CWnd* pParentWnd, UINT nID,
                CFile* pFile = NULL, BOOL bAutoDelete = FALSE)
    {
      return CVBControl::Create(
               "AWARE.VBX;AwareMask10;",
               dwStyle, rect,
               pParentWnd, nID,
               pFile, bAutoDelete
             );
    }

#elif fpOWL

    CAwareMask(TWindow* parent, int id,
        const char far* title,
        int x, int y, int w, int h,
        long initLen = 0, void far* initData = 0,
        TModule* module = 0)
    : CVBControl(parent, id, "AWARE.VBX", "AwareMask10",
          title, x, y, w, h, initLen, initData, module) {};

    CAwareMask(TWindow* parent, int resourceId, TModule* module = 0)
    : CVBControl(parent, resourceId, module) {};

#endif

    CStringProperty About() {return CStringProperty(this,102);}
    CEnumProperty AlignTextH() {return CEnumProperty(this,59);}
    CEnumProperty AlignTextV() {return CEnumProperty(this,60);}
    CBoolProperty AllowNull() {return CBoolProperty(this,61);}
    CBoolProperty AllowOverflow() {return CBoolProperty(this,91);}
    CBoolProperty AutoAdvance() {return CBoolProperty(this,63);}
    CBoolProperty AutoBeep() {return CBoolProperty(this,64);}
    CColorProperty BackColor() {return CColorProperty(this,2);}
    CBoolProperty BestFit() {return CBoolProperty(this,92);}
    CColorProperty BorderColor() {return CColorProperty(this,37);}
    CColorProperty BorderGrayAreaColor() {return CColorProperty(this,103);}
    CEnumProperty BorderStyle() {return CEnumProperty(this,36);}
    CShortProperty BorderWidth() {return CShortProperty(this,38);}
    CBoolProperty ButtonDisable() {return CBoolProperty(this,41);}
    CBoolProperty ButtonHide() {return CBoolProperty(this,42);}
    CShortProperty ButtonIncrement() {return CShortProperty(this,43);}
    CShortProperty ButtonIndex() {return CShortProperty(this,44);}
    CShortProperty ButtonMax() {return CShortProperty(this,46);}
    CShortProperty ButtonMin() {return CShortProperty(this,45);}
    CEnumProperty ButtonStyle() {return CEnumProperty(this,47);}
    CLongProperty ButtonWidth() {return CLongProperty(this,48);}
    CBoolProperty ButtonWrap() {return CBoolProperty(this,49);}
    CEnumProperty CaretInsert() {return CEnumProperty(this,65);}
    CEnumProperty CaretOverWrite() {return CEnumProperty(this,66);}
    CLongProperty CharPositionLeft() {return CLongProperty(this,67);}
    CLongProperty CharPositionRight() {return CLongProperty(this,68);}
    CEnumProperty ClipMode() {return CEnumProperty(this,93);}
    CEnumProperty ControlType() {return CEnumProperty(this,89);}
    CLongProperty CurrentPosition() {return CLongProperty(this,69);}
    CEnumProperty DataFormat() {return CEnumProperty(this,94);}
    CColorProperty DropShadowColor() {return CColorProperty(this,52);}
    CShortProperty DropShadowWidth() {return CShortProperty(this,53);}
    CBoolProperty Enabled() {return CBoolProperty(this,19);}
    CBoolProperty FontBold() {return CBoolProperty(this,10);}
    CBoolProperty FontItalic() {return CBoolProperty(this,11);}
    CStringProperty FontName() {return CStringProperty(this,9);}
    CFloatProperty FontSize() {return CFloatProperty(this,14);}
    CBoolProperty FontStrikethru() {return CBoolProperty(this,12);}
    CBoolProperty FontUnderline() {return CBoolProperty(this,13);}
    CColorProperty ForeColor() {return CColorProperty(this,3);}
    CLongProperty Height() {return CLongProperty(this,7);}
    CBoolProperty HideSelection() {return CBoolProperty(this,71);}
    CShortProperty Index() {return CShortProperty(this,1);}
    CColorProperty InvalidColor() {return CColorProperty(this,73);}
    CEnumProperty InvalidOption() {return CEnumProperty(this,74);}
    CBoolProperty IsNull() {return CBoolProperty(this,75);}
    CBoolProperty IsValid() {return CBoolProperty(this,76);}
    CLongProperty Left() {return CLongProperty(this,4);}
    CShortProperty MarginBottom() {return CShortProperty(this,80);}
    CShortProperty MarginLeft() {return CShortProperty(this,77);}
    CShortProperty MarginRight() {return CShortProperty(this,79);}
    CShortProperty MarginTop() {return CShortProperty(this,78);}
    CStringProperty Mask() {return CStringProperty(this,95);}
    CStringProperty MaskChar(int i) {return CStringProperty(this,96,i);}
    CEnumProperty MousePointer() {return CEnumProperty(this,8);}
    CStringProperty Name() {return CStringProperty(this,0);}
    CEnumProperty NoSpecialKeys() {return CEnumProperty(this,62);}
    CColorProperty NullColor() {return CColorProperty(this,81);}
    CEnumProperty OnFocusAlignH() {return CEnumProperty(this,82);}
    CEnumProperty OnFocusAlignV() {return CEnumProperty(this,83);}
    CBoolProperty OnFocusInvert3D() {return CBoolProperty(this,50);}
    CBoolProperty OnFocusNoSelect() {return CBoolProperty(this,84);}
    CEnumProperty OnFocusPosition() {return CEnumProperty(this,85);}
    CBoolProperty OnFocusShadow() {return CBoolProperty(this,51);}
    CShortProperty Parent() {return CShortProperty(this,20);}
    CStringProperty PromptChar() {return CStringProperty(this,97);}
    CBoolProperty PromptInclude() {return CBoolProperty(this,98);}
    CBoolProperty Redraw() {return CBoolProperty(this,101);}
    CBoolProperty RequireFill() {return CBoolProperty(this,99);}
    CLongProperty SelLength() {return CLongProperty(this,86);}
    CLongProperty SelStart() {return CLongProperty(this,87);}
    CStringProperty SelText() {return CStringProperty(this,88);}
    CShortProperty TabIndex() {return CShortProperty(this,15);}
    CShortProperty TabStop() {return CShortProperty(this,16);}
    CStringProperty Tag() {return CStringProperty(this,21);}
    CStringProperty Text() {return CStringProperty(this,90);}
    CShortProperty ThreeDFrameWidth() {return CShortProperty(this,35);}
    CColorProperty ThreeDInsideHighlightColor() {return CColorProperty(this,28);}
    CColorProperty ThreeDInsideShadowColor() {return CColorProperty(this,29);}
    CEnumProperty ThreeDInsideStyle() {return CEnumProperty(this,27);}
    CShortProperty ThreeDInsideWidth() {return CShortProperty(this,30);}
    CColorProperty ThreeDOutsideHighlightColor() {return CColorProperty(this,32);}
    CColorProperty ThreeDOutsideShadowColor() {return CColorProperty(this,33);}
    CEnumProperty ThreeDOutsideStyle() {return CEnumProperty(this,31);}
    CShortProperty ThreeDOutsideWidth() {return CShortProperty(this,34);}
    CEnumProperty ThreeDText() {return CEnumProperty(this,54);}
    CColorProperty ThreeDTextHighlightColor() {return CColorProperty(this,55);}
    CShortProperty ThreeDTextOffset() {return CShortProperty(this,57);}
    CColorProperty ThreeDTextShadowColor() {return CColorProperty(this,56);}
    CLongProperty Top() {return CLongProperty(this,5);}
    CStringProperty UnFmtText() {return CStringProperty(this,100);}
    CEnumProperty UserEntry() {return CEnumProperty(this,70);}
    CBoolProperty Visible() {return CBoolProperty(this,22);}
    CLongProperty Width() {return CLongProperty(this,6);}
    CShortProperty hWnd() {return CShortProperty(this,72);}

};

#ifdef fpMFC

inline void AFXAPI
DDX_VBControl(CDataExchange* pDX, int nIDC, CAwareMask*& rpAwareMask)
{
  CVBControl* pControl = (CVBControl*)rpAwareMask;
  DDX_VBControl(pDX, nIDC, pControl);
  rpAwareMask = (CAwareMask*)pControl;
}
#endif

// AwareMask event indices
#define EVENT_MSK_ADVANCE 0
#define EVENT_MSK_BUTTONHIT 1
#define EVENT_MSK_CHANGE 2
#define EVENT_MSK_CHANGEMODE 3
#define EVENT_MSK_CLICK 4
#define EVENT_MSK_DBLCLICK 5
#define EVENT_MSK_GOTFOUCS 8
#define EVENT_MSK_INVALIDDATA 9
#define EVENT_MSK_KEYDOWN 10
#define EVENT_MSK_KEYPRESS 11
#define EVENT_MSK_KEYUP 12
#define EVENT_MSK_LOSTFOCUS 13
#define EVENT_MSK_MOUSEDOWN 14
#define EVENT_MSK_MOUSEMOVE 15
#define EVENT_MSK_MOUSEUP 16
#define EVENT_MSK_USERERROR 17

// AwareMask property indices
#define PROP_MSK_ABOUT 102
#define PROP_MSK_ACTION 58
#define PROP_MSK_ALIGNTEXTH 59
#define PROP_MSK_ALIGNTEXTV 60
#define PROP_MSK_ALLOWNULL 61
#define PROP_MSK_ALLOWOVERFLOW 91
#define PROP_MSK_AUTOADVANCE 63
#define PROP_MSK_AUTOBEEP 64
#define PROP_MSK_BACKCOLOR 2
#define PROP_MSK_BESTFIT 92
#define PROP_MSK_BORDERCOLOR 37
#define PROP_MSK_BORDERGRAYAREACOLOR 103
#define PROP_MSK_BORDERSTYLE 36
#define PROP_MSK_BORDERWIDTH 38
#define PROP_MSK_BUTTONDISABLE 41
#define PROP_MSK_BUTTONHIDE 42
#define PROP_MSK_BUTTONINCREMENT 43
#define PROP_MSK_BUTTONINDEX 44
#define PROP_MSK_BUTTONMAX 46
#define PROP_MSK_BUTTONMIN 45
#define PROP_MSK_BUTTONSTYLE 47
#define PROP_MSK_BUTTONWIDTH 48
#define PROP_MSK_BUTTONWRAP 49
#define PROP_MSK_CARETINSERT 65
#define PROP_MSK_CARETOVERWRITE 66
#define PROP_MSK_CHARPOSITIONLEFT 67
#define PROP_MSK_CHARPOSITIONRIGHT 68
#define PROP_MSK_CLIPMODE 93
#define PROP_MSK_CONTROLTYPE 89
#define PROP_MSK_CURRENTPOSITION 69
#define PROP_MSK_DATAFORMAT 94
#define PROP_MSK_DROPSHADOWCOLOR 52
#define PROP_MSK_DROPSHADOWWIDTH 53
#define PROP_MSK_ENABLED 19
#define PROP_MSK_FONTBOLD 10
#define PROP_MSK_FONTITALIC 11
#define PROP_MSK_FONTNAME 9
#define PROP_MSK_FONTSIZE 14
#define PROP_MSK_FONTSTRIKETHRU 12
#define PROP_MSK_FONTUNDERLINE 13
#define PROP_MSK_FORECOLOR 3
#define PROP_MSK_HEIGHT 7
#define PROP_MSK_HIDESELECTION 71
#define PROP_MSK_INDEX 1
#define PROP_MSK_INVALIDCOLOR 73
#define PROP_MSK_INVALIDOPTION 74
#define PROP_MSK_ISNULL 75
#define PROP_MSK_ISVALID 76
#define PROP_MSK_LEFT 4
#define PROP_MSK_MARGINBOTTOM 80
#define PROP_MSK_MARGINLEFT 77
#define PROP_MSK_MARGINRIGHT 79
#define PROP_MSK_MARGINTOP 78
#define PROP_MSK_MASK 95
#define PROP_MSK_MASKCHAR 96
#define PROP_MSK_MOUSEPOINTER 8
#define PROP_MSK_NAME 0
#define PROP_MSK_NOSPECIALKEYS 62
#define PROP_MSK_NULLCOLOR 81
#define PROP_MSK_ONFOCUSALIGNH 82
#define PROP_MSK_ONFOCUSALIGNV 83
#define PROP_MSK_ONFOCUSINVERT3D 50
#define PROP_MSK_ONFOCUSNOSELECT 84
#define PROP_MSK_ONFOCUSPOSITION 85
#define PROP_MSK_ONFOCUSSHADOW 51
#define PROP_MSK_PARENT 20
#define PROP_MSK_PROMPTCHAR 97
#define PROP_MSK_PROMPTINCLUDE 98
#define PROP_MSK_REDRAW 101
#define PROP_MSK_REQUIREFILL 99
#define PROP_MSK_SELLENGTH 86
#define PROP_MSK_SELSTART 87
#define PROP_MSK_SELTEXT 88
#define PROP_MSK_TABINDEX 15
#define PROP_MSK_TABSTOP 16
#define PROP_MSK_TAG 21
#define PROP_MSK_TEXT 90
#define PROP_MSK_THREEDFRAMEWIDTH 35
#define PROP_MSK_THREEDINSIDEHIGHLIGHTCOLOR 28
#define PROP_MSK_THREEDINSIDESHADOWCOLOR 29
#define PROP_MSK_THREEDINSIDESTYLE 27
#define PROP_MSK_THREEDINSIDEWIDTH 30
#define PROP_MSK_THREEDOUTSIDEHIGHLIGHTCOLOR 32
#define PROP_MSK_THREEDOUTSIDESHADOWCOLOR 33
#define PROP_MSK_THREEDOUTSIDESTYLE 31
#define PROP_MSK_THREEDOUTSIDEWIDTH 34
#define PROP_MSK_THREEDTEXT 54
#define PROP_MSK_THREEDTEXTHIGHLIGHTCOLOR 55
#define PROP_MSK_THREEDTEXTOFFSET 57
#define PROP_MSK_THREEDTEXTSHADOWCOLOR 56
#define PROP_MSK_TOP 5
#define PROP_MSK_UNFMTTEXT 100
#define PROP_MSK_USERENTRY 70
#define PROP_MSK_VISIBLE 22
#define PROP_MSK_WIDTH 6
#define PROP_MSK_HWND 72

#ifdef fpMFC


// AwareMask event macros
#define MSK_ADVANCE_DIRECTION(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define MSK_ADVANCE_AUTOADVANCE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MSK_BUTTONHIT_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define MSK_BUTTONHIT_NEWINDEX(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MSK_CHANGEMODE_EDITMODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MSK_CLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MSK_DBLCLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MSK_INVALIDDATA_NEXTWND(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MSK_KEYDOWN_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,1)
#define MSK_KEYDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define MSK_KEYPRESS_KEYASCII(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define MSK_KEYUP_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define MSK_KEYUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MSK_MOUSEDOWN_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define MSK_MOUSEDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define MSK_MOUSEDOWN_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define MSK_MOUSEDOWN_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MSK_MOUSEMOVE_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define MSK_MOUSEMOVE_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define MSK_MOUSEMOVE_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define MSK_MOUSEMOVE_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MSK_MOUSEUP_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define MSK_MOUSEUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define MSK_MOUSEUP_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define MSK_MOUSEUP_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MSK_USERERROR_ERRORCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define MSK_USERERROR_AUTOBEEP(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)

#elif fpOWL


// AwareMask event macros
#define MSK_ADVANCE_DIRECTION(event) VBX_EVENTARGNUM(event,int,0)
#define MSK_ADVANCE_AUTOADVANCE(event) VBX_EVENTARGNUM(event,int,1)
#define MSK_BUTTONHIT_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define MSK_BUTTONHIT_NEWINDEX(event) VBX_EVENTARGNUM(event,int,1)
#define MSK_CHANGEMODE_EDITMODE(event) VBX_EVENTARGNUM(event,int,0)
#define MSK_CLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define MSK_DBLCLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define MSK_INVALIDDATA_NEXTWND(event) VBX_EVENTARGNUM(event,int,0)
#define MSK_KEYDOWN_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define MSK_KEYDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define MSK_KEYPRESS_KEYASCII(event) VBX_EVENTARGNUM(event,int,0)
#define MSK_KEYUP_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define MSK_KEYUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define MSK_MOUSEDOWN_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define MSK_MOUSEDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define MSK_MOUSEDOWN_X(event) VBX_EVENTARGNUM(event,float,2)
#define MSK_MOUSEDOWN_Y(event) VBX_EVENTARGNUM(event,float,3)
#define MSK_MOUSEMOVE_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define MSK_MOUSEMOVE_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define MSK_MOUSEMOVE_X(event) VBX_EVENTARGNUM(event,float,2)
#define MSK_MOUSEMOVE_Y(event) VBX_EVENTARGNUM(event,float,3)
#define MSK_MOUSEUP_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define MSK_MOUSEUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define MSK_MOUSEUP_X(event) VBX_EVENTARGNUM(event,float,2)
#define MSK_MOUSEUP_Y(event) VBX_EVENTARGNUM(event,float,3)
#define MSK_USERERROR_ERRORCODE(event) VBX_EVENTARGNUM(event,int,0)
#define MSK_USERERROR_AUTOBEEP(event) VBX_EVENTARGNUM(event,int,1)

#endif


// AwareMask property values
#define MSK_ACTION_COPY 0
#define MSK_ACTION_CUT 1
#define MSK_ACTION_PASTE 2
#define MSK_ACTION_CLEAR 3
#define MSK_ACTION_UNDO 4
#define MSK_ACTION_SET_NULL 5
#define MSK_ALIGNTEXTH_LEFT 0
#define MSK_ALIGNTEXTH_CENTER 1
#define MSK_ALIGNTEXTH_RIGHT 2
#define MSK_ALIGNTEXTV_TOP 0
#define MSK_ALIGNTEXTV_CENTER 1
#define MSK_ALIGNTEXTV_BOTTOM 2
#define MSK_BORDERSTYLE_NO_BORDER 0
#define MSK_BORDERSTYLE_SINGLE_LINE 1
#define MSK_BORDERSTYLE_ROUNDED 2
#define MSK_BORDERSTYLE_DASH 3
#define MSK_BORDERSTYLE_DOT 4
#define MSK_BORDERSTYLE_DASH_DOT 5
#define MSK_BORDERSTYLE_DASH_DOT_DOT 6
#define MSK_BUTTONSTYLE_NONE 0
#define MSK_BUTTONSTYLE_SPIN 1
#define MSK_BUTTONSTYLE_POP_UP 2
#define MSK_BUTTONSTYLE_DROP_DOWN 3
#define MSK_BUTTONSTYLE_SLIDE 4
#define MSK_CARETINSERT_SINGLE 0
#define MSK_CARETINSERT_DOUBLE 1
#define MSK_CARETINSERT_BLOCK 2
#define MSK_CARETINSERT_UNDERLINE 3
#define MSK_CARETINSERT_TRIANGLE 4
#define MSK_CARETOVERWRITE_SINGLE 0
#define MSK_CARETOVERWRITE_DOUBLE 1
#define MSK_CARETOVERWRITE_BLOCK 2
#define MSK_CARETOVERWRITE_UNDERLINE 3
#define MSK_CARETOVERWRITE_TRIANGLE 4
#define MSK_CLIPMODE_CLIP_DATA_AND_LITERALS 0
#define MSK_CLIPMODE_CLIP_DATA_W_O_LITERALS 1
#define MSK_CONTROLTYPE_NORMAL 0
#define MSK_CONTROLTYPE_READ_ONLY 1
#define MSK_CONTROLTYPE_STATIC 2
#define MSK_DATAFORMAT_SAVE_DATA_AND_LITERALS 0
#define MSK_DATAFORMAT_SAVE_DATA_W_O_LITERALS 1
#define MSK_INVALIDOPTION_SHOW_DATA 0
#define MSK_INVALIDOPTION_HIDE_DATA 1
#define MSK_INVALIDOPTION_CLEAR_DATA 2
#define MSK_MOUSEPOINTER_DEFAULT 0
#define MSK_MOUSEPOINTER_ARROW 1
#define MSK_MOUSEPOINTER_CROSS 2
#define MSK_MOUSEPOINTER_I_BEAM 3
#define MSK_MOUSEPOINTER_ICON 4
#define MSK_MOUSEPOINTER_SIZE 5
#define MSK_MOUSEPOINTER_SIZE_NE_SW 6
#define MSK_MOUSEPOINTER_SIZE_N_S 7
#define MSK_MOUSEPOINTER_SIZE_NW_SE 8
#define MSK_MOUSEPOINTER_SIZE_W_E 9
#define MSK_MOUSEPOINTER_UP_ARROW 10
#define MSK_MOUSEPOINTER_HOURGLASS 11
#define MSK_MOUSEPOINTER_NO_DROP 12
#define MSK_NOSPECIALKEYS_ALL_KEYS_ENABLED 0
#define MSK_NOSPECIALKEYS_AWARE_KEYS_DISABLED 1
#define MSK_NOSPECIALKEYS_EDIT_KEYS_DISABLED 2
#define MSK_NOSPECIALKEYS_ALL_KEYS_DISABLED 3
#define MSK_ONFOCUSALIGNH_DEFAULT 0
#define MSK_ONFOCUSALIGNH_LEFT 1
#define MSK_ONFOCUSALIGNH_CENTER 2
#define MSK_ONFOCUSALIGNH_RIGHT 3
#define MSK_ONFOCUSALIGNV_DEFAULT 0
#define MSK_ONFOCUSALIGNV_TOP 1
#define MSK_ONFOCUSALIGNV_CENTER 2
#define MSK_ONFOCUSALIGNV_BOTTOM 3
#define MSK_ONFOCUSPOSITION_END 0
#define MSK_ONFOCUSPOSITION_BEGINNING 1
#define MSK_ONFOCUSPOSITION_PREVIOUS 2
#define MSK_ONFOCUSPOSITION_CARET 3
#define MSK_THREEDINSIDESTYLE_NONE 0
#define MSK_THREEDINSIDESTYLE_LOWERED 1
#define MSK_THREEDINSIDESTYLE_RAISED 2
#define MSK_THREEDOUTSIDESTYLE_NONE 0
#define MSK_THREEDOUTSIDESTYLE_LOWERED 1
#define MSK_THREEDOUTSIDESTYLE_RAISED 2
#define MSK_THREEDTEXT_NONE 0
#define MSK_THREEDTEXT_ETCHED 1
#define MSK_THREEDTEXT_EMBOSSED 2
#define MSK_THREEDTEXT_ETCHED_W_SHADING 3
#define MSK_THREEDTEXT_EMBOSSED_W_SHADING 4
#define MSK_USERENTRY_FORMATTED 0
#define MSK_USERENTRY_FREE_FORMAT 1

// Class representing AwareDouble10 control in AWARE.VBX file

class CAwareDouble : public CVBControl
{
  public:

#ifdef fpMFC

    BOOL Create(DWORD dwStyle, const RECT& rect,
                CWnd* pParentWnd, UINT nID,
                CFile* pFile = NULL, BOOL bAutoDelete = FALSE)
    {
      return CVBControl::Create(
               "AWARE.VBX;AwareDouble10;",
               dwStyle, rect,
               pParentWnd, nID,
               pFile, bAutoDelete
             );
    }

#elif fpOWL

    CAwareDouble(TWindow* parent, int id,
        const char far* title,
        int x, int y, int w, int h,
        long initLen = 0, void far* initData = 0,
        TModule* module = 0)
    : CVBControl(parent, id, "AWARE.VBX", "AwareDouble10",
          title, x, y, w, h, initLen, initData, module) {};

    CAwareDouble(TWindow* parent, int resourceId, TModule* module = 0)
    : CVBControl(parent, resourceId, module) {};

#endif

    CStringProperty About() {return CStringProperty(this,107);}
    CEnumProperty AlignTextH() {return CEnumProperty(this,60);}
    CEnumProperty AlignTextV() {return CEnumProperty(this,61);}
    CBoolProperty AllowNull() {return CBoolProperty(this,62);}
    CBoolProperty AutoAdvance() {return CBoolProperty(this,64);}
    CBoolProperty AutoBeep() {return CBoolProperty(this,65);}
    CColorProperty BackColor() {return CColorProperty(this,2);}
    CColorProperty BorderColor() {return CColorProperty(this,37);}
    CColorProperty BorderGrayAreaColor() {return CColorProperty(this,108);}
    CEnumProperty BorderStyle() {return CEnumProperty(this,36);}
    CShortProperty BorderWidth() {return CShortProperty(this,38);}
    CBoolProperty ButtonDefaultAction() {return CBoolProperty(this,50);}
    CBoolProperty ButtonDisable() {return CBoolProperty(this,41);}
    CBoolProperty ButtonHide() {return CBoolProperty(this,42);}
    CShortProperty ButtonIncrement() {return CShortProperty(this,43);}
    CShortProperty ButtonIndex() {return CShortProperty(this,44);}
    CShortProperty ButtonMax() {return CShortProperty(this,46);}
    CShortProperty ButtonMin() {return CShortProperty(this,45);}
    CEnumProperty ButtonStyle() {return CEnumProperty(this,47);}
    CLongProperty ButtonWidth() {return CLongProperty(this,48);}
    CBoolProperty ButtonWrap() {return CBoolProperty(this,49);}
    CEnumProperty CaretInsert() {return CEnumProperty(this,66);}
    CEnumProperty CaretOverWrite() {return CEnumProperty(this,67);}
    CLongProperty CharPositionLeft() {return CLongProperty(this,68);}
    CLongProperty CharPositionRight() {return CLongProperty(this,69);}
    CEnumProperty ControlType() {return CEnumProperty(this,90);}
    CLongProperty CurrentPosition() {return CLongProperty(this,70);}
    CShortProperty DecimalPlaces() {return CShortProperty(this,92);}
    CStringProperty DecimalPoint() {return CStringProperty(this,93);}
    CColorProperty DropShadowColor() {return CColorProperty(this,53);}
    CShortProperty DropShadowWidth() {return CShortProperty(this,54);}
    CBoolProperty Enabled() {return CBoolProperty(this,19);}
    CBoolProperty FixedPoint() {return CBoolProperty(this,94);}
    CBoolProperty FontBold() {return CBoolProperty(this,10);}
    CBoolProperty FontItalic() {return CBoolProperty(this,11);}
    CStringProperty FontName() {return CStringProperty(this,9);}
    CFloatProperty FontSize() {return CFloatProperty(this,14);}
    CBoolProperty FontStrikethru() {return CBoolProperty(this,12);}
    CBoolProperty FontUnderline() {return CBoolProperty(this,13);}
    CColorProperty ForeColor() {return CColorProperty(this,3);}
    CLongProperty Height() {return CLongProperty(this,7);}
    CBoolProperty HideSelection() {return CBoolProperty(this,72);}
    CFloatProperty IncDec() {return CFloatProperty(this,105);}
    CFloatProperty IncInt() {return CFloatProperty(this,104);}
    CShortProperty Index() {return CShortProperty(this,1);}
    CColorProperty InvalidColor() {return CColorProperty(this,74);}
    CEnumProperty InvalidOption() {return CEnumProperty(this,75);}
    CBoolProperty IsNull() {return CBoolProperty(this,76);}
    CBoolProperty IsValid() {return CBoolProperty(this,77);}
    CEnumProperty LeadZero() {return CEnumProperty(this,95);}
    CLongProperty Left() {return CLongProperty(this,4);}
    CShortProperty MarginBottom() {return CShortProperty(this,81);}
    CShortProperty MarginLeft() {return CShortProperty(this,78);}
    CShortProperty MarginRight() {return CShortProperty(this,80);}
    CShortProperty MarginTop() {return CShortProperty(this,79);}
    CStringProperty MaxValue() {return CStringProperty(this,96);}
    CStringProperty MinValue() {return CStringProperty(this,97);}
    CEnumProperty MousePointer() {return CEnumProperty(this,8);}
    CStringProperty Name() {return CStringProperty(this,0);}
    CEnumProperty NegFormat() {return CEnumProperty(this,98);}
    CBoolProperty NegToggle() {return CBoolProperty(this,99);}
    CEnumProperty NoSpecialKeys() {return CEnumProperty(this,63);}
    CColorProperty NullColor() {return CColorProperty(this,82);}
    CEnumProperty OnFocusAlignH() {return CEnumProperty(this,83);}
    CEnumProperty OnFocusAlignV() {return CEnumProperty(this,84);}
    CBoolProperty OnFocusInvert3D() {return CBoolProperty(this,51);}
    CBoolProperty OnFocusNoSelect() {return CBoolProperty(this,85);}
    CEnumProperty OnFocusPosition() {return CEnumProperty(this,86);}
    CBoolProperty OnFocusShadow() {return CBoolProperty(this,52);}
    CShortProperty Parent() {return CShortProperty(this,20);}
    CBoolProperty Redraw() {return CBoolProperty(this,106);}
    CLongProperty SelLength() {return CLongProperty(this,87);}
    CLongProperty SelStart() {return CLongProperty(this,88);}
    CStringProperty SelText() {return CStringProperty(this,89);}
    CStringProperty Separator() {return CStringProperty(this,100);}
    CShortProperty TabIndex() {return CShortProperty(this,15);}
    CShortProperty TabStop() {return CShortProperty(this,16);}
    CStringProperty Tag() {return CStringProperty(this,21);}
    CStringProperty Text() {return CStringProperty(this,91);}
    CShortProperty ThreeDFrameWidth() {return CShortProperty(this,35);}
    CColorProperty ThreeDInsideHighlightColor() {return CColorProperty(this,28);}
    CColorProperty ThreeDInsideShadowColor() {return CColorProperty(this,29);}
    CEnumProperty ThreeDInsideStyle() {return CEnumProperty(this,27);}
    CShortProperty ThreeDInsideWidth() {return CShortProperty(this,30);}
    CColorProperty ThreeDOutsideHighlightColor() {return CColorProperty(this,32);}
    CColorProperty ThreeDOutsideShadowColor() {return CColorProperty(this,33);}
    CEnumProperty ThreeDOutsideStyle() {return CEnumProperty(this,31);}
    CShortProperty ThreeDOutsideWidth() {return CShortProperty(this,34);}
    CEnumProperty ThreeDText() {return CEnumProperty(this,55);}
    CColorProperty ThreeDTextHighlightColor() {return CColorProperty(this,56);}
    CShortProperty ThreeDTextOffset() {return CShortProperty(this,58);}
    CColorProperty ThreeDTextShadowColor() {return CColorProperty(this,57);}
    CLongProperty Top() {return CLongProperty(this,5);}
    CStringProperty UnFmtText() {return CStringProperty(this,101);}
    CBoolProperty UseSeparator() {return CBoolProperty(this,102);}
    CEnumProperty UserEntry() {return CEnumProperty(this,71);}
    CStringProperty Value() {return CStringProperty(this,103);}
    CBoolProperty Visible() {return CBoolProperty(this,22);}
    CLongProperty Width() {return CLongProperty(this,6);}
    CShortProperty hWnd() {return CShortProperty(this,73);}

};

#ifdef fpMFC

inline void AFXAPI
DDX_VBControl(CDataExchange* pDX, int nIDC, CAwareDouble*& rpAwareDouble)
{
  CVBControl* pControl = (CVBControl*)rpAwareDouble;
  DDX_VBControl(pDX, nIDC, pControl);
  rpAwareDouble = (CAwareDouble*)pControl;
}
#endif

// AwareDouble event indices
#define EVENT_DBL_ADVANCE 0
#define EVENT_DBL_BUTTONHIT 1
#define EVENT_DBL_CHANGE 2
#define EVENT_DBL_CHANGEMODE 3
#define EVENT_DBL_CLICK 4
#define EVENT_DBL_DBLCLICK 5
#define EVENT_DBL_GOTFOUCS 8
#define EVENT_DBL_INVALIDDATA 9
#define EVENT_DBL_KEYDOWN 10
#define EVENT_DBL_KEYPRESS 11
#define EVENT_DBL_KEYUP 12
#define EVENT_DBL_LOSTFOCUS 13
#define EVENT_DBL_MOUSEDOWN 14
#define EVENT_DBL_MOUSEMOVE 15
#define EVENT_DBL_MOUSEUP 16
#define EVENT_DBL_USERERROR 17

// AwareDouble property indices
#define PROP_DBL_ABOUT 107
#define PROP_DBL_ACTION 59
#define PROP_DBL_ALIGNTEXTH 60
#define PROP_DBL_ALIGNTEXTV 61
#define PROP_DBL_ALLOWNULL 62
#define PROP_DBL_AUTOADVANCE 64
#define PROP_DBL_AUTOBEEP 65
#define PROP_DBL_BACKCOLOR 2
#define PROP_DBL_BORDERCOLOR 37
#define PROP_DBL_BORDERGRAYAREACOLOR 108
#define PROP_DBL_BORDERSTYLE 36
#define PROP_DBL_BORDERWIDTH 38
#define PROP_DBL_BUTTONDEFAULTACTION 50
#define PROP_DBL_BUTTONDISABLE 41
#define PROP_DBL_BUTTONHIDE 42
#define PROP_DBL_BUTTONINCREMENT 43
#define PROP_DBL_BUTTONINDEX 44
#define PROP_DBL_BUTTONMAX 46
#define PROP_DBL_BUTTONMIN 45
#define PROP_DBL_BUTTONSTYLE 47
#define PROP_DBL_BUTTONWIDTH 48
#define PROP_DBL_BUTTONWRAP 49
#define PROP_DBL_CARETINSERT 66
#define PROP_DBL_CARETOVERWRITE 67
#define PROP_DBL_CHARPOSITIONLEFT 68
#define PROP_DBL_CHARPOSITIONRIGHT 69
#define PROP_DBL_CONTROLTYPE 90
#define PROP_DBL_CURRENTPOSITION 70
#define PROP_DBL_DECIMALPLACES 92
#define PROP_DBL_DECIMALPOINT 93
#define PROP_DBL_DROPSHADOWCOLOR 53
#define PROP_DBL_DROPSHADOWWIDTH 54
#define PROP_DBL_ENABLED 19
#define PROP_DBL_FIXEDPOINT 94
#define PROP_DBL_FONTBOLD 10
#define PROP_DBL_FONTITALIC 11
#define PROP_DBL_FONTNAME 9
#define PROP_DBL_FONTSIZE 14
#define PROP_DBL_FONTSTRIKETHRU 12
#define PROP_DBL_FONTUNDERLINE 13
#define PROP_DBL_FORECOLOR 3
#define PROP_DBL_HEIGHT 7
#define PROP_DBL_HIDESELECTION 72
#define PROP_DBL_INCDEC 105
#define PROP_DBL_INCINT 104
#define PROP_DBL_INDEX 1
#define PROP_DBL_INVALIDCOLOR 74
#define PROP_DBL_INVALIDOPTION 75
#define PROP_DBL_ISNULL 76
#define PROP_DBL_ISVALID 77
#define PROP_DBL_LEADZERO 95
#define PROP_DBL_LEFT 4
#define PROP_DBL_MARGINBOTTOM 81
#define PROP_DBL_MARGINLEFT 78
#define PROP_DBL_MARGINRIGHT 80
#define PROP_DBL_MARGINTOP 79
#define PROP_DBL_MAXVALUE 96
#define PROP_DBL_MINVALUE 97
#define PROP_DBL_MOUSEPOINTER 8
#define PROP_DBL_NAME 0
#define PROP_DBL_NEGFORMAT 98
#define PROP_DBL_NEGTOGGLE 99
#define PROP_DBL_NOSPECIALKEYS 63
#define PROP_DBL_NULLCOLOR 82
#define PROP_DBL_ONFOCUSALIGNH 83
#define PROP_DBL_ONFOCUSALIGNV 84
#define PROP_DBL_ONFOCUSINVERT3D 51
#define PROP_DBL_ONFOCUSNOSELECT 85
#define PROP_DBL_ONFOCUSPOSITION 86
#define PROP_DBL_ONFOCUSSHADOW 52
#define PROP_DBL_PARENT 20
#define PROP_DBL_REDRAW 106
#define PROP_DBL_SELLENGTH 87
#define PROP_DBL_SELSTART 88
#define PROP_DBL_SELTEXT 89
#define PROP_DBL_SEPARATOR 100
#define PROP_DBL_TABINDEX 15
#define PROP_DBL_TABSTOP 16
#define PROP_DBL_TAG 21
#define PROP_DBL_TEXT 91
#define PROP_DBL_THREEDFRAMEWIDTH 35
#define PROP_DBL_THREEDINSIDEHIGHLIGHTCOLOR 28
#define PROP_DBL_THREEDINSIDESHADOWCOLOR 29
#define PROP_DBL_THREEDINSIDESTYLE 27
#define PROP_DBL_THREEDINSIDEWIDTH 30
#define PROP_DBL_THREEDOUTSIDEHIGHLIGHTCOLOR 32
#define PROP_DBL_THREEDOUTSIDESHADOWCOLOR 33
#define PROP_DBL_THREEDOUTSIDESTYLE 31
#define PROP_DBL_THREEDOUTSIDEWIDTH 34
#define PROP_DBL_THREEDTEXT 55
#define PROP_DBL_THREEDTEXTHIGHLIGHTCOLOR 56
#define PROP_DBL_THREEDTEXTOFFSET 58
#define PROP_DBL_THREEDTEXTSHADOWCOLOR 57
#define PROP_DBL_TOP 5
#define PROP_DBL_UNFMTTEXT 101
#define PROP_DBL_USESEPARATOR 102
#define PROP_DBL_USERENTRY 71
#define PROP_DBL_VALUE 103
#define PROP_DBL_VISIBLE 22
#define PROP_DBL_WIDTH 6
#define PROP_DBL_HWND 73

#ifdef fpMFC


// AwareDouble event macros
#define DBL_ADVANCE_DIRECTION(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define DBL_ADVANCE_AUTOADVANCE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DBL_BUTTONHIT_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define DBL_BUTTONHIT_NEWINDEX(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DBL_CHANGEMODE_EDITMODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DBL_CLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DBL_DBLCLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DBL_INVALIDDATA_NEXTWND(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DBL_KEYDOWN_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,1)
#define DBL_KEYDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define DBL_KEYPRESS_KEYASCII(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define DBL_KEYUP_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define DBL_KEYUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DBL_MOUSEDOWN_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define DBL_MOUSEDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define DBL_MOUSEDOWN_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define DBL_MOUSEDOWN_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DBL_MOUSEMOVE_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define DBL_MOUSEMOVE_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define DBL_MOUSEMOVE_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define DBL_MOUSEMOVE_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DBL_MOUSEUP_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define DBL_MOUSEUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define DBL_MOUSEUP_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define DBL_MOUSEUP_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DBL_USERERROR_ERRORCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define DBL_USERERROR_AUTOBEEP(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)

#elif fpOWL


// AwareDouble event macros
#define DBL_ADVANCE_DIRECTION(event) VBX_EVENTARGNUM(event,int,0)
#define DBL_ADVANCE_AUTOADVANCE(event) VBX_EVENTARGNUM(event,int,1)
#define DBL_BUTTONHIT_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define DBL_BUTTONHIT_NEWINDEX(event) VBX_EVENTARGNUM(event,int,1)
#define DBL_CHANGEMODE_EDITMODE(event) VBX_EVENTARGNUM(event,int,0)
#define DBL_CLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define DBL_DBLCLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define DBL_INVALIDDATA_NEXTWND(event) VBX_EVENTARGNUM(event,int,0)
#define DBL_KEYDOWN_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define DBL_KEYDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define DBL_KEYPRESS_KEYASCII(event) VBX_EVENTARGNUM(event,int,0)
#define DBL_KEYUP_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define DBL_KEYUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define DBL_MOUSEDOWN_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define DBL_MOUSEDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define DBL_MOUSEDOWN_X(event) VBX_EVENTARGNUM(event,float,2)
#define DBL_MOUSEDOWN_Y(event) VBX_EVENTARGNUM(event,float,3)
#define DBL_MOUSEMOVE_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define DBL_MOUSEMOVE_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define DBL_MOUSEMOVE_X(event) VBX_EVENTARGNUM(event,float,2)
#define DBL_MOUSEMOVE_Y(event) VBX_EVENTARGNUM(event,float,3)
#define DBL_MOUSEUP_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define DBL_MOUSEUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define DBL_MOUSEUP_X(event) VBX_EVENTARGNUM(event,float,2)
#define DBL_MOUSEUP_Y(event) VBX_EVENTARGNUM(event,float,3)
#define DBL_USERERROR_ERRORCODE(event) VBX_EVENTARGNUM(event,int,0)
#define DBL_USERERROR_AUTOBEEP(event) VBX_EVENTARGNUM(event,int,1)

#endif


// AwareDouble property values
#define DBL_ACTION_COPY 0
#define DBL_ACTION_CUT 1
#define DBL_ACTION_PASTE 2
#define DBL_ACTION_CLEAR 3
#define DBL_ACTION_UNDO 4
#define DBL_ACTION_SET_NULL 5
#define DBL_ALIGNTEXTH_LEFT 0
#define DBL_ALIGNTEXTH_CENTER 1
#define DBL_ALIGNTEXTH_RIGHT 2
#define DBL_ALIGNTEXTV_TOP 0
#define DBL_ALIGNTEXTV_CENTER 1
#define DBL_ALIGNTEXTV_BOTTOM 2
#define DBL_BORDERSTYLE_NO_BORDER 0
#define DBL_BORDERSTYLE_SINGLE_LINE 1
#define DBL_BORDERSTYLE_ROUNDED 2
#define DBL_BORDERSTYLE_DASH 3
#define DBL_BORDERSTYLE_DOT 4
#define DBL_BORDERSTYLE_DASH_DOT 5
#define DBL_BORDERSTYLE_DASH_DOT_DOT 6
#define DBL_BUTTONSTYLE_NONE 0
#define DBL_BUTTONSTYLE_SPIN 1
#define DBL_BUTTONSTYLE_POP_UP 2
#define DBL_BUTTONSTYLE_DROP_DOWN 3
#define DBL_BUTTONSTYLE_SLIDE 4
#define DBL_CARETINSERT_SINGLE 0
#define DBL_CARETINSERT_DOUBLE 1
#define DBL_CARETINSERT_BLOCK 2
#define DBL_CARETINSERT_UNDERLINE 3
#define DBL_CARETINSERT_TRIANGLE 4
#define DBL_CARETOVERWRITE_SINGLE 0
#define DBL_CARETOVERWRITE_DOUBLE 1
#define DBL_CARETOVERWRITE_BLOCK 2
#define DBL_CARETOVERWRITE_UNDERLINE 3
#define DBL_CARETOVERWRITE_TRIANGLE 4
#define DBL_CONTROLTYPE_NORMAL 0
#define DBL_CONTROLTYPE_READ_ONLY 1
#define DBL_CONTROLTYPE_STATIC 2
#define DBL_INVALIDOPTION_SHOW_DATA 0
#define DBL_INVALIDOPTION_HIDE_DATA 1
#define DBL_INVALIDOPTION_CLEAR_DATA 2
#define DBL_LEADZERO_INTL 0
#define DBL_LEADZERO_NO_LEADING_ZERO 1
#define DBL_LEADZERO_LEADING_ZERO 2
#define DBL_MOUSEPOINTER_DEFAULT 0
#define DBL_MOUSEPOINTER_ARROW 1
#define DBL_MOUSEPOINTER_CROSS 2
#define DBL_MOUSEPOINTER_I_BEAM 3
#define DBL_MOUSEPOINTER_ICON 4
#define DBL_MOUSEPOINTER_SIZE 5
#define DBL_MOUSEPOINTER_SIZE_NE_SW 6
#define DBL_MOUSEPOINTER_SIZE_N_S 7
#define DBL_MOUSEPOINTER_SIZE_NW_SE 8
#define DBL_MOUSEPOINTER_SIZE_W_E 9
#define DBL_MOUSEPOINTER_UP_ARROW 10
#define DBL_MOUSEPOINTER_HOURGLASS 11
#define DBL_MOUSEPOINTER_NO_DROP 12
#define DBL_NEGFORMAT_LFT_1_RGT 0
#define DBL_NEGFORMAT_NEG_1 1
#define DBL_NEGFORMAT_1_NEG 2
#define DBL_NOSPECIALKEYS_ALL_KEYS_ENABLED 0
#define DBL_NOSPECIALKEYS_AWARE_KEYS_DISABLED 1
#define DBL_NOSPECIALKEYS_EDIT_KEYS_DISABLED 2
#define DBL_NOSPECIALKEYS_ALL_KEYS_DISABLED 3
#define DBL_ONFOCUSALIGNH_DEFAULT 0
#define DBL_ONFOCUSALIGNH_LEFT 1
#define DBL_ONFOCUSALIGNH_CENTER 2
#define DBL_ONFOCUSALIGNH_RIGHT 3
#define DBL_ONFOCUSALIGNV_DEFAULT 0
#define DBL_ONFOCUSALIGNV_TOP 1
#define DBL_ONFOCUSALIGNV_CENTER 2
#define DBL_ONFOCUSALIGNV_BOTTOM 3
#define DBL_ONFOCUSPOSITION_END 0
#define DBL_ONFOCUSPOSITION_BEGINNING 1
#define DBL_ONFOCUSPOSITION_PREVIOUS 2
#define DBL_ONFOCUSPOSITION_CARET 3
#define DBL_THREEDINSIDESTYLE_NONE 0
#define DBL_THREEDINSIDESTYLE_LOWERED 1
#define DBL_THREEDINSIDESTYLE_RAISED 2
#define DBL_THREEDOUTSIDESTYLE_NONE 0
#define DBL_THREEDOUTSIDESTYLE_LOWERED 1
#define DBL_THREEDOUTSIDESTYLE_RAISED 2
#define DBL_THREEDTEXT_NONE 0
#define DBL_THREEDTEXT_ETCHED 1
#define DBL_THREEDTEXT_EMBOSSED 2
#define DBL_THREEDTEXT_ETCHED_W_SHADING 3
#define DBL_THREEDTEXT_EMBOSSED_W_SHADING 4
#define DBL_USERENTRY_FORMATTED 0
#define DBL_USERENTRY_FREE_FORMAT 1
#define DBL_USERENTRY_FIXED_RIGHT 2

// Class representing AwareLong10 control in AWARE.VBX file

class CAwareLong : public CVBControl
{
  public:

#ifdef fpMFC

    BOOL Create(DWORD dwStyle, const RECT& rect,
                CWnd* pParentWnd, UINT nID,
                CFile* pFile = NULL, BOOL bAutoDelete = FALSE)
    {
      return CVBControl::Create(
               "AWARE.VBX;AwareLong10;",
               dwStyle, rect,
               pParentWnd, nID,
               pFile, bAutoDelete
             );
    }

#elif fpOWL

    CAwareLong(TWindow* parent, int id,
        const char far* title,
        int x, int y, int w, int h,
        long initLen = 0, void far* initData = 0,
        TModule* module = 0)
    : CVBControl(parent, id, "AWARE.VBX", "AwareLong10",
          title, x, y, w, h, initLen, initData, module) {};

    CAwareLong(TWindow* parent, int resourceId, TModule* module = 0)
    : CVBControl(parent, resourceId, module) {};

#endif

    CStringProperty About() {return CStringProperty(this,102);}
    CEnumProperty AlignTextH() {return CEnumProperty(this,60);}
    CEnumProperty AlignTextV() {return CEnumProperty(this,61);}
    CBoolProperty AllowNull() {return CBoolProperty(this,62);}
    CBoolProperty AutoAdvance() {return CBoolProperty(this,64);}
    CBoolProperty AutoBeep() {return CBoolProperty(this,65);}
    CColorProperty BackColor() {return CColorProperty(this,2);}
    CColorProperty BorderColor() {return CColorProperty(this,37);}
    CColorProperty BorderGrayAreaColor() {return CColorProperty(this,103);}
    CEnumProperty BorderStyle() {return CEnumProperty(this,36);}
    CShortProperty BorderWidth() {return CShortProperty(this,38);}
    CBoolProperty ButtonDefaultAction() {return CBoolProperty(this,50);}
    CBoolProperty ButtonDisable() {return CBoolProperty(this,41);}
    CBoolProperty ButtonHide() {return CBoolProperty(this,42);}
    CShortProperty ButtonIncrement() {return CShortProperty(this,43);}
    CShortProperty ButtonIndex() {return CShortProperty(this,44);}
    CShortProperty ButtonMax() {return CShortProperty(this,46);}
    CShortProperty ButtonMin() {return CShortProperty(this,45);}
    CEnumProperty ButtonStyle() {return CEnumProperty(this,47);}
    CLongProperty ButtonWidth() {return CLongProperty(this,48);}
    CBoolProperty ButtonWrap() {return CBoolProperty(this,49);}
    CEnumProperty CaretInsert() {return CEnumProperty(this,66);}
    CEnumProperty CaretOverWrite() {return CEnumProperty(this,67);}
    CLongProperty CharPositionLeft() {return CLongProperty(this,68);}
    CLongProperty CharPositionRight() {return CLongProperty(this,69);}
    CEnumProperty ControlType() {return CEnumProperty(this,90);}
    CLongProperty CurrentPosition() {return CLongProperty(this,70);}
    CColorProperty DropShadowColor() {return CColorProperty(this,53);}
    CShortProperty DropShadowWidth() {return CShortProperty(this,54);}
    CBoolProperty Enabled() {return CBoolProperty(this,19);}
    CBoolProperty FontBold() {return CBoolProperty(this,10);}
    CBoolProperty FontItalic() {return CBoolProperty(this,11);}
    CStringProperty FontName() {return CStringProperty(this,9);}
    CFloatProperty FontSize() {return CFloatProperty(this,14);}
    CBoolProperty FontStrikethru() {return CBoolProperty(this,12);}
    CBoolProperty FontUnderline() {return CBoolProperty(this,13);}
    CColorProperty ForeColor() {return CColorProperty(this,3);}
    CLongProperty Height() {return CLongProperty(this,7);}
    CBoolProperty HideSelection() {return CBoolProperty(this,72);}
    CFloatProperty IncInt() {return CFloatProperty(this,100);}
    CShortProperty Index() {return CShortProperty(this,1);}
    CColorProperty InvalidColor() {return CColorProperty(this,74);}
    CEnumProperty InvalidOption() {return CEnumProperty(this,75);}
    CBoolProperty IsNull() {return CBoolProperty(this,76);}
    CBoolProperty IsValid() {return CBoolProperty(this,77);}
    CLongProperty Left() {return CLongProperty(this,4);}
    CShortProperty MarginBottom() {return CShortProperty(this,81);}
    CShortProperty MarginLeft() {return CShortProperty(this,78);}
    CShortProperty MarginRight() {return CShortProperty(this,80);}
    CShortProperty MarginTop() {return CShortProperty(this,79);}
    CStringProperty MaxValue() {return CStringProperty(this,92);}
    CStringProperty MinValue() {return CStringProperty(this,93);}
    CEnumProperty MousePointer() {return CEnumProperty(this,8);}
    CStringProperty Name() {return CStringProperty(this,0);}
    CEnumProperty NegFormat() {return CEnumProperty(this,94);}
    CBoolProperty NegToggle() {return CBoolProperty(this,95);}
    CEnumProperty NoSpecialKeys() {return CEnumProperty(this,63);}
    CColorProperty NullColor() {return CColorProperty(this,82);}
    CEnumProperty OnFocusAlignH() {return CEnumProperty(this,83);}
    CEnumProperty OnFocusAlignV() {return CEnumProperty(this,84);}
    CBoolProperty OnFocusInvert3D() {return CBoolProperty(this,51);}
    CBoolProperty OnFocusNoSelect() {return CBoolProperty(this,85);}
    CEnumProperty OnFocusPosition() {return CEnumProperty(this,86);}
    CBoolProperty OnFocusShadow() {return CBoolProperty(this,52);}
    CShortProperty Parent() {return CShortProperty(this,20);}
    CBoolProperty Redraw() {return CBoolProperty(this,101);}
    CLongProperty SelLength() {return CLongProperty(this,87);}
    CLongProperty SelStart() {return CLongProperty(this,88);}
    CStringProperty SelText() {return CStringProperty(this,89);}
    CStringProperty Separator() {return CStringProperty(this,96);}
    CShortProperty TabIndex() {return CShortProperty(this,15);}
    CShortProperty TabStop() {return CShortProperty(this,16);}
    CStringProperty Tag() {return CStringProperty(this,21);}
    CStringProperty Text() {return CStringProperty(this,91);}
    CShortProperty ThreeDFrameWidth() {return CShortProperty(this,35);}
    CColorProperty ThreeDInsideHighlightColor() {return CColorProperty(this,28);}
    CColorProperty ThreeDInsideShadowColor() {return CColorProperty(this,29);}
    CEnumProperty ThreeDInsideStyle() {return CEnumProperty(this,27);}
    CShortProperty ThreeDInsideWidth() {return CShortProperty(this,30);}
    CColorProperty ThreeDOutsideHighlightColor() {return CColorProperty(this,32);}
    CColorProperty ThreeDOutsideShadowColor() {return CColorProperty(this,33);}
    CEnumProperty ThreeDOutsideStyle() {return CEnumProperty(this,31);}
    CShortProperty ThreeDOutsideWidth() {return CShortProperty(this,34);}
    CEnumProperty ThreeDText() {return CEnumProperty(this,55);}
    CColorProperty ThreeDTextHighlightColor() {return CColorProperty(this,56);}
    CShortProperty ThreeDTextOffset() {return CShortProperty(this,58);}
    CColorProperty ThreeDTextShadowColor() {return CColorProperty(this,57);}
    CLongProperty Top() {return CLongProperty(this,5);}
    CStringProperty UnFmtText() {return CStringProperty(this,97);}
    CBoolProperty UseSeparator() {return CBoolProperty(this,98);}
    CEnumProperty UserEntry() {return CEnumProperty(this,71);}
    CStringProperty Value() {return CStringProperty(this,99);}
    CBoolProperty Visible() {return CBoolProperty(this,22);}
    CLongProperty Width() {return CLongProperty(this,6);}
    CShortProperty hWnd() {return CShortProperty(this,73);}

};

#ifdef fpMFC

inline void AFXAPI
DDX_VBControl(CDataExchange* pDX, int nIDC, CAwareLong*& rpAwareLong)
{
  CVBControl* pControl = (CVBControl*)rpAwareLong;
  DDX_VBControl(pDX, nIDC, pControl);
  rpAwareLong = (CAwareLong*)pControl;
}
#endif

// AwareLong event indices
#define EVENT_LNG_ADVANCE 0
#define EVENT_LNG_BUTTONHIT 1
#define EVENT_LNG_CHANGE 2
#define EVENT_LNG_CHANGEMODE 3
#define EVENT_LNG_CLICK 4
#define EVENT_LNG_DBLCLICK 5
#define EVENT_LNG_GOTFOUCS 8
#define EVENT_LNG_INVALIDDATA 9
#define EVENT_LNG_KEYDOWN 10
#define EVENT_LNG_KEYPRESS 11
#define EVENT_LNG_KEYUP 12
#define EVENT_LNG_LOSTFOCUS 13
#define EVENT_LNG_MOUSEDOWN 14
#define EVENT_LNG_MOUSEMOVE 15
#define EVENT_LNG_MOUSEUP 16
#define EVENT_LNG_USERERROR 17

// AwareLong property indices
#define PROP_LNG_ABOUT 102
#define PROP_LNG_ACTION 59
#define PROP_LNG_ALIGNTEXTH 60
#define PROP_LNG_ALIGNTEXTV 61
#define PROP_LNG_ALLOWNULL 62
#define PROP_LNG_AUTOADVANCE 64
#define PROP_LNG_AUTOBEEP 65
#define PROP_LNG_BACKCOLOR 2
#define PROP_LNG_BORDERCOLOR 37
#define PROP_LNG_BORDERGRAYAREACOLOR 103
#define PROP_LNG_BORDERSTYLE 36
#define PROP_LNG_BORDERWIDTH 38
#define PROP_LNG_BUTTONDEFAULTACTION 50
#define PROP_LNG_BUTTONDISABLE 41
#define PROP_LNG_BUTTONHIDE 42
#define PROP_LNG_BUTTONINCREMENT 43
#define PROP_LNG_BUTTONINDEX 44
#define PROP_LNG_BUTTONMAX 46
#define PROP_LNG_BUTTONMIN 45
#define PROP_LNG_BUTTONSTYLE 47
#define PROP_LNG_BUTTONWIDTH 48
#define PROP_LNG_BUTTONWRAP 49
#define PROP_LNG_CARETINSERT 66
#define PROP_LNG_CARETOVERWRITE 67
#define PROP_LNG_CHARPOSITIONLEFT 68
#define PROP_LNG_CHARPOSITIONRIGHT 69
#define PROP_LNG_CONTROLTYPE 90
#define PROP_LNG_CURRENTPOSITION 70
#define PROP_LNG_DROPSHADOWCOLOR 53
#define PROP_LNG_DROPSHADOWWIDTH 54
#define PROP_LNG_ENABLED 19
#define PROP_LNG_FONTBOLD 10
#define PROP_LNG_FONTITALIC 11
#define PROP_LNG_FONTNAME 9
#define PROP_LNG_FONTSIZE 14
#define PROP_LNG_FONTSTRIKETHRU 12
#define PROP_LNG_FONTUNDERLINE 13
#define PROP_LNG_FORECOLOR 3
#define PROP_LNG_HEIGHT 7
#define PROP_LNG_HIDESELECTION 72
#define PROP_LNG_INCINT 100
#define PROP_LNG_INDEX 1
#define PROP_LNG_INVALIDCOLOR 74
#define PROP_LNG_INVALIDOPTION 75
#define PROP_LNG_ISNULL 76
#define PROP_LNG_ISVALID 77
#define PROP_LNG_LEFT 4
#define PROP_LNG_MARGINBOTTOM 81
#define PROP_LNG_MARGINLEFT 78
#define PROP_LNG_MARGINRIGHT 80
#define PROP_LNG_MARGINTOP 79
#define PROP_LNG_MAXVALUE 92
#define PROP_LNG_MINVALUE 93
#define PROP_LNG_MOUSEPOINTER 8
#define PROP_LNG_NAME 0
#define PROP_LNG_NEGFORMAT 94
#define PROP_LNG_NEGTOGGLE 95
#define PROP_LNG_NOSPECIALKEYS 63
#define PROP_LNG_NULLCOLOR 82
#define PROP_LNG_ONFOCUSALIGNH 83
#define PROP_LNG_ONFOCUSALIGNV 84
#define PROP_LNG_ONFOCUSINVERT3D 51
#define PROP_LNG_ONFOCUSNOSELECT 85
#define PROP_LNG_ONFOCUSPOSITION 86
#define PROP_LNG_ONFOCUSSHADOW 52
#define PROP_LNG_PARENT 20
#define PROP_LNG_REDRAW 101
#define PROP_LNG_SELLENGTH 87
#define PROP_LNG_SELSTART 88
#define PROP_LNG_SELTEXT 89
#define PROP_LNG_SEPARATOR 96
#define PROP_LNG_TABINDEX 15
#define PROP_LNG_TABSTOP 16
#define PROP_LNG_TAG 21
#define PROP_LNG_TEXT 91
#define PROP_LNG_THREEDFRAMEWIDTH 35
#define PROP_LNG_THREEDINSIDEHIGHLIGHTCOLOR 28
#define PROP_LNG_THREEDINSIDESHADOWCOLOR 29
#define PROP_LNG_THREEDINSIDESTYLE 27
#define PROP_LNG_THREEDINSIDEWIDTH 30
#define PROP_LNG_THREEDOUTSIDEHIGHLIGHTCOLOR 32
#define PROP_LNG_THREEDOUTSIDESHADOWCOLOR 33
#define PROP_LNG_THREEDOUTSIDESTYLE 31
#define PROP_LNG_THREEDOUTSIDEWIDTH 34
#define PROP_LNG_THREEDTEXT 55
#define PROP_LNG_THREEDTEXTHIGHLIGHTCOLOR 56
#define PROP_LNG_THREEDTEXTOFFSET 58
#define PROP_LNG_THREEDTEXTSHADOWCOLOR 57
#define PROP_LNG_TOP 5
#define PROP_LNG_UNFMTTEXT 97
#define PROP_LNG_USESEPARATOR 98
#define PROP_LNG_USERENTRY 71
#define PROP_LNG_VALUE 99
#define PROP_LNG_VISIBLE 22
#define PROP_LNG_WIDTH 6
#define PROP_LNG_HWND 73

#ifdef fpMFC


// AwareLong event macros
#define LNG_ADVANCE_DIRECTION(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define LNG_ADVANCE_AUTOADVANCE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define LNG_BUTTONHIT_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define LNG_BUTTONHIT_NEWINDEX(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define LNG_CHANGEMODE_EDITMODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define LNG_CLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define LNG_DBLCLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define LNG_INVALIDDATA_NEXTWND(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define LNG_KEYDOWN_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,1)
#define LNG_KEYDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define LNG_KEYPRESS_KEYASCII(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define LNG_KEYUP_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define LNG_KEYUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define LNG_MOUSEDOWN_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define LNG_MOUSEDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define LNG_MOUSEDOWN_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define LNG_MOUSEDOWN_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define LNG_MOUSEMOVE_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define LNG_MOUSEMOVE_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define LNG_MOUSEMOVE_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define LNG_MOUSEMOVE_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define LNG_MOUSEUP_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define LNG_MOUSEUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define LNG_MOUSEUP_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define LNG_MOUSEUP_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define LNG_USERERROR_ERRORCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define LNG_USERERROR_AUTOBEEP(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)

#elif fpOWL


// AwareLong event macros
#define LNG_ADVANCE_DIRECTION(event) VBX_EVENTARGNUM(event,int,0)
#define LNG_ADVANCE_AUTOADVANCE(event) VBX_EVENTARGNUM(event,int,1)
#define LNG_BUTTONHIT_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define LNG_BUTTONHIT_NEWINDEX(event) VBX_EVENTARGNUM(event,int,1)
#define LNG_CHANGEMODE_EDITMODE(event) VBX_EVENTARGNUM(event,int,0)
#define LNG_CLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define LNG_DBLCLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define LNG_INVALIDDATA_NEXTWND(event) VBX_EVENTARGNUM(event,int,0)
#define LNG_KEYDOWN_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define LNG_KEYDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define LNG_KEYPRESS_KEYASCII(event) VBX_EVENTARGNUM(event,int,0)
#define LNG_KEYUP_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define LNG_KEYUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define LNG_MOUSEDOWN_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define LNG_MOUSEDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define LNG_MOUSEDOWN_X(event) VBX_EVENTARGNUM(event,float,2)
#define LNG_MOUSEDOWN_Y(event) VBX_EVENTARGNUM(event,float,3)
#define LNG_MOUSEMOVE_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define LNG_MOUSEMOVE_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define LNG_MOUSEMOVE_X(event) VBX_EVENTARGNUM(event,float,2)
#define LNG_MOUSEMOVE_Y(event) VBX_EVENTARGNUM(event,float,3)
#define LNG_MOUSEUP_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define LNG_MOUSEUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define LNG_MOUSEUP_X(event) VBX_EVENTARGNUM(event,float,2)
#define LNG_MOUSEUP_Y(event) VBX_EVENTARGNUM(event,float,3)
#define LNG_USERERROR_ERRORCODE(event) VBX_EVENTARGNUM(event,int,0)
#define LNG_USERERROR_AUTOBEEP(event) VBX_EVENTARGNUM(event,int,1)

#endif


// AwareLong property values
#define LNG_ACTION_COPY 0
#define LNG_ACTION_CUT 1
#define LNG_ACTION_PASTE 2
#define LNG_ACTION_CLEAR 3
#define LNG_ACTION_UNDO 4
#define LNG_ACTION_SET_NULL 5
#define LNG_ALIGNTEXTH_LEFT 0
#define LNG_ALIGNTEXTH_CENTER 1
#define LNG_ALIGNTEXTH_RIGHT 2
#define LNG_ALIGNTEXTV_TOP 0
#define LNG_ALIGNTEXTV_CENTER 1
#define LNG_ALIGNTEXTV_BOTTOM 2
#define LNG_BORDERSTYLE_NO_BORDER 0
#define LNG_BORDERSTYLE_SINGLE_LINE 1
#define LNG_BORDERSTYLE_ROUNDED 2
#define LNG_BORDERSTYLE_DASH 3
#define LNG_BORDERSTYLE_DOT 4
#define LNG_BORDERSTYLE_DASH_DOT 5
#define LNG_BORDERSTYLE_DASH_DOT_DOT 6
#define LNG_BUTTONSTYLE_NONE 0
#define LNG_BUTTONSTYLE_SPIN 1
#define LNG_BUTTONSTYLE_POP_UP 2
#define LNG_BUTTONSTYLE_DROP_DOWN 3
#define LNG_BUTTONSTYLE_SLIDE 4
#define LNG_CARETINSERT_SINGLE 0
#define LNG_CARETINSERT_DOUBLE 1
#define LNG_CARETINSERT_BLOCK 2
#define LNG_CARETINSERT_UNDERLINE 3
#define LNG_CARETINSERT_TRIANGLE 4
#define LNG_CARETOVERWRITE_SINGLE 0
#define LNG_CARETOVERWRITE_DOUBLE 1
#define LNG_CARETOVERWRITE_BLOCK 2
#define LNG_CARETOVERWRITE_UNDERLINE 3
#define LNG_CARETOVERWRITE_TRIANGLE 4
#define LNG_CONTROLTYPE_NORMAL 0
#define LNG_CONTROLTYPE_READ_ONLY 1
#define LNG_CONTROLTYPE_STATIC 2
#define LNG_INVALIDOPTION_SHOW_DATA 0
#define LNG_INVALIDOPTION_HIDE_DATA 1
#define LNG_INVALIDOPTION_CLEAR_DATA 2
#define LNG_MOUSEPOINTER_DEFAULT 0
#define LNG_MOUSEPOINTER_ARROW 1
#define LNG_MOUSEPOINTER_CROSS 2
#define LNG_MOUSEPOINTER_I_BEAM 3
#define LNG_MOUSEPOINTER_ICON 4
#define LNG_MOUSEPOINTER_SIZE 5
#define LNG_MOUSEPOINTER_SIZE_NE_SW 6
#define LNG_MOUSEPOINTER_SIZE_N_S 7
#define LNG_MOUSEPOINTER_SIZE_NW_SE 8
#define LNG_MOUSEPOINTER_SIZE_W_E 9
#define LNG_MOUSEPOINTER_UP_ARROW 10
#define LNG_MOUSEPOINTER_HOURGLASS 11
#define LNG_MOUSEPOINTER_NO_DROP 12
#define LNG_NEGFORMAT_LFT_1_RGT 0
#define LNG_NEGFORMAT_NEG_1 1
#define LNG_NEGFORMAT_1_NEG 2
#define LNG_NOSPECIALKEYS_ALL_KEYS_ENABLED 0
#define LNG_NOSPECIALKEYS_AWARE_KEYS_DISABLED 1
#define LNG_NOSPECIALKEYS_EDIT_KEYS_DISABLED 2
#define LNG_NOSPECIALKEYS_ALL_KEYS_DISABLED 3
#define LNG_ONFOCUSALIGNH_DEFAULT 0
#define LNG_ONFOCUSALIGNH_LEFT 1
#define LNG_ONFOCUSALIGNH_CENTER 2
#define LNG_ONFOCUSALIGNH_RIGHT 3
#define LNG_ONFOCUSALIGNV_DEFAULT 0
#define LNG_ONFOCUSALIGNV_TOP 1
#define LNG_ONFOCUSALIGNV_CENTER 2
#define LNG_ONFOCUSALIGNV_BOTTOM 3
#define LNG_ONFOCUSPOSITION_END 0
#define LNG_ONFOCUSPOSITION_BEGINNING 1
#define LNG_ONFOCUSPOSITION_PREVIOUS 2
#define LNG_ONFOCUSPOSITION_CARET 3
#define LNG_THREEDINSIDESTYLE_NONE 0
#define LNG_THREEDINSIDESTYLE_LOWERED 1
#define LNG_THREEDINSIDESTYLE_RAISED 2
#define LNG_THREEDOUTSIDESTYLE_NONE 0
#define LNG_THREEDOUTSIDESTYLE_LOWERED 1
#define LNG_THREEDOUTSIDESTYLE_RAISED 2
#define LNG_THREEDTEXT_NONE 0
#define LNG_THREEDTEXT_ETCHED 1
#define LNG_THREEDTEXT_EMBOSSED 2
#define LNG_THREEDTEXT_ETCHED_W_SHADING 3
#define LNG_THREEDTEXT_EMBOSSED_W_SHADING 4
#define LNG_USERENTRY_FORMATTED 0
#define LNG_USERENTRY_FREE_FORMAT 1

// Class representing AwareCurrency10 control in AWARE.VBX file

class CAwareCurrency : public CVBControl
{
  public:

#ifdef fpMFC

    BOOL Create(DWORD dwStyle, const RECT& rect,
                CWnd* pParentWnd, UINT nID,
                CFile* pFile = NULL, BOOL bAutoDelete = FALSE)
    {
      return CVBControl::Create(
               "AWARE.VBX;AwareCurrency10;",
               dwStyle, rect,
               pParentWnd, nID,
               pFile, bAutoDelete
             );
    }

#elif fpOWL

    CAwareCurrency(TWindow* parent, int id,
        const char far* title,
        int x, int y, int w, int h,
        long initLen = 0, void far* initData = 0,
        TModule* module = 0)
    : CVBControl(parent, id, "AWARE.VBX", "AwareCurrency10",
          title, x, y, w, h, initLen, initData, module) {};

    CAwareCurrency(TWindow* parent, int resourceId, TModule* module = 0)
    : CVBControl(parent, resourceId, module) {};

#endif

    CStringProperty About() {return CStringProperty(this,109);}
    CEnumProperty AlignTextH() {return CEnumProperty(this,60);}
    CEnumProperty AlignTextV() {return CEnumProperty(this,61);}
    CBoolProperty AllowNull() {return CBoolProperty(this,62);}
    CBoolProperty AutoAdvance() {return CBoolProperty(this,64);}
    CBoolProperty AutoBeep() {return CBoolProperty(this,65);}
    CColorProperty BackColor() {return CColorProperty(this,2);}
    CColorProperty BorderColor() {return CColorProperty(this,37);}
    CColorProperty BorderGrayAreaColor() {return CColorProperty(this,110);}
    CEnumProperty BorderStyle() {return CEnumProperty(this,36);}
    CShortProperty BorderWidth() {return CShortProperty(this,38);}
    CBoolProperty ButtonDefaultAction() {return CBoolProperty(this,50);}
    CBoolProperty ButtonDisable() {return CBoolProperty(this,41);}
    CBoolProperty ButtonHide() {return CBoolProperty(this,42);}
    CShortProperty ButtonIncrement() {return CShortProperty(this,43);}
    CShortProperty ButtonIndex() {return CShortProperty(this,44);}
    CShortProperty ButtonMax() {return CShortProperty(this,46);}
    CShortProperty ButtonMin() {return CShortProperty(this,45);}
    CEnumProperty ButtonStyle() {return CEnumProperty(this,47);}
    CLongProperty ButtonWidth() {return CLongProperty(this,48);}
    CBoolProperty ButtonWrap() {return CBoolProperty(this,49);}
    CEnumProperty CaretInsert() {return CEnumProperty(this,66);}
    CEnumProperty CaretOverWrite() {return CEnumProperty(this,67);}
    CLongProperty CharPositionLeft() {return CLongProperty(this,68);}
    CLongProperty CharPositionRight() {return CLongProperty(this,69);}
    CEnumProperty ControlType() {return CEnumProperty(this,90);}
    CShortProperty CurrencyDecimalPlaces() {return CShortProperty(this,92);}
    CEnumProperty CurrencyNegFormat() {return CEnumProperty(this,93);}
    CEnumProperty CurrencyPlacement() {return CEnumProperty(this,94);}
    CStringProperty CurrencySymbol() {return CStringProperty(this,95);}
    CLongProperty CurrentPosition() {return CLongProperty(this,70);}
    CStringProperty DecimalPoint() {return CStringProperty(this,96);}
    CColorProperty DropShadowColor() {return CColorProperty(this,53);}
    CShortProperty DropShadowWidth() {return CShortProperty(this,54);}
    CBoolProperty Enabled() {return CBoolProperty(this,19);}
    CBoolProperty FixedPoint() {return CBoolProperty(this,97);}
    CBoolProperty FontBold() {return CBoolProperty(this,10);}
    CBoolProperty FontItalic() {return CBoolProperty(this,11);}
    CStringProperty FontName() {return CStringProperty(this,9);}
    CFloatProperty FontSize() {return CFloatProperty(this,14);}
    CBoolProperty FontStrikethru() {return CBoolProperty(this,12);}
    CBoolProperty FontUnderline() {return CBoolProperty(this,13);}
    CColorProperty ForeColor() {return CColorProperty(this,3);}
    CLongProperty Height() {return CLongProperty(this,7);}
    CBoolProperty HideSelection() {return CBoolProperty(this,72);}
    CFloatProperty IncDec() {return CFloatProperty(this,107);}
    CFloatProperty IncInt() {return CFloatProperty(this,106);}
    CShortProperty Index() {return CShortProperty(this,1);}
    CColorProperty InvalidColor() {return CColorProperty(this,74);}
    CEnumProperty InvalidOption() {return CEnumProperty(this,75);}
    CBoolProperty IsNull() {return CBoolProperty(this,76);}
    CBoolProperty IsValid() {return CBoolProperty(this,77);}
    CEnumProperty LeadZero() {return CEnumProperty(this,98);}
    CLongProperty Left() {return CLongProperty(this,4);}
    CShortProperty MarginBottom() {return CShortProperty(this,81);}
    CShortProperty MarginLeft() {return CShortProperty(this,78);}
    CShortProperty MarginRight() {return CShortProperty(this,80);}
    CShortProperty MarginTop() {return CShortProperty(this,79);}
    CStringProperty MaxValue() {return CStringProperty(this,99);}
    CStringProperty MinValue() {return CStringProperty(this,100);}
    CEnumProperty MousePointer() {return CEnumProperty(this,8);}
    CStringProperty Name() {return CStringProperty(this,0);}
    CBoolProperty NegToggle() {return CBoolProperty(this,101);}
    CEnumProperty NoSpecialKeys() {return CEnumProperty(this,63);}
    CColorProperty NullColor() {return CColorProperty(this,82);}
    CEnumProperty OnFocusAlignH() {return CEnumProperty(this,83);}
    CEnumProperty OnFocusAlignV() {return CEnumProperty(this,84);}
    CBoolProperty OnFocusInvert3D() {return CBoolProperty(this,51);}
    CBoolProperty OnFocusNoSelect() {return CBoolProperty(this,85);}
    CEnumProperty OnFocusPosition() {return CEnumProperty(this,86);}
    CBoolProperty OnFocusShadow() {return CBoolProperty(this,52);}
    CShortProperty Parent() {return CShortProperty(this,20);}
    CBoolProperty Redraw() {return CBoolProperty(this,108);}
    CLongProperty SelLength() {return CLongProperty(this,87);}
    CLongProperty SelStart() {return CLongProperty(this,88);}
    CStringProperty SelText() {return CStringProperty(this,89);}
    CStringProperty Separator() {return CStringProperty(this,102);}
    CShortProperty TabIndex() {return CShortProperty(this,15);}
    CShortProperty TabStop() {return CShortProperty(this,16);}
    CStringProperty Tag() {return CStringProperty(this,21);}
    CStringProperty Text() {return CStringProperty(this,91);}
    CShortProperty ThreeDFrameWidth() {return CShortProperty(this,35);}
    CColorProperty ThreeDInsideHighlightColor() {return CColorProperty(this,28);}
    CColorProperty ThreeDInsideShadowColor() {return CColorProperty(this,29);}
    CEnumProperty ThreeDInsideStyle() {return CEnumProperty(this,27);}
    CShortProperty ThreeDInsideWidth() {return CShortProperty(this,30);}
    CColorProperty ThreeDOutsideHighlightColor() {return CColorProperty(this,32);}
    CColorProperty ThreeDOutsideShadowColor() {return CColorProperty(this,33);}
    CEnumProperty ThreeDOutsideStyle() {return CEnumProperty(this,31);}
    CShortProperty ThreeDOutsideWidth() {return CShortProperty(this,34);}
    CEnumProperty ThreeDText() {return CEnumProperty(this,55);}
    CColorProperty ThreeDTextHighlightColor() {return CColorProperty(this,56);}
    CShortProperty ThreeDTextOffset() {return CShortProperty(this,58);}
    CColorProperty ThreeDTextShadowColor() {return CColorProperty(this,57);}
    CLongProperty Top() {return CLongProperty(this,5);}
    CStringProperty UnFmtText() {return CStringProperty(this,103);}
    CBoolProperty UseSeparator() {return CBoolProperty(this,104);}
    CEnumProperty UserEntry() {return CEnumProperty(this,71);}
    CStringProperty Value() {return CStringProperty(this,105);}
    CBoolProperty Visible() {return CBoolProperty(this,22);}
    CLongProperty Width() {return CLongProperty(this,6);}
    CShortProperty hWnd() {return CShortProperty(this,73);}

};

#ifdef fpMFC

inline void AFXAPI
DDX_VBControl(CDataExchange* pDX, int nIDC, CAwareCurrency*& rpAwareCurrency)
{
  CVBControl* pControl = (CVBControl*)rpAwareCurrency;
  DDX_VBControl(pDX, nIDC, pControl);
  rpAwareCurrency = (CAwareCurrency*)pControl;
}
#endif

// AwareCurrency event indices
#define EVENT_CUR_ADVANCE 0
#define EVENT_CUR_BUTTONHIT 1
#define EVENT_CUR_CHANGE 2
#define EVENT_CUR_CHANGEMODE 3
#define EVENT_CUR_CLICK 4
#define EVENT_CUR_DBLCLICK 5
#define EVENT_CUR_GOTFOUCS 8
#define EVENT_CUR_INVALIDDATA 9
#define EVENT_CUR_KEYDOWN 10
#define EVENT_CUR_KEYPRESS 11
#define EVENT_CUR_KEYUP 12
#define EVENT_CUR_LOSTFOCUS 13
#define EVENT_CUR_MOUSEDOWN 14
#define EVENT_CUR_MOUSEMOVE 15
#define EVENT_CUR_MOUSEUP 16
#define EVENT_CUR_USERERROR 17

// AwareCurrency property indices
#define PROP_CUR_ABOUT 109
#define PROP_CUR_ACTION 59
#define PROP_CUR_ALIGNTEXTH 60
#define PROP_CUR_ALIGNTEXTV 61
#define PROP_CUR_ALLOWNULL 62
#define PROP_CUR_AUTOADVANCE 64
#define PROP_CUR_AUTOBEEP 65
#define PROP_CUR_BACKCOLOR 2
#define PROP_CUR_BORDERCOLOR 37
#define PROP_CUR_BORDERGRAYAREACOLOR 110
#define PROP_CUR_BORDERSTYLE 36
#define PROP_CUR_BORDERWIDTH 38
#define PROP_CUR_BUTTONDEFAULTACTION 50
#define PROP_CUR_BUTTONDISABLE 41
#define PROP_CUR_BUTTONHIDE 42
#define PROP_CUR_BUTTONINCREMENT 43
#define PROP_CUR_BUTTONINDEX 44
#define PROP_CUR_BUTTONMAX 46
#define PROP_CUR_BUTTONMIN 45
#define PROP_CUR_BUTTONSTYLE 47
#define PROP_CUR_BUTTONWIDTH 48
#define PROP_CUR_BUTTONWRAP 49
#define PROP_CUR_CARETINSERT 66
#define PROP_CUR_CARETOVERWRITE 67
#define PROP_CUR_CHARPOSITIONLEFT 68
#define PROP_CUR_CHARPOSITIONRIGHT 69
#define PROP_CUR_CONTROLTYPE 90
#define PROP_CUR_CURRENCYDECIMALPLACES 92
#define PROP_CUR_CURRENCYNEGFORMAT 93
#define PROP_CUR_CURRENCYPLACEMENT 94
#define PROP_CUR_CURRENCYSYMBOL 95
#define PROP_CUR_CURRENTPOSITION 70
#define PROP_CUR_DECIMALPOINT 96
#define PROP_CUR_DROPSHADOWCOLOR 53
#define PROP_CUR_DROPSHADOWWIDTH 54
#define PROP_CUR_ENABLED 19
#define PROP_CUR_FIXEDPOINT 97
#define PROP_CUR_FONTBOLD 10
#define PROP_CUR_FONTITALIC 11
#define PROP_CUR_FONTNAME 9
#define PROP_CUR_FONTSIZE 14
#define PROP_CUR_FONTSTRIKETHRU 12
#define PROP_CUR_FONTUNDERLINE 13
#define PROP_CUR_FORECOLOR 3
#define PROP_CUR_HEIGHT 7
#define PROP_CUR_HIDESELECTION 72
#define PROP_CUR_INCDEC 107
#define PROP_CUR_INCINT 106
#define PROP_CUR_INDEX 1
#define PROP_CUR_INVALIDCOLOR 74
#define PROP_CUR_INVALIDOPTION 75
#define PROP_CUR_ISNULL 76
#define PROP_CUR_ISVALID 77
#define PROP_CUR_LEADZERO 98
#define PROP_CUR_LEFT 4
#define PROP_CUR_MARGINBOTTOM 81
#define PROP_CUR_MARGINLEFT 78
#define PROP_CUR_MARGINRIGHT 80
#define PROP_CUR_MARGINTOP 79
#define PROP_CUR_MAXVALUE 99
#define PROP_CUR_MINVALUE 100
#define PROP_CUR_MOUSEPOINTER 8
#define PROP_CUR_NAME 0
#define PROP_CUR_NEGTOGGLE 101
#define PROP_CUR_NOSPECIALKEYS 63
#define PROP_CUR_NULLCOLOR 82
#define PROP_CUR_ONFOCUSALIGNH 83
#define PROP_CUR_ONFOCUSALIGNV 84
#define PROP_CUR_ONFOCUSINVERT3D 51
#define PROP_CUR_ONFOCUSNOSELECT 85
#define PROP_CUR_ONFOCUSPOSITION 86
#define PROP_CUR_ONFOCUSSHADOW 52
#define PROP_CUR_PARENT 20
#define PROP_CUR_REDRAW 108
#define PROP_CUR_SELLENGTH 87
#define PROP_CUR_SELSTART 88
#define PROP_CUR_SELTEXT 89
#define PROP_CUR_SEPARATOR 102
#define PROP_CUR_TABINDEX 15
#define PROP_CUR_TABSTOP 16
#define PROP_CUR_TAG 21
#define PROP_CUR_TEXT 91
#define PROP_CUR_THREEDFRAMEWIDTH 35
#define PROP_CUR_THREEDINSIDEHIGHLIGHTCOLOR 28
#define PROP_CUR_THREEDINSIDESHADOWCOLOR 29
#define PROP_CUR_THREEDINSIDESTYLE 27
#define PROP_CUR_THREEDINSIDEWIDTH 30
#define PROP_CUR_THREEDOUTSIDEHIGHLIGHTCOLOR 32
#define PROP_CUR_THREEDOUTSIDESHADOWCOLOR 33
#define PROP_CUR_THREEDOUTSIDESTYLE 31
#define PROP_CUR_THREEDOUTSIDEWIDTH 34
#define PROP_CUR_THREEDTEXT 55
#define PROP_CUR_THREEDTEXTHIGHLIGHTCOLOR 56
#define PROP_CUR_THREEDTEXTOFFSET 58
#define PROP_CUR_THREEDTEXTSHADOWCOLOR 57
#define PROP_CUR_TOP 5
#define PROP_CUR_UNFMTTEXT 103
#define PROP_CUR_USESEPARATOR 104
#define PROP_CUR_USERENTRY 71
#define PROP_CUR_VALUE 105
#define PROP_CUR_VISIBLE 22
#define PROP_CUR_WIDTH 6
#define PROP_CUR_HWND 73

#ifdef fpMFC


// AwareCurrency event macros
#define CUR_ADVANCE_DIRECTION(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CUR_ADVANCE_AUTOADVANCE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CUR_BUTTONHIT_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CUR_BUTTONHIT_NEWINDEX(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CUR_CHANGEMODE_EDITMODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CUR_CLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CUR_DBLCLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CUR_INVALIDDATA_NEXTWND(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CUR_KEYDOWN_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,1)
#define CUR_KEYDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define CUR_KEYPRESS_KEYASCII(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define CUR_KEYUP_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CUR_KEYUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CUR_MOUSEDOWN_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define CUR_MOUSEDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define CUR_MOUSEDOWN_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CUR_MOUSEDOWN_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CUR_MOUSEMOVE_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define CUR_MOUSEMOVE_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define CUR_MOUSEMOVE_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CUR_MOUSEMOVE_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CUR_MOUSEUP_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define CUR_MOUSEUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define CUR_MOUSEUP_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CUR_MOUSEUP_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CUR_USERERROR_ERRORCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CUR_USERERROR_AUTOBEEP(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)

#elif fpOWL


// AwareCurrency event macros
#define CUR_ADVANCE_DIRECTION(event) VBX_EVENTARGNUM(event,int,0)
#define CUR_ADVANCE_AUTOADVANCE(event) VBX_EVENTARGNUM(event,int,1)
#define CUR_BUTTONHIT_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define CUR_BUTTONHIT_NEWINDEX(event) VBX_EVENTARGNUM(event,int,1)
#define CUR_CHANGEMODE_EDITMODE(event) VBX_EVENTARGNUM(event,int,0)
#define CUR_CLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define CUR_DBLCLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define CUR_INVALIDDATA_NEXTWND(event) VBX_EVENTARGNUM(event,int,0)
#define CUR_KEYDOWN_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define CUR_KEYDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CUR_KEYPRESS_KEYASCII(event) VBX_EVENTARGNUM(event,int,0)
#define CUR_KEYUP_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define CUR_KEYUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CUR_MOUSEDOWN_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define CUR_MOUSEDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CUR_MOUSEDOWN_X(event) VBX_EVENTARGNUM(event,float,2)
#define CUR_MOUSEDOWN_Y(event) VBX_EVENTARGNUM(event,float,3)
#define CUR_MOUSEMOVE_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define CUR_MOUSEMOVE_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CUR_MOUSEMOVE_X(event) VBX_EVENTARGNUM(event,float,2)
#define CUR_MOUSEMOVE_Y(event) VBX_EVENTARGNUM(event,float,3)
#define CUR_MOUSEUP_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define CUR_MOUSEUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CUR_MOUSEUP_X(event) VBX_EVENTARGNUM(event,float,2)
#define CUR_MOUSEUP_Y(event) VBX_EVENTARGNUM(event,float,3)
#define CUR_USERERROR_ERRORCODE(event) VBX_EVENTARGNUM(event,int,0)
#define CUR_USERERROR_AUTOBEEP(event) VBX_EVENTARGNUM(event,int,1)

#endif


// AwareCurrency property values
#define CUR_ACTION_COPY 0
#define CUR_ACTION_CUT 1
#define CUR_ACTION_PASTE 2
#define CUR_ACTION_CLEAR 3
#define CUR_ACTION_UNDO 4
#define CUR_ACTION_SET_NULL 5
#define CUR_ALIGNTEXTH_LEFT 0
#define CUR_ALIGNTEXTH_CENTER 1
#define CUR_ALIGNTEXTH_RIGHT 2
#define CUR_ALIGNTEXTV_TOP 0
#define CUR_ALIGNTEXTV_CENTER 1
#define CUR_ALIGNTEXTV_BOTTOM 2
#define CUR_BORDERSTYLE_NO_BORDER 0
#define CUR_BORDERSTYLE_SINGLE_LINE 1
#define CUR_BORDERSTYLE_ROUNDED 2
#define CUR_BORDERSTYLE_DASH 3
#define CUR_BORDERSTYLE_DOT 4
#define CUR_BORDERSTYLE_DASH_DOT 5
#define CUR_BORDERSTYLE_DASH_DOT_DOT 6
#define CUR_BUTTONSTYLE_NONE 0
#define CUR_BUTTONSTYLE_SPIN 1
#define CUR_BUTTONSTYLE_POP_UP 2
#define CUR_BUTTONSTYLE_DROP_DOWN 3
#define CUR_BUTTONSTYLE_SLIDE 4
#define CUR_CARETINSERT_SINGLE 0
#define CUR_CARETINSERT_DOUBLE 1
#define CUR_CARETINSERT_BLOCK 2
#define CUR_CARETINSERT_UNDERLINE 3
#define CUR_CARETINSERT_TRIANGLE 4
#define CUR_CARETOVERWRITE_SINGLE 0
#define CUR_CARETOVERWRITE_DOUBLE 1
#define CUR_CARETOVERWRITE_BLOCK 2
#define CUR_CARETOVERWRITE_UNDERLINE 3
#define CUR_CARETOVERWRITE_TRIANGLE 4
#define CUR_CONTROLTYPE_NORMAL 0
#define CUR_CONTROLTYPE_READ_ONLY 1
#define CUR_CONTROLTYPE_STATIC 2
#define CUR_CURRENCYNEGFORMAT_INTL 0
#define CUR_CURRENCYNEGFORMAT_LFT_SYM_1_RGT 1
#define CUR_CURRENCYNEGFORMAT_NEG_SYM_1 2
#define CUR_CURRENCYNEGFORMAT_SYM_NEG_1 3
#define CUR_CURRENCYNEGFORMAT_SYM_1_NEG 4
#define CUR_CURRENCYNEGFORMAT_LFT_1_SYM_RGT 5
#define CUR_CURRENCYNEGFORMAT_NEG_1_SYM 6
#define CUR_CURRENCYNEGFORMAT_1_NEG_SYM 7
#define CUR_CURRENCYNEGFORMAT_1_SYM_NEG 8
#define CUR_CURRENCYNEGFORMAT_NEG_1_SPC_SYM 9
#define CUR_CURRENCYNEGFORMAT_NEG_SYM_SPC_1 10
#define CUR_CURRENCYNEGFORMAT_SYM_SPC_1_NEG 11
#define CUR_CURRENCYPLACEMENT_INTL 0
#define CUR_CURRENCYPLACEMENT_SYM_1 1
#define CUR_CURRENCYPLACEMENT_1_SYM 2
#define CUR_CURRENCYPLACEMENT_SYM_SPC_1 3
#define CUR_CURRENCYPLACEMENT_1_SPC_SYM 4
#define CUR_INVALIDOPTION_SHOW_DATA 0
#define CUR_INVALIDOPTION_HIDE_DATA 1
#define CUR_INVALIDOPTION_CLEAR_DATA 2
#define CUR_LEADZERO_INTL 0
#define CUR_LEADZERO_NO_LEADING_ZERO 1
#define CUR_LEADZERO_LEADING_ZERO 2
#define CUR_MOUSEPOINTER_DEFAULT 0
#define CUR_MOUSEPOINTER_ARROW 1
#define CUR_MOUSEPOINTER_CROSS 2
#define CUR_MOUSEPOINTER_I_BEAM 3
#define CUR_MOUSEPOINTER_ICON 4
#define CUR_MOUSEPOINTER_SIZE 5
#define CUR_MOUSEPOINTER_SIZE_NE_SW 6
#define CUR_MOUSEPOINTER_SIZE_N_S 7
#define CUR_MOUSEPOINTER_SIZE_NW_SE 8
#define CUR_MOUSEPOINTER_SIZE_W_E 9
#define CUR_MOUSEPOINTER_UP_ARROW 10
#define CUR_MOUSEPOINTER_HOURGLASS 11
#define CUR_MOUSEPOINTER_NO_DROP 12
#define CUR_NOSPECIALKEYS_ALL_KEYS_ENABLED 0
#define CUR_NOSPECIALKEYS_AWARE_KEYS_DISABLED 1
#define CUR_NOSPECIALKEYS_EDIT_KEYS_DISABLED 2
#define CUR_NOSPECIALKEYS_ALL_KEYS_DISABLED 3
#define CUR_ONFOCUSALIGNH_DEFAULT 0
#define CUR_ONFOCUSALIGNH_LEFT 1
#define CUR_ONFOCUSALIGNH_CENTER 2
#define CUR_ONFOCUSALIGNH_RIGHT 3
#define CUR_ONFOCUSALIGNV_DEFAULT 0
#define CUR_ONFOCUSALIGNV_TOP 1
#define CUR_ONFOCUSALIGNV_CENTER 2
#define CUR_ONFOCUSALIGNV_BOTTOM 3
#define CUR_ONFOCUSPOSITION_END 0
#define CUR_ONFOCUSPOSITION_BEGINNING 1
#define CUR_ONFOCUSPOSITION_PREVIOUS 2
#define CUR_ONFOCUSPOSITION_CARET 3
#define CUR_THREEDINSIDESTYLE_NONE 0
#define CUR_THREEDINSIDESTYLE_LOWERED 1
#define CUR_THREEDINSIDESTYLE_RAISED 2
#define CUR_THREEDOUTSIDESTYLE_NONE 0
#define CUR_THREEDOUTSIDESTYLE_LOWERED 1
#define CUR_THREEDOUTSIDESTYLE_RAISED 2
#define CUR_THREEDTEXT_NONE 0
#define CUR_THREEDTEXT_ETCHED 1
#define CUR_THREEDTEXT_EMBOSSED 2
#define CUR_THREEDTEXT_ETCHED_W_SHADING 3
#define CUR_THREEDTEXT_EMBOSSED_W_SHADING 4
#define CUR_USERENTRY_FORMATTED 0
#define CUR_USERENTRY_FREE_FORMAT 1

// Class representing AwareDateTime10 control in AWARE.VBX file

class CAwareDateTime : public CVBControl
{
  public:

#ifdef fpMFC

    BOOL Create(DWORD dwStyle, const RECT& rect,
                CWnd* pParentWnd, UINT nID,
                CFile* pFile = NULL, BOOL bAutoDelete = FALSE)
    {
      return CVBControl::Create(
               "AWARE.VBX;AwareDateTime10;",
               dwStyle, rect,
               pParentWnd, nID,
               pFile, bAutoDelete
             );
    }

#elif fpOWL

    CAwareDateTime(TWindow* parent, int id,
        const char far* title,
        int x, int y, int w, int h,
        long initLen = 0, void far* initData = 0,
        TModule* module = 0)
    : CVBControl(parent, id, "AWARE.VBX", "AwareDateTime10",
          title, x, y, w, h, initLen, initData, module) {};

    CAwareDateTime(TWindow* parent, int resourceId, TModule* module = 0)
    : CVBControl(parent, resourceId, module) {};

#endif

    CStringProperty About() {return CStringProperty(this,105);}
    CEnumProperty AlignTextH() {return CEnumProperty(this,58);}
    CEnumProperty AlignTextV() {return CEnumProperty(this,59);}
    CBoolProperty AllowNull() {return CBoolProperty(this,60);}
    CBoolProperty AutoAdvance() {return CBoolProperty(this,62);}
    CBoolProperty AutoBeep() {return CBoolProperty(this,63);}
    CColorProperty BackColor() {return CColorProperty(this,2);}
    CColorProperty BorderColor() {return CColorProperty(this,37);}
    CColorProperty BorderGrayAreaColor() {return CColorProperty(this,106);}
    CEnumProperty BorderStyle() {return CEnumProperty(this,36);}
    CShortProperty BorderWidth() {return CShortProperty(this,38);}
    CBoolProperty ButtonDefaultAction() {return CBoolProperty(this,39);}
    CBoolProperty ButtonDisable() {return CBoolProperty(this,40);}
    CBoolProperty ButtonHide() {return CBoolProperty(this,41);}
    CShortProperty ButtonIncrement() {return CShortProperty(this,42);}
    CShortProperty ButtonIndex() {return CShortProperty(this,43);}
    CShortProperty ButtonMax() {return CShortProperty(this,45);}
    CShortProperty ButtonMin() {return CShortProperty(this,44);}
    CEnumProperty ButtonStyle() {return CEnumProperty(this,46);}
    CLongProperty ButtonWidth() {return CLongProperty(this,47);}
    CBoolProperty ButtonWrap() {return CBoolProperty(this,48);}
    CEnumProperty CaretInsert() {return CEnumProperty(this,64);}
    CEnumProperty CaretOverWrite() {return CEnumProperty(this,65);}
    CLongProperty CharPositionLeft() {return CLongProperty(this,66);}
    CLongProperty CharPositionRight() {return CLongProperty(this,67);}
    CEnumProperty ControlType() {return CEnumProperty(this,88);}
    CLongProperty CurrentPosition() {return CLongProperty(this,68);}
    CEnumProperty DateCalcMethod() {return CEnumProperty(this,90);}
    CStringProperty DateDefault() {return CStringProperty(this,101);}
    CStringProperty DateMax() {return CStringProperty(this,93);}
    CStringProperty DateMin() {return CStringProperty(this,94);}
    CEnumProperty DateTimeFormat() {return CEnumProperty(this,91);}
    CStringProperty DateValue() {return CStringProperty(this,107);}
    CShortProperty Day() {return CShortProperty(this,111);}
    CColorProperty DropShadowColor() {return CColorProperty(this,51);}
    CShortProperty DropShadowWidth() {return CShortProperty(this,52);}
    CBoolProperty Enabled() {return CBoolProperty(this,19);}
    CBoolProperty FontBold() {return CBoolProperty(this,10);}
    CBoolProperty FontItalic() {return CBoolProperty(this,11);}
    CStringProperty FontName() {return CStringProperty(this,9);}
    CFloatProperty FontSize() {return CFloatProperty(this,14);}
    CBoolProperty FontStrikethru() {return CBoolProperty(this,12);}
    CBoolProperty FontUnderline() {return CBoolProperty(this,13);}
    CColorProperty ForeColor() {return CColorProperty(this,3);}
    CLongProperty Height() {return CLongProperty(this,7);}
    CBoolProperty HideSelection() {return CBoolProperty(this,70);}
    CShortProperty Hour() {return CShortProperty(this,112);}
    CShortProperty Index() {return CShortProperty(this,1);}
    CColorProperty InvalidColor() {return CColorProperty(this,72);}
    CEnumProperty InvalidOption() {return CEnumProperty(this,73);}
    CBoolProperty IsNull() {return CBoolProperty(this,74);}
    CBoolProperty IsValid() {return CBoolProperty(this,75);}
    CLongProperty Left() {return CLongProperty(this,4);}
    CStringProperty LongDayName(int i) {return CStringProperty(this,115,i);}
    CStringProperty LongMonthName(int i) {return CStringProperty(this,117,i);}
    CShortProperty MarginBottom() {return CShortProperty(this,79);}
    CShortProperty MarginLeft() {return CShortProperty(this,76);}
    CShortProperty MarginRight() {return CShortProperty(this,78);}
    CShortProperty MarginTop() {return CShortProperty(this,77);}
    CShortProperty Min() {return CShortProperty(this,113);}
    CShortProperty Month() {return CShortProperty(this,110);}
    CEnumProperty MousePointer() {return CEnumProperty(this,8);}
    CStringProperty Name() {return CStringProperty(this,0);}
    CEnumProperty NoSpecialKeys() {return CEnumProperty(this,61);}
    CColorProperty NullColor() {return CColorProperty(this,80);}
    CEnumProperty OnFocusAlignH() {return CEnumProperty(this,81);}
    CEnumProperty OnFocusAlignV() {return CEnumProperty(this,82);}
    CBoolProperty OnFocusInvert3D() {return CBoolProperty(this,49);}
    CBoolProperty OnFocusNoSelect() {return CBoolProperty(this,83);}
    CEnumProperty OnFocusPosition() {return CEnumProperty(this,84);}
    CBoolProperty OnFocusShadow() {return CBoolProperty(this,50);}
    CShortProperty Parent() {return CShortProperty(this,20);}
    CBoolProperty Redraw() {return CBoolProperty(this,104);}
    CShortProperty Sec() {return CShortProperty(this,114);}
    CLongProperty SelLength() {return CLongProperty(this,85);}
    CLongProperty SelStart() {return CLongProperty(this,86);}
    CStringProperty SelText() {return CStringProperty(this,87);}
    CStringProperty ShortDayName(int i) {return CStringProperty(this,116,i);}
    CStringProperty ShortMonthName(int i) {return CStringProperty(this,118,i);}
    CShortProperty TabIndex() {return CShortProperty(this,15);}
    CShortProperty TabStop() {return CShortProperty(this,16);}
    CStringProperty Tag() {return CStringProperty(this,21);}
    CStringProperty Text() {return CStringProperty(this,89);}
    CShortProperty ThreeDFrameWidth() {return CShortProperty(this,35);}
    CColorProperty ThreeDInsideHighlightColor() {return CColorProperty(this,28);}
    CColorProperty ThreeDInsideShadowColor() {return CColorProperty(this,29);}
    CEnumProperty ThreeDInsideStyle() {return CEnumProperty(this,27);}
    CShortProperty ThreeDInsideWidth() {return CShortProperty(this,30);}
    CColorProperty ThreeDOutsideHighlightColor() {return CColorProperty(this,32);}
    CColorProperty ThreeDOutsideShadowColor() {return CColorProperty(this,33);}
    CEnumProperty ThreeDOutsideStyle() {return CEnumProperty(this,31);}
    CShortProperty ThreeDOutsideWidth() {return CShortProperty(this,34);}
    CEnumProperty ThreeDText() {return CEnumProperty(this,53);}
    CColorProperty ThreeDTextHighlightColor() {return CColorProperty(this,54);}
    CShortProperty ThreeDTextOffset() {return CShortProperty(this,56);}
    CColorProperty ThreeDTextShadowColor() {return CColorProperty(this,55);}
    CStringProperty TimeDefault() {return CStringProperty(this,102);}
    CStringProperty TimeMax() {return CStringProperty(this,97);}
    CStringProperty TimeMin() {return CStringProperty(this,98);}
    CStringProperty TimeString1159() {return CStringProperty(this,99);}
    CStringProperty TimeString2359() {return CStringProperty(this,100);}
    CEnumProperty TimeStyle() {return CEnumProperty(this,103);}
    CStringProperty TimeValue() {return CStringProperty(this,108);}
    CLongProperty Top() {return CLongProperty(this,5);}
    CStringProperty UnFmtText() {return CStringProperty(this,95);}
    CStringProperty UserDefinedFormat() {return CStringProperty(this,92);}
    CEnumProperty UserEntry() {return CEnumProperty(this,69);}
    CStringProperty Value() {return CStringProperty(this,96);}
    CBoolProperty Visible() {return CBoolProperty(this,22);}
    CLongProperty Width() {return CLongProperty(this,6);}
    CShortProperty Year() {return CShortProperty(this,109);}
    CShortProperty hWnd() {return CShortProperty(this,71);}

};

#ifdef fpMFC

inline void AFXAPI
DDX_VBControl(CDataExchange* pDX, int nIDC, CAwareDateTime*& rpAwareDateTime)
{
  CVBControl* pControl = (CVBControl*)rpAwareDateTime;
  DDX_VBControl(pDX, nIDC, pControl);
  rpAwareDateTime = (CAwareDateTime*)pControl;
}
#endif

// AwareDateTime event indices
#define EVENT_DTM_ADVANCE 0
#define EVENT_DTM_BUTTONHIT 1
#define EVENT_DTM_CHANGE 2
#define EVENT_DTM_CHANGEMODE 3
#define EVENT_DTM_CLICK 4
#define EVENT_DTM_DBLCLICK 5
#define EVENT_DTM_GOTFOUCS 8
#define EVENT_DTM_INVALIDDATA 9
#define EVENT_DTM_KEYDOWN 10
#define EVENT_DTM_KEYPRESS 11
#define EVENT_DTM_KEYUP 12
#define EVENT_DTM_LOSTFOCUS 13
#define EVENT_DTM_MOUSEDOWN 14
#define EVENT_DTM_MOUSEMOVE 15
#define EVENT_DTM_MOUSEUP 16
#define EVENT_DTM_POPUP 17
#define EVENT_DTM_USERERROR 18

// AwareDateTime property indices
#define PROP_DTM_ABOUT 105
#define PROP_DTM_ACTION 57
#define PROP_DTM_ALIGNTEXTH 58
#define PROP_DTM_ALIGNTEXTV 59
#define PROP_DTM_ALLOWNULL 60
#define PROP_DTM_AUTOADVANCE 62
#define PROP_DTM_AUTOBEEP 63
#define PROP_DTM_BACKCOLOR 2
#define PROP_DTM_BORDERCOLOR 37
#define PROP_DTM_BORDERGRAYAREACOLOR 106
#define PROP_DTM_BORDERSTYLE 36
#define PROP_DTM_BORDERWIDTH 38
#define PROP_DTM_BUTTONDEFAULTACTION 39
#define PROP_DTM_BUTTONDISABLE 40
#define PROP_DTM_BUTTONHIDE 41
#define PROP_DTM_BUTTONINCREMENT 42
#define PROP_DTM_BUTTONINDEX 43
#define PROP_DTM_BUTTONMAX 45
#define PROP_DTM_BUTTONMIN 44
#define PROP_DTM_BUTTONSTYLE 46
#define PROP_DTM_BUTTONWIDTH 47
#define PROP_DTM_BUTTONWRAP 48
#define PROP_DTM_CARETINSERT 64
#define PROP_DTM_CARETOVERWRITE 65
#define PROP_DTM_CHARPOSITIONLEFT 66
#define PROP_DTM_CHARPOSITIONRIGHT 67
#define PROP_DTM_CONTROLTYPE 88
#define PROP_DTM_CURRENTPOSITION 68
#define PROP_DTM_DATECALCMETHOD 90
#define PROP_DTM_DATEDEFAULT 101
#define PROP_DTM_DATEMAX 93
#define PROP_DTM_DATEMIN 94
#define PROP_DTM_DATETIMEFORMAT 91
#define PROP_DTM_DATEVALUE 107
#define PROP_DTM_DAY 111
#define PROP_DTM_DROPSHADOWCOLOR 51
#define PROP_DTM_DROPSHADOWWIDTH 52
#define PROP_DTM_ENABLED 19
#define PROP_DTM_FONTBOLD 10
#define PROP_DTM_FONTITALIC 11
#define PROP_DTM_FONTNAME 9
#define PROP_DTM_FONTSIZE 14
#define PROP_DTM_FONTSTRIKETHRU 12
#define PROP_DTM_FONTUNDERLINE 13
#define PROP_DTM_FORECOLOR 3
#define PROP_DTM_HEIGHT 7
#define PROP_DTM_HIDESELECTION 70
#define PROP_DTM_HOUR 112
#define PROP_DTM_INDEX 1
#define PROP_DTM_INVALIDCOLOR 72
#define PROP_DTM_INVALIDOPTION 73
#define PROP_DTM_ISNULL 74
#define PROP_DTM_ISVALID 75
#define PROP_DTM_LEFT 4
#define PROP_DTM_LONGDAYNAME 115
#define PROP_DTM_LONGMONTHNAME 117
#define PROP_DTM_MARGINBOTTOM 79
#define PROP_DTM_MARGINLEFT 76
#define PROP_DTM_MARGINRIGHT 78
#define PROP_DTM_MARGINTOP 77
#define PROP_DTM_MIN 113
#define PROP_DTM_MONTH 110
#define PROP_DTM_MOUSEPOINTER 8
#define PROP_DTM_NAME 0
#define PROP_DTM_NOSPECIALKEYS 61
#define PROP_DTM_NULLCOLOR 80
#define PROP_DTM_ONFOCUSALIGNH 81
#define PROP_DTM_ONFOCUSALIGNV 82
#define PROP_DTM_ONFOCUSINVERT3D 49
#define PROP_DTM_ONFOCUSNOSELECT 83
#define PROP_DTM_ONFOCUSPOSITION 84
#define PROP_DTM_ONFOCUSSHADOW 50
#define PROP_DTM_PARENT 20
#define PROP_DTM_REDRAW 104
#define PROP_DTM_SEC 114
#define PROP_DTM_SELLENGTH 85
#define PROP_DTM_SELSTART 86
#define PROP_DTM_SELTEXT 87
#define PROP_DTM_SHORTDAYNAME 116
#define PROP_DTM_SHORTMONTHNAME 118
#define PROP_DTM_TABINDEX 15
#define PROP_DTM_TABSTOP 16
#define PROP_DTM_TAG 21
#define PROP_DTM_TEXT 89
#define PROP_DTM_THREEDFRAMEWIDTH 35
#define PROP_DTM_THREEDINSIDEHIGHLIGHTCOLOR 28
#define PROP_DTM_THREEDINSIDESHADOWCOLOR 29
#define PROP_DTM_THREEDINSIDESTYLE 27
#define PROP_DTM_THREEDINSIDEWIDTH 30
#define PROP_DTM_THREEDOUTSIDEHIGHLIGHTCOLOR 32
#define PROP_DTM_THREEDOUTSIDESHADOWCOLOR 33
#define PROP_DTM_THREEDOUTSIDESTYLE 31
#define PROP_DTM_THREEDOUTSIDEWIDTH 34
#define PROP_DTM_THREEDTEXT 53
#define PROP_DTM_THREEDTEXTHIGHLIGHTCOLOR 54
#define PROP_DTM_THREEDTEXTOFFSET 56
#define PROP_DTM_THREEDTEXTSHADOWCOLOR 55
#define PROP_DTM_TIMEDEFAULT 102
#define PROP_DTM_TIMEMAX 97
#define PROP_DTM_TIMEMIN 98
#define PROP_DTM_TIMESTRING1159 99
#define PROP_DTM_TIMESTRING2359 100
#define PROP_DTM_TIMESTYLE 103
#define PROP_DTM_TIMEVALUE 108
#define PROP_DTM_TOP 5
#define PROP_DTM_UNFMTTEXT 95
#define PROP_DTM_USERDEFINEDFORMAT 92
#define PROP_DTM_USERENTRY 69
#define PROP_DTM_VALUE 96
#define PROP_DTM_VISIBLE 22
#define PROP_DTM_WIDTH 6
#define PROP_DTM_YEAR 109
#define PROP_DTM_HWND 71

#ifdef fpMFC


// AwareDateTime event macros
#define DTM_ADVANCE_DIRECTION(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define DTM_ADVANCE_AUTOADVANCE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DTM_BUTTONHIT_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define DTM_BUTTONHIT_NEWINDEX(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DTM_CHANGEMODE_EDITMODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DTM_CLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DTM_DBLCLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DTM_INVALIDDATA_NEXTWND(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DTM_KEYDOWN_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,1)
#define DTM_KEYDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define DTM_KEYPRESS_KEYASCII(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define DTM_KEYUP_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define DTM_KEYUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DTM_MOUSEDOWN_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define DTM_MOUSEDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define DTM_MOUSEDOWN_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define DTM_MOUSEDOWN_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DTM_MOUSEMOVE_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define DTM_MOUSEMOVE_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define DTM_MOUSEMOVE_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define DTM_MOUSEMOVE_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DTM_MOUSEUP_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define DTM_MOUSEUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define DTM_MOUSEUP_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define DTM_MOUSEUP_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define DTM_POPUP_CANCEL(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define DTM_USERERROR_ERRORCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define DTM_USERERROR_AUTOBEEP(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)

#elif fpOWL


// AwareDateTime event macros
#define DTM_ADVANCE_DIRECTION(event) VBX_EVENTARGNUM(event,int,0)
#define DTM_ADVANCE_AUTOADVANCE(event) VBX_EVENTARGNUM(event,int,1)
#define DTM_BUTTONHIT_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define DTM_BUTTONHIT_NEWINDEX(event) VBX_EVENTARGNUM(event,int,1)
#define DTM_CHANGEMODE_EDITMODE(event) VBX_EVENTARGNUM(event,int,0)
#define DTM_CLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define DTM_DBLCLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define DTM_INVALIDDATA_NEXTWND(event) VBX_EVENTARGNUM(event,int,0)
#define DTM_KEYDOWN_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define DTM_KEYDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define DTM_KEYPRESS_KEYASCII(event) VBX_EVENTARGNUM(event,int,0)
#define DTM_KEYUP_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define DTM_KEYUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define DTM_MOUSEDOWN_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define DTM_MOUSEDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define DTM_MOUSEDOWN_X(event) VBX_EVENTARGNUM(event,float,2)
#define DTM_MOUSEDOWN_Y(event) VBX_EVENTARGNUM(event,float,3)
#define DTM_MOUSEMOVE_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define DTM_MOUSEMOVE_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define DTM_MOUSEMOVE_X(event) VBX_EVENTARGNUM(event,float,2)
#define DTM_MOUSEMOVE_Y(event) VBX_EVENTARGNUM(event,float,3)
#define DTM_MOUSEUP_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define DTM_MOUSEUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define DTM_MOUSEUP_X(event) VBX_EVENTARGNUM(event,float,2)
#define DTM_MOUSEUP_Y(event) VBX_EVENTARGNUM(event,float,3)
#define DTM_POPUP_CANCEL(event) VBX_EVENTARGNUM(event,int,0)
#define DTM_USERERROR_ERRORCODE(event) VBX_EVENTARGNUM(event,int,0)
#define DTM_USERERROR_AUTOBEEP(event) VBX_EVENTARGNUM(event,int,1)

#endif


// AwareDateTime property values
#define DTM_ACTION_COPY 0
#define DTM_ACTION_CUT 1
#define DTM_ACTION_PASTE 2
#define DTM_ACTION_CLEAR 3
#define DTM_ACTION_UNDO 4
#define DTM_ACTION_SET_NULL 5
#define DTM_ALIGNTEXTH_LEFT 0
#define DTM_ALIGNTEXTH_CENTER 1
#define DTM_ALIGNTEXTH_RIGHT 2
#define DTM_ALIGNTEXTV_TOP 0
#define DTM_ALIGNTEXTV_CENTER 1
#define DTM_ALIGNTEXTV_BOTTOM 2
#define DTM_BORDERSTYLE_NO_BORDER 0
#define DTM_BORDERSTYLE_SINGLE_LINE 1
#define DTM_BORDERSTYLE_ROUNDED 2
#define DTM_BORDERSTYLE_DASH 3
#define DTM_BORDERSTYLE_DOT 4
#define DTM_BORDERSTYLE_DASH_DOT 5
#define DTM_BORDERSTYLE_DASH_DOT_DOT 6
#define DTM_BUTTONSTYLE_NONE 0
#define DTM_BUTTONSTYLE_SPIN 1
#define DTM_BUTTONSTYLE_POP_UP 2
#define DTM_BUTTONSTYLE_DROP_DOWN 3
#define DTM_BUTTONSTYLE_SLIDE 4
#define DTM_CARETINSERT_SINGLE 0
#define DTM_CARETINSERT_DOUBLE 1
#define DTM_CARETINSERT_BLOCK 2
#define DTM_CARETINSERT_UNDERLINE 3
#define DTM_CARETINSERT_TRIANGLE 4
#define DTM_CARETOVERWRITE_SINGLE 0
#define DTM_CARETOVERWRITE_DOUBLE 1
#define DTM_CARETOVERWRITE_BLOCK 2
#define DTM_CARETOVERWRITE_UNDERLINE 3
#define DTM_CARETOVERWRITE_TRIANGLE 4
#define DTM_CONTROLTYPE_NORMAL 0
#define DTM_CONTROLTYPE_READ_ONLY 1
#define DTM_CONTROLTYPE_STATIC 2
#define DTM_DATECALCMETHOD_CURRENT_DATE_TIME 0
#define DTM_DATECALCMETHOD_USER_DEFINED_DATE_TIM 1
#define DTM_DATECALCMETHOD_50_50 2
#define DTM_DATECALCMETHOD_FUTURE 3
#define DTM_DATETIMEFORMAT_INTL_SHORT_DATE 0
#define DTM_DATETIMEFORMAT_INTL_LONG_DATE 1
#define DTM_DATETIMEFORMAT_INTL_SHORT_DATE_W_TIM 2
#define DTM_DATETIMEFORMAT_INTL_LONG_DATE_W_TIME 3
#define DTM_DATETIMEFORMAT_TIME_ONLY 4
#define DTM_DATETIMEFORMAT_USER_DEFINED 5
#define DTM_INVALIDOPTION_SHOW_DATA 0
#define DTM_INVALIDOPTION_HIDE_DATA 1
#define DTM_INVALIDOPTION_CLEAR_DATA 2
#define DTM_MOUSEPOINTER_DEFAULT 0
#define DTM_MOUSEPOINTER_ARROW 1
#define DTM_MOUSEPOINTER_CROSS 2
#define DTM_MOUSEPOINTER_I_BEAM 3
#define DTM_MOUSEPOINTER_ICON 4
#define DTM_MOUSEPOINTER_SIZE 5
#define DTM_MOUSEPOINTER_SIZE_NE_SW 6
#define DTM_MOUSEPOINTER_SIZE_N_S 7
#define DTM_MOUSEPOINTER_SIZE_NW_SE 8
#define DTM_MOUSEPOINTER_SIZE_W_E 9
#define DTM_MOUSEPOINTER_UP_ARROW 10
#define DTM_MOUSEPOINTER_HOURGLASS 11
#define DTM_MOUSEPOINTER_NO_DROP 12
#define DTM_NOSPECIALKEYS_ALL_KEYS_ENABLED 0
#define DTM_NOSPECIALKEYS_AWARE_KEYS_DISABLED 1
#define DTM_NOSPECIALKEYS_EDIT_KEYS_DISABLED 2
#define DTM_NOSPECIALKEYS_ALL_KEYS_DISABLED 3
#define DTM_ONFOCUSALIGNH_DEFAULT 0
#define DTM_ONFOCUSALIGNH_LEFT 1
#define DTM_ONFOCUSALIGNH_CENTER 2
#define DTM_ONFOCUSALIGNH_RIGHT 3
#define DTM_ONFOCUSALIGNV_DEFAULT 0
#define DTM_ONFOCUSALIGNV_TOP 1
#define DTM_ONFOCUSALIGNV_CENTER 2
#define DTM_ONFOCUSALIGNV_BOTTOM 3
#define DTM_ONFOCUSPOSITION_END 0
#define DTM_ONFOCUSPOSITION_BEGINNING 1
#define DTM_ONFOCUSPOSITION_PREVIOUS 2
#define DTM_ONFOCUSPOSITION_CARET 3
#define DTM_THREEDINSIDESTYLE_NONE 0
#define DTM_THREEDINSIDESTYLE_LOWERED 1
#define DTM_THREEDINSIDESTYLE_RAISED 2
#define DTM_THREEDOUTSIDESTYLE_NONE 0
#define DTM_THREEDOUTSIDESTYLE_LOWERED 1
#define DTM_THREEDOUTSIDESTYLE_RAISED 2
#define DTM_THREEDTEXT_NONE 0
#define DTM_THREEDTEXT_ETCHED 1
#define DTM_THREEDTEXT_EMBOSSED 2
#define DTM_THREEDTEXT_ETCHED_W_SHADING 3
#define DTM_THREEDTEXT_EMBOSSED_W_SHADING 4
#define DTM_TIMESTYLE_INTL 0
#define DTM_TIMESTYLE_12_HOUR 1
#define DTM_TIMESTYLE_24_HOUR 2
#define DTM_USERENTRY_FORMATTED 0
#define DTM_USERENTRY_FREE_FORMAT 1

// Class representing AwareBoolean control in AWAREBB.VBX file

class CAwareBoolean : public CVBControl
{
  public:

#ifdef fpMFC

    BOOL Create(DWORD dwStyle, const RECT& rect,
                CWnd* pParentWnd, UINT nID,
                CFile* pFile = NULL, BOOL bAutoDelete = FALSE)
    {
      return CVBControl::Create(
               "AWAREBB.VBX;AwareBoolean;",
               dwStyle, rect,
               pParentWnd, nID,
               pFile, bAutoDelete
             );
    }

#elif fpOWL

    CAwareBoolean(TWindow* parent, int id,
        const char far* title,
        int x, int y, int w, int h,
        long initLen = 0, void far* initData = 0,
        TModule* module = 0)
    : CVBControl(parent, id, "AWAREBB.VBX", "AwareBoolean",
          title, x, y, w, h, initLen, initData, module) {};

    CAwareBoolean(TWindow* parent, int resourceId, TModule* module = 0)
    : CVBControl(parent, resourceId, module) {};

#endif

    CStringProperty About() {return CStringProperty(this,79);}
    CEnumProperty AlignPictureH() {return CEnumProperty(this,53);}
    CEnumProperty AlignPictureV() {return CEnumProperty(this,54);}
    CEnumProperty AlignTextH() {return CEnumProperty(this,64);}
    CEnumProperty AlignTextV() {return CEnumProperty(this,65);}
    CBoolProperty AutoToggle() {return CBoolProperty(this,43);}
    CColorProperty BackColor() {return CColorProperty(this,2);}
    CEnumProperty BooleanMode() {return CEnumProperty(this,71);}
    CEnumProperty BooleanPicture() {return CEnumProperty(this,52);}
    CEnumProperty BooleanStyle() {return CEnumProperty(this,44);}
    CColorProperty BorderColor() {return CColorProperty(this,37);}
    CColorProperty BorderGrayAreaColor() {return CColorProperty(this,80);}
    CEnumProperty BorderStyle() {return CEnumProperty(this,36);}
    CShortProperty BorderWidth() {return CShortProperty(this,38);}
    CStringProperty Caption() {return CStringProperty(this,72);}
    CColorProperty DropShadowColor() {return CColorProperty(this,41);}
    CShortProperty DropShadowWidth() {return CShortProperty(this,42);}
    CBoolProperty Enabled() {return CBoolProperty(this,19);}
    CBoolProperty FontBold() {return CBoolProperty(this,10);}
    CBoolProperty FontItalic() {return CBoolProperty(this,11);}
    CStringProperty FontName() {return CStringProperty(this,9);}
    CFloatProperty FontSize() {return CFloatProperty(this,14);}
    CBoolProperty FontStrikethru() {return CBoolProperty(this,12);}
    CBoolProperty FontUnderline() {return CBoolProperty(this,13);}
    CColorProperty ForeColor() {return CColorProperty(this,3);}
    CLongProperty GroupId() {return CLongProperty(this,55);}
    CEnumProperty GroupSelect() {return CEnumProperty(this,57);}
    CLongProperty GroupTag() {return CLongProperty(this,56);}
    CLongProperty GroupValue() {return CLongProperty(this,81);}
    CLongProperty Height() {return CLongProperty(this,7);}
    CShortProperty Index() {return CShortProperty(this,1);}
    CLongProperty Left() {return CLongProperty(this,4);}
    CShortProperty MarginBottom() {return CShortProperty(this,61);}
    CShortProperty MarginLeft() {return CShortProperty(this,58);}
    CShortProperty MarginRight() {return CShortProperty(this,60);}
    CShortProperty MarginTop() {return CShortProperty(this,59);}
    CEnumProperty MousePointer() {return CEnumProperty(this,8);}
    CBoolProperty MultiLine() {return CBoolProperty(this,62);}
    CStringProperty Name() {return CStringProperty(this,0);}
    CBoolProperty OnFocusInvert3D() {return CBoolProperty(this,39);}
    CBoolProperty OnFocusShadow() {return CBoolProperty(this,40);}
    CShortProperty Parent() {return CShortProperty(this,20);}
    CPictureProperty PictureFalse() {return CPictureProperty(this,49);}
    CPictureProperty PictureFalseDisabled() {return CPictureProperty(this,46);}
    CPictureProperty PictureFalseDown() {return CPictureProperty(this,48);}
    CPictureProperty PictureTrue() {return CPictureProperty(this,67);}
    CPictureProperty PictureTrueDisabled() {return CPictureProperty(this,45);}
    CPictureProperty PictureTrueDown() {return CPictureProperty(this,66);}
    CBoolProperty Redraw() {return CBoolProperty(this,78);}
    CShortProperty TabIndex() {return CShortProperty(this,15);}
    CShortProperty TabStop() {return CShortProperty(this,16);}
    CStringProperty Tag() {return CStringProperty(this,21);}
    CStringProperty Text() {return CStringProperty(this,63);}
    CStringProperty TextDisabled() {return CStringProperty(this,47);}
    CStringProperty TextFalse() {return CStringProperty(this,51);}
    CStringProperty TextTrue() {return CStringProperty(this,69);}
    CShortProperty ThreeDFrameWidth() {return CShortProperty(this,35);}
    CColorProperty ThreeDInsideHighlightColor() {return CColorProperty(this,28);}
    CColorProperty ThreeDInsideShadowColor() {return CColorProperty(this,29);}
    CEnumProperty ThreeDInsideStyle() {return CEnumProperty(this,27);}
    CShortProperty ThreeDInsideWidth() {return CShortProperty(this,30);}
    CColorProperty ThreeDOutsideHighlightColor() {return CColorProperty(this,32);}
    CColorProperty ThreeDOutsideShadowColor() {return CColorProperty(this,33);}
    CEnumProperty ThreeDOutsideStyle() {return CEnumProperty(this,31);}
    CShortProperty ThreeDOutsideWidth() {return CShortProperty(this,34);}
    CEnumProperty ThreeDText() {return CEnumProperty(this,73);}
    CColorProperty ThreeDTextHighlightColor() {return CColorProperty(this,74);}
    CShortProperty ThreeDTextOffset() {return CShortProperty(this,76);}
    CColorProperty ThreeDTextShadowColor() {return CColorProperty(this,75);}
    CStringProperty ToggleFalse() {return CStringProperty(this,50);}
    CStringProperty ToggleTrue() {return CStringProperty(this,68);}
    CLongProperty Top() {return CLongProperty(this,5);}
    CEnumProperty Value() {return CEnumProperty(this,70);}
    CBoolProperty Visible() {return CBoolProperty(this,22);}
    CLongProperty Width() {return CLongProperty(this,6);}
    CShortProperty hWnd() {return CShortProperty(this,77);}

};

#ifdef fpMFC

inline void AFXAPI
DDX_VBControl(CDataExchange* pDX, int nIDC, CAwareBoolean*& rpAwareBoolean)
{
  CVBControl* pControl = (CVBControl*)rpAwareBoolean;
  DDX_VBControl(pDX, nIDC, pControl);
  rpAwareBoolean = (CAwareBoolean*)pControl;
}
#endif

// AwareBoolean event indices
#define EVENT_BLN_ADVANCE 0
#define EVENT_BLN_CHANGE 1
#define EVENT_BLN_CLICK 2
#define EVENT_BLN_DBLCLICK 3
#define EVENT_BLN_GOTFOUCS 6
#define EVENT_BLN_KEYDOWN 7
#define EVENT_BLN_KEYPRESS 8
#define EVENT_BLN_KEYUP 9
#define EVENT_BLN_LOSTFOCUS 10
#define EVENT_BLN_MOUSEDOWN 11
#define EVENT_BLN_MOUSEMOVE 12
#define EVENT_BLN_MOUSEUP 13
#define EVENT_BLN_USERERROR 14

// AwareBoolean property indices
#define PROP_BLN_ABOUT 79
#define PROP_BLN_ALIGNPICTUREH 53
#define PROP_BLN_ALIGNPICTUREV 54
#define PROP_BLN_ALIGNTEXTH 64
#define PROP_BLN_ALIGNTEXTV 65
#define PROP_BLN_AUTOTOGGLE 43
#define PROP_BLN_BACKCOLOR 2
#define PROP_BLN_BOOLEANMODE 71
#define PROP_BLN_BOOLEANPICTURE 52
#define PROP_BLN_BOOLEANSTYLE 44
#define PROP_BLN_BORDERCOLOR 37
#define PROP_BLN_BORDERGRAYAREACOLOR 80
#define PROP_BLN_BORDERSTYLE 36
#define PROP_BLN_BORDERWIDTH 38
#define PROP_BLN_CAPTION 72
#define PROP_BLN_DROPSHADOWCOLOR 41
#define PROP_BLN_DROPSHADOWWIDTH 42
#define PROP_BLN_ENABLED 19
#define PROP_BLN_FONTBOLD 10
#define PROP_BLN_FONTITALIC 11
#define PROP_BLN_FONTNAME 9
#define PROP_BLN_FONTSIZE 14
#define PROP_BLN_FONTSTRIKETHRU 12
#define PROP_BLN_FONTUNDERLINE 13
#define PROP_BLN_FORECOLOR 3
#define PROP_BLN_GROUPID 55
#define PROP_BLN_GROUPSELECT 57
#define PROP_BLN_GROUPTAG 56
#define PROP_BLN_GROUPVALUE 81
#define PROP_BLN_HEIGHT 7
#define PROP_BLN_INDEX 1
#define PROP_BLN_LEFT 4
#define PROP_BLN_MARGINBOTTOM 61
#define PROP_BLN_MARGINLEFT 58
#define PROP_BLN_MARGINRIGHT 60
#define PROP_BLN_MARGINTOP 59
#define PROP_BLN_MOUSEPOINTER 8
#define PROP_BLN_MULTILINE 62
#define PROP_BLN_NAME 0
#define PROP_BLN_ONFOCUSINVERT3D 39
#define PROP_BLN_ONFOCUSSHADOW 40
#define PROP_BLN_PARENT 20
#define PROP_BLN_PICTUREFALSE 49
#define PROP_BLN_PICTUREFALSEDISABLED 46
#define PROP_BLN_PICTUREFALSEDOWN 48
#define PROP_BLN_PICTURETRUE 67
#define PROP_BLN_PICTURETRUEDISABLED 45
#define PROP_BLN_PICTURETRUEDOWN 66
#define PROP_BLN_REDRAW 78
#define PROP_BLN_TABINDEX 15
#define PROP_BLN_TABSTOP 16
#define PROP_BLN_TAG 21
#define PROP_BLN_TEXT 63
#define PROP_BLN_TEXTDISABLED 47
#define PROP_BLN_TEXTFALSE 51
#define PROP_BLN_TEXTTRUE 69
#define PROP_BLN_THREEDFRAMEWIDTH 35
#define PROP_BLN_THREEDINSIDEHIGHLIGHTCOLOR 28
#define PROP_BLN_THREEDINSIDESHADOWCOLOR 29
#define PROP_BLN_THREEDINSIDESTYLE 27
#define PROP_BLN_THREEDINSIDEWIDTH 30
#define PROP_BLN_THREEDOUTSIDEHIGHLIGHTCOLOR 32
#define PROP_BLN_THREEDOUTSIDESHADOWCOLOR 33
#define PROP_BLN_THREEDOUTSIDESTYLE 31
#define PROP_BLN_THREEDOUTSIDEWIDTH 34
#define PROP_BLN_THREEDTEXT 73
#define PROP_BLN_THREEDTEXTHIGHLIGHTCOLOR 74
#define PROP_BLN_THREEDTEXTOFFSET 76
#define PROP_BLN_THREEDTEXTSHADOWCOLOR 75
#define PROP_BLN_TOGGLEFALSE 50
#define PROP_BLN_TOGGLETRUE 68
#define PROP_BLN_TOP 5
#define PROP_BLN_VALUE 70
#define PROP_BLN_VISIBLE 22
#define PROP_BLN_WIDTH 6
#define PROP_BLN_HWND 77

#ifdef fpMFC


// AwareBoolean event macros
#define BLN_ADVANCE_DIRECTION(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define BLN_ADVANCE_AUTOADVANCE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BLN_CLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BLN_DBLCLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BLN_KEYDOWN_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define BLN_KEYDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BLN_KEYPRESS_KEYASCII(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define BLN_KEYUP_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define BLN_KEYUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BLN_MOUSEDOWN_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define BLN_MOUSEDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define BLN_MOUSEDOWN_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define BLN_MOUSEDOWN_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BLN_MOUSEMOVE_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define BLN_MOUSEMOVE_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define BLN_MOUSEMOVE_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define BLN_MOUSEMOVE_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BLN_MOUSEUP_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define BLN_MOUSEUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define BLN_MOUSEUP_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define BLN_MOUSEUP_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BLN_USERERROR_ERRORCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define BLN_USERERROR_AUTOBEEP(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)

#elif fpOWL


// AwareBoolean event macros
#define BLN_ADVANCE_DIRECTION(event) VBX_EVENTARGNUM(event,int,0)
#define BLN_ADVANCE_AUTOADVANCE(event) VBX_EVENTARGNUM(event,int,1)
#define BLN_CLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define BLN_DBLCLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define BLN_KEYDOWN_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define BLN_KEYDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define BLN_KEYPRESS_KEYASCII(event) VBX_EVENTARGNUM(event,int,0)
#define BLN_KEYUP_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define BLN_KEYUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define BLN_MOUSEDOWN_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define BLN_MOUSEDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define BLN_MOUSEDOWN_X(event) VBX_EVENTARGNUM(event,float,2)
#define BLN_MOUSEDOWN_Y(event) VBX_EVENTARGNUM(event,float,3)
#define BLN_MOUSEMOVE_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define BLN_MOUSEMOVE_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define BLN_MOUSEMOVE_X(event) VBX_EVENTARGNUM(event,float,2)
#define BLN_MOUSEMOVE_Y(event) VBX_EVENTARGNUM(event,float,3)
#define BLN_MOUSEUP_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define BLN_MOUSEUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define BLN_MOUSEUP_X(event) VBX_EVENTARGNUM(event,float,2)
#define BLN_MOUSEUP_Y(event) VBX_EVENTARGNUM(event,float,3)
#define BLN_USERERROR_ERRORCODE(event) VBX_EVENTARGNUM(event,int,0)
#define BLN_USERERROR_AUTOBEEP(event) VBX_EVENTARGNUM(event,int,1)

#endif


// AwareBoolean property values
#define BLN_ALIGNPICTUREH_LEFT 0
#define BLN_ALIGNPICTUREH_CENTER 1
#define BLN_ALIGNPICTUREH_RIGHT 2
#define BLN_ALIGNPICTUREH_LEFT_OF_TEXT 3
#define BLN_ALIGNPICTUREH_RIGHT_OF_TEXT 4
#define BLN_ALIGNPICTUREV_TOP 0
#define BLN_ALIGNPICTUREV_CENTER 1
#define BLN_ALIGNPICTUREV_BOTTOM 2
#define BLN_ALIGNTEXTH_LEFT 0
#define BLN_ALIGNTEXTH_CENTER 1
#define BLN_ALIGNTEXTH_RIGHT 2
#define BLN_ALIGNTEXTV_TOP 0
#define BLN_ALIGNTEXTV_CENTER 1
#define BLN_ALIGNTEXTV_BOTTOM 2
#define BLN_BOOLEANMODE_2_STATE 0
#define BLN_BOOLEANMODE_3_STATE 1
#define BLN_BOOLEANMODE_BUTTON_LIKE 2
#define BLN_BOOLEANPICTURE_CHECK_BOX 0
#define BLN_BOOLEANPICTURE_OPTION_BUTTON 1
#define BLN_BOOLEANPICTURE_3D_CHECK_BOX 2
#define BLN_BOOLEANPICTURE_3D_OPTION_BUTTON 3
#define BLN_BOOLEANPICTURE_USER_DEFINED 4
#define BLN_BOOLEANSTYLE_TEXT_W_BITMAP 0
#define BLN_BOOLEANSTYLE_TEXT_ONLY 1
#define BLN_BOOLEANSTYLE_BITMAP_ONLY 2
#define BLN_BORDERSTYLE_NO_BORDER 0
#define BLN_BORDERSTYLE_SINGLE_LINE 1
#define BLN_BORDERSTYLE_ROUNDED 2
#define BLN_BORDERSTYLE_DASH 3
#define BLN_BORDERSTYLE_DOT 4
#define BLN_BORDERSTYLE_DASH_DOT 5
#define BLN_BORDERSTYLE_DASH_DOT_DOT 6
#define BLN_GROUPSELECT_NO_RULE 0
#define BLN_GROUPSELECT_ANY_COMBINATION 1
#define BLN_GROUPSELECT_NO_MORE_THAN_ONE 2
#define BLN_GROUPSELECT_ONE_AND_ONLY_ONE 3
#define BLN_GROUPSELECT_ONE_OR_MORE 4
#define BLN_MOUSEPOINTER_DEFAULT 0
#define BLN_MOUSEPOINTER_ARROW 1
#define BLN_MOUSEPOINTER_CROSS 2
#define BLN_MOUSEPOINTER_I_BEAM 3
#define BLN_MOUSEPOINTER_ICON 4
#define BLN_MOUSEPOINTER_SIZE 5
#define BLN_MOUSEPOINTER_SIZE_NE_SW 6
#define BLN_MOUSEPOINTER_SIZE_N_S 7
#define BLN_MOUSEPOINTER_SIZE_NW_SE 8
#define BLN_MOUSEPOINTER_SIZE_W_E 9
#define BLN_MOUSEPOINTER_UP_ARROW 10
#define BLN_MOUSEPOINTER_HOURGLASS 11
#define BLN_MOUSEPOINTER_NO_DROP 12
#define BLN_THREEDINSIDESTYLE_NONE 0
#define BLN_THREEDINSIDESTYLE_LOWERED 1
#define BLN_THREEDINSIDESTYLE_RAISED 2
#define BLN_THREEDOUTSIDESTYLE_NONE 0
#define BLN_THREEDOUTSIDESTYLE_LOWERED 1
#define BLN_THREEDOUTSIDESTYLE_RAISED 2
#define BLN_THREEDTEXT_NONE 0
#define BLN_THREEDTEXT_ETCHED 1
#define BLN_THREEDTEXT_EMBOSSED 2
#define BLN_THREEDTEXT_ETCHED_W_SHADING 3
#define BLN_THREEDTEXT_EMBOSSED_W_SHADING 4
#define BLN_VALUE_FALSE 0
#define BLN_VALUE_TRUE 1
#define BLN_VALUE_DISABLED 2

// Class representing AwareBinary control in AWAREBB.VBX file

class CAwareBinary : public CVBControl
{
  public:

#ifdef fpMFC

    BOOL Create(DWORD dwStyle, const RECT& rect,
                CWnd* pParentWnd, UINT nID,
                CFile* pFile = NULL, BOOL bAutoDelete = FALSE)
    {
      return CVBControl::Create(
               "AWAREBB.VBX;AwareBinary;",
               dwStyle, rect,
               pParentWnd, nID,
               pFile, bAutoDelete
             );
    }

#elif fpOWL

    CAwareBinary(TWindow* parent, int id,
        const char far* title,
        int x, int y, int w, int h,
        long initLen = 0, void far* initData = 0,
        TModule* module = 0)
    : CVBControl(parent, id, "AWAREBB.VBX", "AwareBinary",
          title, x, y, w, h, initLen, initData, module) {};

    CAwareBinary(TWindow* parent, int resourceId, TModule* module = 0)
    : CVBControl(parent, resourceId, module) {};

#endif

    CStringProperty About() {return CStringProperty(this,47);}
    CColorProperty BackColor() {return CColorProperty(this,2);}
    CEnumProperty BinaryStyle() {return CEnumProperty(this,43);}
    CColorProperty BorderColor() {return CColorProperty(this,36);}
    CColorProperty BorderGrayAreaColor() {return CColorProperty(this,48);}
    CEnumProperty BorderStyle() {return CEnumProperty(this,35);}
    CShortProperty BorderWidth() {return CShortProperty(this,37);}
    CColorProperty DropShadowColor() {return CColorProperty(this,40);}
    CShortProperty DropShadowWidth() {return CShortProperty(this,41);}
    CBoolProperty Enabled() {return CBoolProperty(this,18);}
    CBoolProperty FontBold() {return CBoolProperty(this,9);}
    CBoolProperty FontItalic() {return CBoolProperty(this,10);}
    CStringProperty FontName() {return CStringProperty(this,8);}
    CFloatProperty FontSize() {return CFloatProperty(this,13);}
    CBoolProperty FontStrikethru() {return CBoolProperty(this,11);}
    CBoolProperty FontUnderline() {return CBoolProperty(this,12);}
    CLongProperty Height() {return CLongProperty(this,6);}
    CShortProperty Index() {return CShortProperty(this,1);}
    CLongProperty Left() {return CLongProperty(this,3);}
    CEnumProperty MousePointer() {return CEnumProperty(this,7);}
    CStringProperty Name() {return CStringProperty(this,0);}
    CBoolProperty OnFocusInvert3D() {return CBoolProperty(this,38);}
    CBoolProperty OnFocusShadow() {return CBoolProperty(this,39);}
    CShortProperty Parent() {return CShortProperty(this,19);}
    CPictureProperty Picture() {return CPictureProperty(this,44);}
    CBoolProperty Redraw() {return CBoolProperty(this,46);}
    CBoolProperty ScrollBars() {return CBoolProperty(this,42);}
    CShortProperty TabIndex() {return CShortProperty(this,14);}
    CShortProperty TabStop() {return CShortProperty(this,15);}
    CStringProperty Tag() {return CStringProperty(this,20);}
    CShortProperty ThreeDFrameWidth() {return CShortProperty(this,34);}
    CColorProperty ThreeDInsideHighlightColor() {return CColorProperty(this,27);}
    CColorProperty ThreeDInsideShadowColor() {return CColorProperty(this,28);}
    CEnumProperty ThreeDInsideStyle() {return CEnumProperty(this,26);}
    CShortProperty ThreeDInsideWidth() {return CShortProperty(this,29);}
    CColorProperty ThreeDOutsideHighlightColor() {return CColorProperty(this,31);}
    CColorProperty ThreeDOutsideShadowColor() {return CColorProperty(this,32);}
    CEnumProperty ThreeDOutsideStyle() {return CEnumProperty(this,30);}
    CShortProperty ThreeDOutsideWidth() {return CShortProperty(this,33);}
    CLongProperty Top() {return CLongProperty(this,4);}
    CBoolProperty Visible() {return CBoolProperty(this,21);}
    CLongProperty Width() {return CLongProperty(this,5);}
    CShortProperty hWnd() {return CShortProperty(this,45);}

};

#ifdef fpMFC

inline void AFXAPI
DDX_VBControl(CDataExchange* pDX, int nIDC, CAwareBinary*& rpAwareBinary)
{
  CVBControl* pControl = (CVBControl*)rpAwareBinary;
  DDX_VBControl(pDX, nIDC, pControl);
  rpAwareBinary = (CAwareBinary*)pControl;
}
#endif

// AwareBinary event indices
#define EVENT_BIN_ADVANCE 0
#define EVENT_BIN_CHANGE 1
#define EVENT_BIN_CLICK 2
#define EVENT_BIN_DBLCLICK 3
#define EVENT_BIN_GOTFOUCS 6
#define EVENT_BIN_KEYDOWN 7
#define EVENT_BIN_KEYPRESS 8
#define EVENT_BIN_KEYUP 9
#define EVENT_BIN_LOSTFOCUS 10
#define EVENT_BIN_MOUSEDOWN 11
#define EVENT_BIN_MOUSEMOVE 12
#define EVENT_BIN_MOUSEUP 13

// AwareBinary property indices
#define PROP_BIN_ABOUT 47
#define PROP_BIN_BACKCOLOR 2
#define PROP_BIN_BINARYSTYLE 43
#define PROP_BIN_BORDERCOLOR 36
#define PROP_BIN_BORDERGRAYAREACOLOR 48
#define PROP_BIN_BORDERSTYLE 35
#define PROP_BIN_BORDERWIDTH 37
#define PROP_BIN_DROPSHADOWCOLOR 40
#define PROP_BIN_DROPSHADOWWIDTH 41
#define PROP_BIN_ENABLED 18
#define PROP_BIN_FONTBOLD 9
#define PROP_BIN_FONTITALIC 10
#define PROP_BIN_FONTNAME 8
#define PROP_BIN_FONTSIZE 13
#define PROP_BIN_FONTSTRIKETHRU 11
#define PROP_BIN_FONTUNDERLINE 12
#define PROP_BIN_HEIGHT 6
#define PROP_BIN_INDEX 1
#define PROP_BIN_LEFT 3
#define PROP_BIN_MOUSEPOINTER 7
#define PROP_BIN_NAME 0
#define PROP_BIN_ONFOCUSINVERT3D 38
#define PROP_BIN_ONFOCUSSHADOW 39
#define PROP_BIN_PARENT 19
#define PROP_BIN_PICTURE 44
#define PROP_BIN_REDRAW 46
#define PROP_BIN_SCROLLBARS 42
#define PROP_BIN_TABINDEX 14
#define PROP_BIN_TABSTOP 15
#define PROP_BIN_TAG 20
#define PROP_BIN_THREEDFRAMEWIDTH 34
#define PROP_BIN_THREEDINSIDEHIGHLIGHTCOLOR 27
#define PROP_BIN_THREEDINSIDESHADOWCOLOR 28
#define PROP_BIN_THREEDINSIDESTYLE 26
#define PROP_BIN_THREEDINSIDEWIDTH 29
#define PROP_BIN_THREEDOUTSIDEHIGHLIGHTCOLOR 31
#define PROP_BIN_THREEDOUTSIDESHADOWCOLOR 32
#define PROP_BIN_THREEDOUTSIDESTYLE 30
#define PROP_BIN_THREEDOUTSIDEWIDTH 33
#define PROP_BIN_TOP 4
#define PROP_BIN_VISIBLE 21
#define PROP_BIN_WIDTH 5
#define PROP_BIN_HWND 45

#ifdef fpMFC


// AwareBinary event macros
#define BIN_ADVANCE_DIRECTION(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define BIN_ADVANCE_AUTOADVANCE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BIN_CLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BIN_DBLCLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BIN_KEYDOWN_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define BIN_KEYDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BIN_KEYPRESS_KEYASCII(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define BIN_KEYUP_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define BIN_KEYUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BIN_MOUSEDOWN_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define BIN_MOUSEDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define BIN_MOUSEDOWN_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define BIN_MOUSEDOWN_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BIN_MOUSEMOVE_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define BIN_MOUSEMOVE_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define BIN_MOUSEMOVE_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define BIN_MOUSEMOVE_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define BIN_MOUSEUP_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define BIN_MOUSEUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define BIN_MOUSEUP_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define BIN_MOUSEUP_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)

#elif fpOWL


// AwareBinary event macros
#define BIN_ADVANCE_DIRECTION(event) VBX_EVENTARGNUM(event,int,0)
#define BIN_ADVANCE_AUTOADVANCE(event) VBX_EVENTARGNUM(event,int,1)
#define BIN_CLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define BIN_DBLCLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define BIN_KEYDOWN_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define BIN_KEYDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define BIN_KEYPRESS_KEYASCII(event) VBX_EVENTARGNUM(event,int,0)
#define BIN_KEYUP_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define BIN_KEYUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define BIN_MOUSEDOWN_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define BIN_MOUSEDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define BIN_MOUSEDOWN_X(event) VBX_EVENTARGNUM(event,float,2)
#define BIN_MOUSEDOWN_Y(event) VBX_EVENTARGNUM(event,float,3)
#define BIN_MOUSEMOVE_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define BIN_MOUSEMOVE_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define BIN_MOUSEMOVE_X(event) VBX_EVENTARGNUM(event,float,2)
#define BIN_MOUSEMOVE_Y(event) VBX_EVENTARGNUM(event,float,3)
#define BIN_MOUSEUP_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define BIN_MOUSEUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define BIN_MOUSEUP_X(event) VBX_EVENTARGNUM(event,float,2)
#define BIN_MOUSEUP_Y(event) VBX_EVENTARGNUM(event,float,3)

#endif


// AwareBinary property values
#define BIN_BINARYSTYLE_ALIGN_LEFT 0
#define BIN_BINARYSTYLE_ALIGN_LEFT_W_SCROLL 1
#define BIN_BINARYSTYLE_CENTER 2
#define BIN_BINARYSTYLE_SCALE_TO_FIT 3
#define BIN_BINARYSTYLE_STRETCH_TO_FIT 4
#define BIN_BORDERSTYLE_NO_BORDER 0
#define BIN_BORDERSTYLE_SINGLE_LINE 1
#define BIN_BORDERSTYLE_ROUNDED 2
#define BIN_BORDERSTYLE_DASH 3
#define BIN_BORDERSTYLE_DOT 4
#define BIN_BORDERSTYLE_DASH_DOT 5
#define BIN_BORDERSTYLE_DASH_DOT_DOT 6
#define BIN_MOUSEPOINTER_DEFAULT 0
#define BIN_MOUSEPOINTER_ARROW 1
#define BIN_MOUSEPOINTER_CROSS 2
#define BIN_MOUSEPOINTER_I_BEAM 3
#define BIN_MOUSEPOINTER_ICON 4
#define BIN_MOUSEPOINTER_SIZE 5
#define BIN_MOUSEPOINTER_SIZE_NE_SW 6
#define BIN_MOUSEPOINTER_SIZE_N_S 7
#define BIN_MOUSEPOINTER_SIZE_NW_SE 8
#define BIN_MOUSEPOINTER_SIZE_W_E 9
#define BIN_MOUSEPOINTER_UP_ARROW 10
#define BIN_MOUSEPOINTER_HOURGLASS 11
#define BIN_MOUSEPOINTER_NO_DROP 12
#define BIN_THREEDINSIDESTYLE_NONE 0
#define BIN_THREEDINSIDESTYLE_LOWERED 1
#define BIN_THREEDINSIDESTYLE_RAISED 2
#define BIN_THREEDOUTSIDESTYLE_NONE 0
#define BIN_THREEDOUTSIDESTYLE_LOWERED 1
#define BIN_THREEDOUTSIDESTYLE_RAISED 2

// Class representing AwareCalendar control in AWARECC.VBX file

class CAwareCalendar : public CVBControl
{
  public:

#ifdef fpMFC

    BOOL Create(DWORD dwStyle, const RECT& rect,
                CWnd* pParentWnd, UINT nID,
                CFile* pFile = NULL, BOOL bAutoDelete = FALSE)
    {
      return CVBControl::Create(
               "AWARECC.VBX;AwareCalendar;",
               dwStyle, rect,
               pParentWnd, nID,
               pFile, bAutoDelete
             );
    }

#elif fpOWL

    CAwareCalendar(TWindow* parent, int id,
        const char far* title,
        int x, int y, int w, int h,
        long initLen = 0, void far* initData = 0,
        TModule* module = 0)
    : CVBControl(parent, id, "AWARECC.VBX", "AwareCalendar",
          title, x, y, w, h, initLen, initData, module) {};

    CAwareCalendar(TWindow* parent, int resourceId, TModule* module = 0)
    : CVBControl(parent, resourceId, module) {};

#endif

    CStringProperty About() {return CStringProperty(this,66);}
    CColorProperty BorderColor() {return CColorProperty(this,35);}
    CColorProperty BorderGrayAreaColor() {return CColorProperty(this,67);}
    CEnumProperty BorderStyle() {return CEnumProperty(this,34);}
    CShortProperty BorderWidth() {return CShortProperty(this,36);}
    CStringProperty CurrentDate() {return CStringProperty(this,42);}
    CStringProperty DateMax() {return CStringProperty(this,44);}
    CStringProperty DateMin() {return CStringProperty(this,43);}
    CShortProperty Day() {return CShortProperty(this,47);}
    CColorProperty DropShadowColor() {return CColorProperty(this,39);}
    CShortProperty DropShadowWidth() {return CShortProperty(this,40);}
    CEnumProperty Element() {return CEnumProperty(this,60);}
    CColorProperty Element3DHighlightColor() {return CColorProperty(this,56);}
    CColorProperty Element3DShadowColor() {return CColorProperty(this,57);}
    CShortProperty Element3DShadowWidth() {return CShortProperty(this,55);}
    CEnumProperty Element3DStyle() {return CEnumProperty(this,53);}
    CEnumProperty Element3DText() {return CEnumProperty(this,54);}
    CColorProperty ElementBackColor() {return CColorProperty(this,58);}
    CColorProperty ElementForeColor() {return CColorProperty(this,59);}
    CShortProperty ElementIndex() {return CShortProperty(this,61);}
    CBoolProperty Enabled() {return CBoolProperty(this,17);}
    CEnumProperty FirstDayOfWeek() {return CEnumProperty(this,41);}
    CBoolProperty FontBold() {return CBoolProperty(this,8);}
    CBoolProperty FontItalic() {return CBoolProperty(this,9);}
    CStringProperty FontName() {return CStringProperty(this,7);}
    CFloatProperty FontSize() {return CFloatProperty(this,12);}
    CBoolProperty FontStrikethru() {return CBoolProperty(this,10);}
    CBoolProperty FontUnderline() {return CBoolProperty(this,11);}
    CColorProperty GrayAreaBackColor() {return CColorProperty(this,50);}
    CColorProperty GrayAreaForeColor() {return CColorProperty(this,51);}
    CEnumProperty GrayAreaStyle() {return CEnumProperty(this,49);}
    CEnumProperty HeaderStyle() {return CEnumProperty(this,52);}
    CLongProperty Height() {return CLongProperty(this,5);}
    CShortProperty Index() {return CShortProperty(this,1);}
    CLongProperty Left() {return CLongProperty(this,2);}
    CStringProperty LongDayName(int i) {return CStringProperty(this,68,i);}
    CStringProperty LongMonthName(int i) {return CStringProperty(this,69,i);}
    CShortProperty Month() {return CShortProperty(this,46);}
    CEnumProperty MonthHeaderStyle() {return CEnumProperty(this,62);}
    CEnumProperty MousePointer() {return CEnumProperty(this,6);}
    CStringProperty Name() {return CStringProperty(this,0);}
    CBoolProperty OnFocusInvert3D() {return CBoolProperty(this,37);}
    CBoolProperty OnFocusShadow() {return CBoolProperty(this,38);}
    CShortProperty Parent() {return CShortProperty(this,18);}
    CBoolProperty Redraw() {return CBoolProperty(this,65);}
    CStringProperty ShortDayName(int i) {return CStringProperty(this,70,i);}
    CStringProperty ShortMonthName(int i) {return CStringProperty(this,71,i);}
    CShortProperty TabIndex() {return CShortProperty(this,13);}
    CShortProperty TabStop() {return CShortProperty(this,14);}
    CStringProperty Tag() {return CStringProperty(this,19);}
    CShortProperty ThreeDFrameWidth() {return CShortProperty(this,33);}
    CColorProperty ThreeDInsideHighlightColor() {return CColorProperty(this,26);}
    CColorProperty ThreeDInsideShadowColor() {return CColorProperty(this,27);}
    CEnumProperty ThreeDInsideStyle() {return CEnumProperty(this,25);}
    CShortProperty ThreeDInsideWidth() {return CShortProperty(this,28);}
    CColorProperty ThreeDOutsideHighlightColor() {return CColorProperty(this,30);}
    CColorProperty ThreeDOutsideShadowColor() {return CColorProperty(this,31);}
    CEnumProperty ThreeDOutsideStyle() {return CEnumProperty(this,29);}
    CShortProperty ThreeDOutsideWidth() {return CShortProperty(this,32);}
    CLongProperty Top() {return CLongProperty(this,3);}
    CBoolProperty Visible() {return CBoolProperty(this,20);}
    CEnumProperty WeekDayHdr() {return CEnumProperty(this,45);}
    CLongProperty Width() {return CLongProperty(this,4);}
    CShortProperty Year() {return CShortProperty(this,48);}
    CEnumProperty YearHeaderStyle() {return CEnumProperty(this,63);}
    CShortProperty hWnd() {return CShortProperty(this,64);}

};

#ifdef fpMFC

inline void AFXAPI
DDX_VBControl(CDataExchange* pDX, int nIDC, CAwareCalendar*& rpAwareCalendar)
{
  CVBControl* pControl = (CVBControl*)rpAwareCalendar;
  DDX_VBControl(pDX, nIDC, pControl);
  rpAwareCalendar = (CAwareCalendar*)pControl;
}
#endif

// AwareCalendar event indices
#define EVENT_CAL_CHANGE 0
#define EVENT_CAL_DBLCLICK 1
#define EVENT_CAL_GOTFOUCS 4
#define EVENT_CAL_KEYDOWN 5
#define EVENT_CAL_KEYPRESS 6
#define EVENT_CAL_KEYUP 7
#define EVENT_CAL_LOSTFOCUS 8

// AwareCalendar property indices
#define PROP_CAL_ABOUT 66
#define PROP_CAL_BORDERCOLOR 35
#define PROP_CAL_BORDERGRAYAREACOLOR 67
#define PROP_CAL_BORDERSTYLE 34
#define PROP_CAL_BORDERWIDTH 36
#define PROP_CAL_CURRENTDATE 42
#define PROP_CAL_DATEMAX 44
#define PROP_CAL_DATEMIN 43
#define PROP_CAL_DAY 47
#define PROP_CAL_DROPSHADOWCOLOR 39
#define PROP_CAL_DROPSHADOWWIDTH 40
#define PROP_CAL_ELEMENT 60
#define PROP_CAL_ELEMENT3DHIGHLIGHTCOLOR 56
#define PROP_CAL_ELEMENT3DSHADOWCOLOR 57
#define PROP_CAL_ELEMENT3DSHADOWWIDTH 55
#define PROP_CAL_ELEMENT3DSTYLE 53
#define PROP_CAL_ELEMENT3DTEXT 54
#define PROP_CAL_ELEMENTBACKCOLOR 58
#define PROP_CAL_ELEMENTFORECOLOR 59
#define PROP_CAL_ELEMENTINDEX 61
#define PROP_CAL_ENABLED 17
#define PROP_CAL_FIRSTDAYOFWEEK 41
#define PROP_CAL_FONTBOLD 8
#define PROP_CAL_FONTITALIC 9
#define PROP_CAL_FONTNAME 7
#define PROP_CAL_FONTSIZE 12
#define PROP_CAL_FONTSTRIKETHRU 10
#define PROP_CAL_FONTUNDERLINE 11
#define PROP_CAL_GRAYAREABACKCOLOR 50
#define PROP_CAL_GRAYAREAFORECOLOR 51
#define PROP_CAL_GRAYAREASTYLE 49
#define PROP_CAL_HEADERSTYLE 52
#define PROP_CAL_HEIGHT 5
#define PROP_CAL_INDEX 1
#define PROP_CAL_LEFT 2
#define PROP_CAL_LONGDAYNAME 68
#define PROP_CAL_LONGMONTHNAME 69
#define PROP_CAL_MONTH 46
#define PROP_CAL_MONTHHEADERSTYLE 62
#define PROP_CAL_MOUSEPOINTER 6
#define PROP_CAL_NAME 0
#define PROP_CAL_ONFOCUSINVERT3D 37
#define PROP_CAL_ONFOCUSSHADOW 38
#define PROP_CAL_PARENT 18
#define PROP_CAL_REDRAW 65
#define PROP_CAL_SHORTDAYNAME 70
#define PROP_CAL_SHORTMONTHNAME 71
#define PROP_CAL_TABINDEX 13
#define PROP_CAL_TABSTOP 14
#define PROP_CAL_TAG 19
#define PROP_CAL_THREEDFRAMEWIDTH 33
#define PROP_CAL_THREEDINSIDEHIGHLIGHTCOLOR 26
#define PROP_CAL_THREEDINSIDESHADOWCOLOR 27
#define PROP_CAL_THREEDINSIDESTYLE 25
#define PROP_CAL_THREEDINSIDEWIDTH 28
#define PROP_CAL_THREEDOUTSIDEHIGHLIGHTCOLOR 30
#define PROP_CAL_THREEDOUTSIDESHADOWCOLOR 31
#define PROP_CAL_THREEDOUTSIDESTYLE 29
#define PROP_CAL_THREEDOUTSIDEWIDTH 32
#define PROP_CAL_TOP 3
#define PROP_CAL_VISIBLE 20
#define PROP_CAL_WEEKDAYHDR 45
#define PROP_CAL_WIDTH 4
#define PROP_CAL_YEAR 48
#define PROP_CAL_YEARHEADERSTYLE 63
#define PROP_CAL_HWND 64

#ifdef fpMFC


// AwareCalendar event macros
#define CAL_CHANGE_OLDMONTH(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,6)
#define CAL_CHANGE_OLDDAY(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,5)
#define CAL_CHANGE_OLDYEAR(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,4)
#define CAL_CHANGE_NEWMONTH(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define CAL_CHANGE_NEWDAY(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define CAL_CHANGE_NEWYEAR(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CAL_CHANGE_CANCEL(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CAL_DBLCLICK_CURRENTMONTH(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define CAL_DBLCLICK_CURRENTDAY(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CAL_DBLCLICK_CURRENTYEAR(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CAL_KEYDOWN_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CAL_KEYDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CAL_KEYPRESS_KEYASCII(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CAL_KEYUP_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CAL_KEYUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)

#elif fpOWL


// AwareCalendar event macros
#define CAL_CHANGE_OLDMONTH(event) VBX_EVENTARGNUM(event,int,0)
#define CAL_CHANGE_OLDDAY(event) VBX_EVENTARGNUM(event,int,1)
#define CAL_CHANGE_OLDYEAR(event) VBX_EVENTARGNUM(event,int,2)
#define CAL_CHANGE_NEWMONTH(event) VBX_EVENTARGNUM(event,int,3)
#define CAL_CHANGE_NEWDAY(event) VBX_EVENTARGNUM(event,int,4)
#define CAL_CHANGE_NEWYEAR(event) VBX_EVENTARGNUM(event,int,5)
#define CAL_CHANGE_CANCEL(event) VBX_EVENTARGNUM(event,int,6)
#define CAL_DBLCLICK_CURRENTMONTH(event) VBX_EVENTARGNUM(event,int,0)
#define CAL_DBLCLICK_CURRENTDAY(event) VBX_EVENTARGNUM(event,int,1)
#define CAL_DBLCLICK_CURRENTYEAR(event) VBX_EVENTARGNUM(event,int,2)
#define CAL_KEYDOWN_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define CAL_KEYDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CAL_KEYPRESS_KEYASCII(event) VBX_EVENTARGNUM(event,int,0)
#define CAL_KEYUP_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define CAL_KEYUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)

#endif


// AwareCalendar property values
#define CAL_BORDERSTYLE_NO_BORDER 0
#define CAL_BORDERSTYLE_SINGLE_LINE 1
#define CAL_BORDERSTYLE_ROUNDED 2
#define CAL_BORDERSTYLE_DASH 3
#define CAL_BORDERSTYLE_DOT 4
#define CAL_BORDERSTYLE_DASH_DOT 5
#define CAL_BORDERSTYLE_DASH_DOT_DOT 6
#define CAL_ELEMENT_DEFAULT 0
#define CAL_ELEMENT_MONTH 1
#define CAL_ELEMENT_DAYS 2
#define CAL_ELEMENT_YEAR 3
#define CAL_ELEMENT_WEEKDAYS 4
#define CAL_ELEMENT_WEEKDAYINDEX 5
#define CAL_ELEMENT_DAYINDEX 6
#define CAL_ELEMENT_DROPDOWN 7
#define CAL_ELEMENT3DSTYLE_OFF 0
#define CAL_ELEMENT3DSTYLE_IN 1
#define CAL_ELEMENT3DSTYLE_OUT 2
#define CAL_ELEMENT3DTEXT_NONE 0
#define CAL_ELEMENT3DTEXT_UP 1
#define CAL_ELEMENT3DTEXT_DOWN 2
#define CAL_ELEMENT3DTEXT_MORE_UP 3
#define CAL_ELEMENT3DTEXT_MORE_DOWN 4
#define CAL_FIRSTDAYOFWEEK_SUNDAY 0
#define CAL_FIRSTDAYOFWEEK_MONDAY 1
#define CAL_GRAYAREASTYLE_SOLID 0
#define CAL_GRAYAREASTYLE_PINSTRIPE 1
#define CAL_GRAYAREASTYLE_SHOW_PREV_NEXT 2
#define CAL_HEADERSTYLE_NONE 0
#define CAL_HEADERSTYLE_1_LINE 1
#define CAL_HEADERSTYLE_2_LINE 2
#define CAL_MONTHHEADERSTYLE_NONE 0
#define CAL_MONTHHEADERSTYLE_SCROLL 1
#define CAL_MONTHHEADERSTYLE_DROP_DOWN 2
#define CAL_MOUSEPOINTER_DEFAULT 0
#define CAL_MOUSEPOINTER_ARROW 1
#define CAL_MOUSEPOINTER_CROSS 2
#define CAL_MOUSEPOINTER_I_BEAM 3
#define CAL_MOUSEPOINTER_ICON 4
#define CAL_MOUSEPOINTER_SIZE 5
#define CAL_MOUSEPOINTER_SIZE_NE_SW 6
#define CAL_MOUSEPOINTER_SIZE_N_S 7
#define CAL_MOUSEPOINTER_SIZE_NW_SE 8
#define CAL_MOUSEPOINTER_SIZE_W_E 9
#define CAL_MOUSEPOINTER_UP_ARROW 10
#define CAL_MOUSEPOINTER_HOURGLASS 11
#define CAL_MOUSEPOINTER_NO_DROP 12
#define CAL_THREEDINSIDESTYLE_NONE 0
#define CAL_THREEDINSIDESTYLE_LOWERED 1
#define CAL_THREEDINSIDESTYLE_RAISED 2
#define CAL_THREEDOUTSIDESTYLE_NONE 0
#define CAL_THREEDOUTSIDESTYLE_LOWERED 1
#define CAL_THREEDOUTSIDESTYLE_RAISED 2
#define CAL_WEEKDAYHDR_NONE 0
#define CAL_WEEKDAYHDR_1_LETTER 1
#define CAL_WEEKDAYHDR_2_LETTERS 2
#define CAL_WEEKDAYHDR_3_LETTERS 3
#define CAL_WEEKDAYHDR_LONG_WORD 4
#define CAL_YEARHEADERSTYLE_NONE 0
#define CAL_YEARHEADERSTYLE_SCROLL 1
#define CAL_YEARHEADERSTYLE_DROP_DOWN 2

// Class representing AwareClock10 control in AWARECC.VBX file

class CAwareClock : public CVBControl
{
  public:

#ifdef fpMFC

    BOOL Create(DWORD dwStyle, const RECT& rect,
                CWnd* pParentWnd, UINT nID,
                CFile* pFile = NULL, BOOL bAutoDelete = FALSE)
    {
      return CVBControl::Create(
               "AWARECC.VBX;AwareClock10;",
               dwStyle, rect,
               pParentWnd, nID,
               pFile, bAutoDelete
             );
    }

#elif fpOWL

    CAwareClock(TWindow* parent, int id,
        const char far* title,
        int x, int y, int w, int h,
        long initLen = 0, void far* initData = 0,
        TModule* module = 0)
    : CVBControl(parent, id, "AWARECC.VBX", "AwareClock10",
          title, x, y, w, h, initLen, initData, module) {};

    CAwareClock(TWindow* parent, int resourceId, TModule* module = 0)
    : CVBControl(parent, resourceId, module) {};

#endif

    CStringProperty About() {return CStringProperty(this,87);}
    CStringProperty AlarmTime() {return CStringProperty(this,43);}
    CEnumProperty AllowMoveHand() {return CEnumProperty(this,64);}
    CEnumProperty AnalogFace() {return CEnumProperty(this,58);}
    CBoolProperty AnalogHourFill() {return CBoolProperty(this,71);}
    CColorProperty AnalogHourFillColor() {return CColorProperty(this,70);}
    CFloatProperty AnalogHourHandAngle(int i) {return CFloatProperty(this,78,i);}
    CColorProperty AnalogHourHandColor() {return CColorProperty(this,69);}
    CShortProperty AnalogHourHandPts() {return CShortProperty(this,80);}
    CShortProperty AnalogHourHandRadius(int i) {return CShortProperty(this,79,i);}
    CBoolProperty AnalogMinFill() {return CBoolProperty(this,74);}
    CColorProperty AnalogMinFillColor() {return CColorProperty(this,73);}
    CFloatProperty AnalogMinHandAngle(int i) {return CFloatProperty(this,81,i);}
    CColorProperty AnalogMinHandColor() {return CColorProperty(this,72);}
    CShortProperty AnalogMinHandPts() {return CShortProperty(this,83);}
    CShortProperty AnalogMinHandRadius(int i) {return CShortProperty(this,82,i);}
    CBoolProperty AnalogSecFill() {return CBoolProperty(this,77);}
    CColorProperty AnalogSecFillColor() {return CColorProperty(this,76);}
    CFloatProperty AnalogSecHandAngle(int i) {return CFloatProperty(this,84,i);}
    CColorProperty AnalogSecHandColor() {return CColorProperty(this,75);}
    CShortProperty AnalogSecHandPts() {return CShortProperty(this,86);}
    CShortProperty AnalogSecHandRadius(int i) {return CShortProperty(this,85,i);}
    CColorProperty AnalogTickFillColor() {return CColorProperty(this,68);}
    CColorProperty AnalogTickShadowColor() {return CColorProperty(this,67);}
    CEnumProperty AnalogTicks() {return CEnumProperty(this,59);}
    CBoolProperty AutoSet() {return CBoolProperty(this,44);}
    CBoolProperty AutoUpdate() {return CBoolProperty(this,45);}
    CColorProperty BackColor() {return CColorProperty(this,2);}
    CColorProperty BorderColor() {return CColorProperty(this,37);}
    CColorProperty BorderGrayAreaColor() {return CColorProperty(this,88);}
    CEnumProperty BorderStyle() {return CEnumProperty(this,36);}
    CShortProperty BorderWidth() {return CShortProperty(this,38);}
    CEnumProperty ClockMode() {return CEnumProperty(this,46);}
    CEnumProperty ClockStyle() {return CEnumProperty(this,47);}
    CStringProperty CurrentTime() {return CStringProperty(this,48);}
    CColorProperty DropShadowColor() {return CColorProperty(this,41);}
    CShortProperty DropShadowWidth() {return CShortProperty(this,42);}
    CStringProperty ElapsedTime() {return CStringProperty(this,49);}
    CBoolProperty Enabled() {return CBoolProperty(this,20);}
    CBoolProperty FontBold() {return CBoolProperty(this,10);}
    CBoolProperty FontItalic() {return CBoolProperty(this,11);}
    CStringProperty FontName() {return CStringProperty(this,9);}
    CFloatProperty FontSize() {return CFloatProperty(this,14);}
    CBoolProperty FontStrikethru() {return CBoolProperty(this,12);}
    CBoolProperty FontUnderline() {return CBoolProperty(this,13);}
    CColorProperty ForeColor() {return CColorProperty(this,3);}
    CLongProperty Height() {return CLongProperty(this,7);}
    CShortProperty Hour() {return CShortProperty(this,89);}
    CShortProperty Index() {return CShortProperty(this,1);}
    CStringProperty Interval() {return CStringProperty(this,50);}
    CEnumProperty LeadZero() {return CEnumProperty(this,54);}
    CLongProperty Left() {return CLongProperty(this,4);}
    CShortProperty Min() {return CShortProperty(this,90);}
    CEnumProperty MousePointer() {return CEnumProperty(this,8);}
    CStringProperty Name() {return CStringProperty(this,0);}
    CBoolProperty OnFocusInvert3D() {return CBoolProperty(this,39);}
    CBoolProperty OnFocusShadow() {return CBoolProperty(this,40);}
    CShortProperty Parent() {return CShortProperty(this,19);}
    CBoolProperty Redraw() {return CBoolProperty(this,66);}
    CShortProperty Sec() {return CShortProperty(this,91);}
    CBoolProperty Seconds() {return CBoolProperty(this,51);}
    CStringProperty Separator() {return CStringProperty(this,55);}
    CStringProperty StartTime() {return CStringProperty(this,52);}
    CShortProperty TabIndex() {return CShortProperty(this,15);}
    CShortProperty TabStop() {return CShortProperty(this,16);}
    CStringProperty Tag() {return CStringProperty(this,21);}
    CShortProperty ThreeDFrameWidth() {return CShortProperty(this,35);}
    CColorProperty ThreeDInsideHighlightColor() {return CColorProperty(this,28);}
    CColorProperty ThreeDInsideShadowColor() {return CColorProperty(this,29);}
    CEnumProperty ThreeDInsideStyle() {return CEnumProperty(this,27);}
    CShortProperty ThreeDInsideWidth() {return CShortProperty(this,30);}
    CColorProperty ThreeDOutsideHighlightColor() {return CColorProperty(this,32);}
    CColorProperty ThreeDOutsideShadowColor() {return CColorProperty(this,33);}
    CEnumProperty ThreeDOutsideStyle() {return CEnumProperty(this,31);}
    CShortProperty ThreeDOutsideWidth() {return CShortProperty(this,34);}
    CEnumProperty ThreeDText() {return CEnumProperty(this,60);}
    CColorProperty ThreeDTextHighlightColor() {return CColorProperty(this,61);}
    CShortProperty ThreeDTextOffset() {return CShortProperty(this,63);}
    CColorProperty ThreeDTextShadowColor() {return CColorProperty(this,62);}
    CEnumProperty TimeScale() {return CEnumProperty(this,53);}
    CStringProperty TimeString1159() {return CStringProperty(this,56);}
    CStringProperty TimeString2359() {return CStringProperty(this,57);}
    CLongProperty Top() {return CLongProperty(this,5);}
    CBoolProperty Visible() {return CBoolProperty(this,22);}
    CLongProperty Width() {return CLongProperty(this,6);}
    CShortProperty hWnd() {return CShortProperty(this,65);}

};

#ifdef fpMFC

inline void AFXAPI
DDX_VBControl(CDataExchange* pDX, int nIDC, CAwareClock*& rpAwareClock)
{
  CVBControl* pControl = (CVBControl*)rpAwareClock;
  DDX_VBControl(pDX, nIDC, pControl);
  rpAwareClock = (CAwareClock*)pControl;
}
#endif

// AwareClock event indices
#define EVENT_CLK_ALARM 0
#define EVENT_CLK_CHANGE 1
#define EVENT_CLK_CLICK 2
#define EVENT_CLK_DBLCLICK 3
#define EVENT_CLK_GOTFOUCS 6
#define EVENT_CLK_KEYDOWN 7
#define EVENT_CLK_KEYPRESS 8
#define EVENT_CLK_KEYUP 9
#define EVENT_CLK_LOSTFOCUS 10
#define EVENT_CLK_MOUSEDOWN 11
#define EVENT_CLK_MOUSEMOVE 12
#define EVENT_CLK_MOUSEUP 13
#define EVENT_CLK_MOVEHAND 14
#define EVENT_CLK_TIMER 15

// AwareClock property indices
#define PROP_CLK_ABOUT 87
#define PROP_CLK_ALARMTIME 43
#define PROP_CLK_ALLOWMOVEHAND 64
#define PROP_CLK_ANALOGFACE 58
#define PROP_CLK_ANALOGHOURFILL 71
#define PROP_CLK_ANALOGHOURFILLCOLOR 70
#define PROP_CLK_ANALOGHOURHANDANGLE 78
#define PROP_CLK_ANALOGHOURHANDCOLOR 69
#define PROP_CLK_ANALOGHOURHANDPTS 80
#define PROP_CLK_ANALOGHOURHANDRADIUS 79
#define PROP_CLK_ANALOGMINFILL 74
#define PROP_CLK_ANALOGMINFILLCOLOR 73
#define PROP_CLK_ANALOGMINHANDANGLE 81
#define PROP_CLK_ANALOGMINHANDCOLOR 72
#define PROP_CLK_ANALOGMINHANDPTS 83
#define PROP_CLK_ANALOGMINHANDRADIUS 82
#define PROP_CLK_ANALOGSECFILL 77
#define PROP_CLK_ANALOGSECFILLCOLOR 76
#define PROP_CLK_ANALOGSECHANDANGLE 84
#define PROP_CLK_ANALOGSECHANDCOLOR 75
#define PROP_CLK_ANALOGSECHANDPTS 86
#define PROP_CLK_ANALOGSECHANDRADIUS 85
#define PROP_CLK_ANALOGTICKFILLCOLOR 68
#define PROP_CLK_ANALOGTICKSHADOWCOLOR 67
#define PROP_CLK_ANALOGTICKS 59
#define PROP_CLK_AUTOSET 44
#define PROP_CLK_AUTOUPDATE 45
#define PROP_CLK_BACKCOLOR 2
#define PROP_CLK_BORDERCOLOR 37
#define PROP_CLK_BORDERGRAYAREACOLOR 88
#define PROP_CLK_BORDERSTYLE 36
#define PROP_CLK_BORDERWIDTH 38
#define PROP_CLK_CLOCKMODE 46
#define PROP_CLK_CLOCKSTYLE 47
#define PROP_CLK_CURRENTTIME 48
#define PROP_CLK_DROPSHADOWCOLOR 41
#define PROP_CLK_DROPSHADOWWIDTH 42
#define PROP_CLK_ELAPSEDTIME 49
#define PROP_CLK_ENABLED 20
#define PROP_CLK_FONTBOLD 10
#define PROP_CLK_FONTITALIC 11
#define PROP_CLK_FONTNAME 9
#define PROP_CLK_FONTSIZE 14
#define PROP_CLK_FONTSTRIKETHRU 12
#define PROP_CLK_FONTUNDERLINE 13
#define PROP_CLK_FORECOLOR 3
#define PROP_CLK_HEIGHT 7
#define PROP_CLK_HOUR 89
#define PROP_CLK_INDEX 1
#define PROP_CLK_INTERVAL 50
#define PROP_CLK_LEADZERO 54
#define PROP_CLK_LEFT 4
#define PROP_CLK_MIN 90
#define PROP_CLK_MOUSEPOINTER 8
#define PROP_CLK_NAME 0
#define PROP_CLK_ONFOCUSINVERT3D 39
#define PROP_CLK_ONFOCUSSHADOW 40
#define PROP_CLK_PARENT 19
#define PROP_CLK_REDRAW 66
#define PROP_CLK_SEC 91
#define PROP_CLK_SECONDS 51
#define PROP_CLK_SEPARATOR 55
#define PROP_CLK_STARTTIME 52
#define PROP_CLK_TABINDEX 15
#define PROP_CLK_TABSTOP 16
#define PROP_CLK_TAG 21
#define PROP_CLK_THREEDFRAMEWIDTH 35
#define PROP_CLK_THREEDINSIDEHIGHLIGHTCOLOR 28
#define PROP_CLK_THREEDINSIDESHADOWCOLOR 29
#define PROP_CLK_THREEDINSIDESTYLE 27
#define PROP_CLK_THREEDINSIDEWIDTH 30
#define PROP_CLK_THREEDOUTSIDEHIGHLIGHTCOLOR 32
#define PROP_CLK_THREEDOUTSIDESHADOWCOLOR 33
#define PROP_CLK_THREEDOUTSIDESTYLE 31
#define PROP_CLK_THREEDOUTSIDEWIDTH 34
#define PROP_CLK_THREEDTEXT 60
#define PROP_CLK_THREEDTEXTHIGHLIGHTCOLOR 61
#define PROP_CLK_THREEDTEXTOFFSET 63
#define PROP_CLK_THREEDTEXTSHADOWCOLOR 62
#define PROP_CLK_TIMESCALE 53
#define PROP_CLK_TIMESTRING1159 56
#define PROP_CLK_TIMESTRING2359 57
#define PROP_CLK_TOP 5
#define PROP_CLK_VISIBLE 22
#define PROP_CLK_WIDTH 6
#define PROP_CLK_HWND 65

#ifdef fpMFC


// AwareClock event macros
#define CLK_CLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CLK_DBLCLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CLK_KEYDOWN_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CLK_KEYDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CLK_KEYPRESS_KEYASCII(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define CLK_KEYUP_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CLK_KEYUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CLK_MOUSEDOWN_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define CLK_MOUSEDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define CLK_MOUSEDOWN_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CLK_MOUSEDOWN_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CLK_MOUSEMOVE_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define CLK_MOUSEMOVE_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define CLK_MOUSEMOVE_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CLK_MOUSEMOVE_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CLK_MOUSEUP_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define CLK_MOUSEUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define CLK_MOUSEUP_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CLK_MOUSEUP_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CLK_MOVEHAND_OLDHOUR(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,5)
#define CLK_MOVEHAND_OLDMIN(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,4)
#define CLK_MOVEHAND_OLDSEC(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define CLK_MOVEHAND_NEWHOUR(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define CLK_MOVEHAND_NEWMIN(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CLK_MOVEHAND_NEWSEC(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CLK_TIMER_AUTOUPDATE(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)

#elif fpOWL


// AwareClock event macros
#define CLK_CLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define CLK_DBLCLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define CLK_KEYDOWN_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define CLK_KEYDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CLK_KEYPRESS_KEYASCII(event) VBX_EVENTARGNUM(event,int,0)
#define CLK_KEYUP_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define CLK_KEYUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CLK_MOUSEDOWN_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define CLK_MOUSEDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CLK_MOUSEDOWN_X(event) VBX_EVENTARGNUM(event,float,2)
#define CLK_MOUSEDOWN_Y(event) VBX_EVENTARGNUM(event,float,3)
#define CLK_MOUSEMOVE_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define CLK_MOUSEMOVE_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CLK_MOUSEMOVE_X(event) VBX_EVENTARGNUM(event,float,2)
#define CLK_MOUSEMOVE_Y(event) VBX_EVENTARGNUM(event,float,3)
#define CLK_MOUSEUP_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define CLK_MOUSEUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CLK_MOUSEUP_X(event) VBX_EVENTARGNUM(event,float,2)
#define CLK_MOUSEUP_Y(event) VBX_EVENTARGNUM(event,float,3)
#define CLK_MOVEHAND_OLDHOUR(event) VBX_EVENTARGNUM(event,int,0)
#define CLK_MOVEHAND_OLDMIN(event) VBX_EVENTARGNUM(event,int,1)
#define CLK_MOVEHAND_OLDSEC(event) VBX_EVENTARGNUM(event,int,2)
#define CLK_MOVEHAND_NEWHOUR(event) VBX_EVENTARGNUM(event,int,3)
#define CLK_MOVEHAND_NEWMIN(event) VBX_EVENTARGNUM(event,int,4)
#define CLK_MOVEHAND_NEWSEC(event) VBX_EVENTARGNUM(event,int,5)
#define CLK_TIMER_AUTOUPDATE(event) VBX_EVENTARGNUM(event,int,0)

#endif


// AwareClock property values
#define CLK_ALLOWMOVEHAND_NO_MOVEMENT 0
#define CLK_ALLOWMOVEHAND_LEFT_BUTTON 1
#define CLK_ALLOWMOVEHAND_RIGHT_BUTTON 2
#define CLK_ANALOGFACE_NO_TEXT 0
#define CLK_ANALOGFACE_4_ROMAN_NUMERALS 1
#define CLK_ANALOGFACE_12_ROMAN_NUMERALS 2
#define CLK_ANALOGFACE_4_ARABIC_NUMBERS 3
#define CLK_ANALOGFACE_12_ARABIC_NUMBERS 4
#define CLK_ANALOGTICKS_NONE 0
#define CLK_ANALOGTICKS_HOUR 1
#define CLK_ANALOGTICKS_MINUTE 2
#define CLK_ANALOGTICKS_BOTH 3
#define CLK_BORDERSTYLE_NO_BORDER 0
#define CLK_BORDERSTYLE_SINGLE_LINE 1
#define CLK_BORDERSTYLE_ROUNDED 2
#define CLK_BORDERSTYLE_DASH 3
#define CLK_BORDERSTYLE_DOT 4
#define CLK_BORDERSTYLE_DASH_DOT 5
#define CLK_BORDERSTYLE_DASH_DOT_DOT 6
#define CLK_CLOCKMODE_INTL 0
#define CLK_CLOCKMODE_12_HOUR 1
#define CLK_CLOCKMODE_24_HOUR 2
#define CLK_CLOCKMODE_STOPWATCH 3
#define CLK_CLOCKSTYLE_DEFAULT 0
#define CLK_CLOCKSTYLE_DIGITAL 1
#define CLK_CLOCKSTYLE_ANALOG 2
#define CLK_LEADZERO_INTL 0
#define CLK_LEADZERO_NO_LEADING_ZERO 1
#define CLK_LEADZERO_LEADING_ZERO 2
#define CLK_MOUSEPOINTER_DEFAULT 0
#define CLK_MOUSEPOINTER_ARROW 1
#define CLK_MOUSEPOINTER_CROSS 2
#define CLK_MOUSEPOINTER_I_BEAM 3
#define CLK_MOUSEPOINTER_ICON 4
#define CLK_MOUSEPOINTER_SIZE 5
#define CLK_MOUSEPOINTER_SIZE_NE_SW 6
#define CLK_MOUSEPOINTER_SIZE_N_S 7
#define CLK_MOUSEPOINTER_SIZE_NW_SE 8
#define CLK_MOUSEPOINTER_SIZE_W_E 9
#define CLK_MOUSEPOINTER_UP_ARROW 10
#define CLK_MOUSEPOINTER_HOURGLASS 11
#define CLK_MOUSEPOINTER_NO_DROP 12
#define CLK_THREEDINSIDESTYLE_NONE 0
#define CLK_THREEDINSIDESTYLE_LOWERED 1
#define CLK_THREEDINSIDESTYLE_RAISED 2
#define CLK_THREEDOUTSIDESTYLE_NONE 0
#define CLK_THREEDOUTSIDESTYLE_LOWERED 1
#define CLK_THREEDOUTSIDESTYLE_RAISED 2
#define CLK_THREEDTEXT_NONE 0
#define CLK_THREEDTEXT_ETCHED 1
#define CLK_THREEDTEXT_EMBOSSED 2
#define CLK_THREEDTEXT_ETCHED_W_SHADING 3
#define CLK_THREEDTEXT_EMBOSSED_W_SHADING 4
#define CLK_TIMESCALE_HH_MM_SS_NN 0
#define CLK_TIMESCALE_HOURS 1
#define CLK_TIMESCALE_MINUTES 2
#define CLK_TIMESCALE_SECONDS 3
#define CLK_TIMESCALE_MILLISECONDS 4

// Class representing AwareMemo10 control in AWAREMM.VBX file

class CAwareMemo : public CVBControl
{
  public:

#ifdef fpMFC

    BOOL Create(DWORD dwStyle, const RECT& rect,
                CWnd* pParentWnd, UINT nID,
                CFile* pFile = NULL, BOOL bAutoDelete = FALSE)
    {
      return CVBControl::Create(
               "AWAREMM.VBX;AwareMemo10;",
               dwStyle, rect,
               pParentWnd, nID,
               pFile, bAutoDelete
             );
    }

#elif fpOWL

    CAwareMemo(TWindow* parent, int id,
        const char far* title,
        int x, int y, int w, int h,
        long initLen = 0, void far* initData = 0,
        TModule* module = 0)
    : CVBControl(parent, id, "AWAREMM.VBX", "AwareMemo10",
          title, x, y, w, h, initLen, initData, module) {};

    CAwareMemo(TWindow* parent, int resourceId, TModule* module = 0)
    : CVBControl(parent, resourceId, module) {};

#endif

    CStringProperty About() {return CStringProperty(this,74);}
    CBoolProperty AllowNull() {return CBoolProperty(this,45);}
    CBoolProperty AutoAdvance() {return CBoolProperty(this,47);}
    CBoolProperty AutoBeep() {return CBoolProperty(this,48);}
    CColorProperty BackColor() {return CColorProperty(this,2);}
    CColorProperty BorderColor() {return CColorProperty(this,37);}
    CColorProperty BorderGrayAreaColor() {return CColorProperty(this,75);}
    CEnumProperty BorderStyle() {return CEnumProperty(this,36);}
    CShortProperty BorderWidth() {return CShortProperty(this,38);}
    CEnumProperty CaretInsert() {return CEnumProperty(this,49);}
    CEnumProperty CaretOverWrite() {return CEnumProperty(this,50);}
    CEnumProperty ControlType() {return CEnumProperty(this,60);}
    CColorProperty DropShadowColor() {return CColorProperty(this,41);}
    CShortProperty DropShadowWidth() {return CShortProperty(this,42);}
    CBoolProperty Enabled() {return CBoolProperty(this,19);}
    CBoolProperty FontBold() {return CBoolProperty(this,10);}
    CBoolProperty FontItalic() {return CBoolProperty(this,11);}
    CStringProperty FontName() {return CStringProperty(this,9);}
    CFloatProperty FontSize() {return CFloatProperty(this,14);}
    CBoolProperty FontStrikethru() {return CBoolProperty(this,12);}
    CBoolProperty FontUnderline() {return CBoolProperty(this,13);}
    CColorProperty ForeColor() {return CColorProperty(this,3);}
    CLongProperty Height() {return CLongProperty(this,7);}
    CBoolProperty HideSelection() {return CBoolProperty(this,51);}
    CShortProperty Index() {return CShortProperty(this,1);}
    CBoolProperty IsNull() {return CBoolProperty(this,53);}
    CLongProperty Left() {return CLongProperty(this,4);}
    CLongProperty LineCount() {return CLongProperty(this,67);}
    CLongProperty LineIndex() {return CLongProperty(this,66);}
    CLongProperty LineLimit() {return CLongProperty(this,68);}
    CEnumProperty MousePointer() {return CEnumProperty(this,8);}
    CStringProperty Name() {return CStringProperty(this,0);}
    CEnumProperty NoSpecialKeys() {return CEnumProperty(this,46);}
    CColorProperty NullColor() {return CColorProperty(this,54);}
    CBoolProperty OnFocusInvert3D() {return CBoolProperty(this,39);}
    CBoolProperty OnFocusNoSelect() {return CBoolProperty(this,55);}
    CEnumProperty OnFocusPosition() {return CEnumProperty(this,56);}
    CBoolProperty OnFocusShadow() {return CBoolProperty(this,40);}
    CLongProperty PageWidth() {return CLongProperty(this,70);}
    CShortProperty Parent() {return CShortProperty(this,20);}
    CBoolProperty Redraw() {return CBoolProperty(this,73);}
    CEnumProperty ScrollBars() {return CEnumProperty(this,69);}
    CColorProperty SelBackColor() {return CColorProperty(this,71);}
    CColorProperty SelForeColor() {return CColorProperty(this,72);}
    CLongProperty SelLength() {return CLongProperty(this,57);}
    CEnumProperty SelMode() {return CEnumProperty(this,65);}
    CLongProperty SelStart() {return CLongProperty(this,58);}
    CStringProperty SelText() {return CStringProperty(this,59);}
    CBoolProperty ShowEOL() {return CBoolProperty(this,63);}
    CShortProperty TabIndex() {return CShortProperty(this,15);}
    CShortProperty TabStop() {return CShortProperty(this,16);}
    CStringProperty Tag() {return CStringProperty(this,21);}
    CStringProperty Text() {return CStringProperty(this,61);}
    CEnumProperty TextMode() {return CEnumProperty(this,64);}
    CShortProperty ThreeDFrameWidth() {return CShortProperty(this,35);}
    CColorProperty ThreeDInsideHighlightColor() {return CColorProperty(this,28);}
    CColorProperty ThreeDInsideShadowColor() {return CColorProperty(this,29);}
    CEnumProperty ThreeDInsideStyle() {return CEnumProperty(this,27);}
    CShortProperty ThreeDInsideWidth() {return CShortProperty(this,30);}
    CColorProperty ThreeDOutsideHighlightColor() {return CColorProperty(this,32);}
    CColorProperty ThreeDOutsideShadowColor() {return CColorProperty(this,33);}
    CEnumProperty ThreeDOutsideStyle() {return CEnumProperty(this,31);}
    CShortProperty ThreeDOutsideWidth() {return CShortProperty(this,34);}
    CLongProperty Top() {return CLongProperty(this,5);}
    CBoolProperty Visible() {return CBoolProperty(this,22);}
    CLongProperty Width() {return CLongProperty(this,6);}
    CBoolProperty WordWrap() {return CBoolProperty(this,62);}
    CShortProperty hWnd() {return CShortProperty(this,52);}

};

#ifdef fpMFC

inline void AFXAPI
DDX_VBControl(CDataExchange* pDX, int nIDC, CAwareMemo*& rpAwareMemo)
{
  CVBControl* pControl = (CVBControl*)rpAwareMemo;
  DDX_VBControl(pDX, nIDC, pControl);
  rpAwareMemo = (CAwareMemo*)pControl;
}
#endif

// AwareMemo event indices
#define EVENT_MEM_ADVANCE 0
#define EVENT_MEM_CHANGE 1
#define EVENT_MEM_CHANGEMODE 2
#define EVENT_MEM_CLICK 3
#define EVENT_MEM_DBLCLICK 4
#define EVENT_MEM_GOTFOUCS 7
#define EVENT_MEM_KEYDOWN 8
#define EVENT_MEM_KEYPRESS 9
#define EVENT_MEM_KEYUP 10
#define EVENT_MEM_LOSTFOCUS 11
#define EVENT_MEM_MOUSEDOWN 12
#define EVENT_MEM_MOUSEMOVE 13
#define EVENT_MEM_MOUSEUP 14
#define EVENT_MEM_USERERROR 15

// AwareMemo property indices
#define PROP_MEM_ABOUT 74
#define PROP_MEM_ACTION 43
#define PROP_MEM_ALLOWNULL 45
#define PROP_MEM_AUTOADVANCE 47
#define PROP_MEM_AUTOBEEP 48
#define PROP_MEM_BACKCOLOR 2
#define PROP_MEM_BORDERCOLOR 37
#define PROP_MEM_BORDERGRAYAREACOLOR 75
#define PROP_MEM_BORDERSTYLE 36
#define PROP_MEM_BORDERWIDTH 38
#define PROP_MEM_CARETINSERT 49
#define PROP_MEM_CARETOVERWRITE 50
#define PROP_MEM_CONTROLTYPE 60
#define PROP_MEM_DROPSHADOWCOLOR 41
#define PROP_MEM_DROPSHADOWWIDTH 42
#define PROP_MEM_ENABLED 19
#define PROP_MEM_FONTBOLD 10
#define PROP_MEM_FONTITALIC 11
#define PROP_MEM_FONTNAME 9
#define PROP_MEM_FONTSIZE 14
#define PROP_MEM_FONTSTRIKETHRU 12
#define PROP_MEM_FONTUNDERLINE 13
#define PROP_MEM_FORECOLOR 3
#define PROP_MEM_HEIGHT 7
#define PROP_MEM_HIDESELECTION 51
#define PROP_MEM_INDEX 1
#define PROP_MEM_ISNULL 53
#define PROP_MEM_LEFT 4
#define PROP_MEM_LINECOUNT 67
#define PROP_MEM_LINEINDEX 66
#define PROP_MEM_LINELIMIT 68
#define PROP_MEM_MOUSEPOINTER 8
#define PROP_MEM_NAME 0
#define PROP_MEM_NOSPECIALKEYS 46
#define PROP_MEM_NULLCOLOR 54
#define PROP_MEM_ONFOCUSINVERT3D 39
#define PROP_MEM_ONFOCUSNOSELECT 55
#define PROP_MEM_ONFOCUSPOSITION 56
#define PROP_MEM_ONFOCUSSHADOW 40
#define PROP_MEM_PAGEWIDTH 70
#define PROP_MEM_PARENT 20
#define PROP_MEM_REDRAW 73
#define PROP_MEM_SCROLLBARS 69
#define PROP_MEM_SELBACKCOLOR 71
#define PROP_MEM_SELFORECOLOR 72
#define PROP_MEM_SELLENGTH 57
#define PROP_MEM_SELMODE 65
#define PROP_MEM_SELSTART 58
#define PROP_MEM_SELTEXT 59
#define PROP_MEM_SHOWEOL 63
#define PROP_MEM_TABINDEX 15
#define PROP_MEM_TABSTOP 16
#define PROP_MEM_TAG 21
#define PROP_MEM_TEXT 61
#define PROP_MEM_TEXTMODE 64
#define PROP_MEM_THREEDFRAMEWIDTH 35
#define PROP_MEM_THREEDINSIDEHIGHLIGHTCOLOR 28
#define PROP_MEM_THREEDINSIDESHADOWCOLOR 29
#define PROP_MEM_THREEDINSIDESTYLE 27
#define PROP_MEM_THREEDINSIDEWIDTH 30
#define PROP_MEM_THREEDOUTSIDEHIGHLIGHTCOLOR 32
#define PROP_MEM_THREEDOUTSIDESHADOWCOLOR 33
#define PROP_MEM_THREEDOUTSIDESTYLE 31
#define PROP_MEM_THREEDOUTSIDEWIDTH 34
#define PROP_MEM_TOP 5
#define PROP_MEM_VISIBLE 22
#define PROP_MEM_WIDTH 6
#define PROP_MEM_WORDWRAP 62
#define PROP_MEM_HWND 52

#ifdef fpMFC


// AwareMemo event macros
#define MEM_ADVANCE_DIRECTION(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define MEM_ADVANCE_AUTOADVANCE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MEM_CHANGEMODE_EDITMODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MEM_CLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MEM_DBLCLICK_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MEM_KEYDOWN_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define MEM_KEYDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MEM_KEYPRESS_KEYASCII(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MEM_KEYUP_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,1)
#define MEM_KEYUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define MEM_MOUSEDOWN_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,3)
#define MEM_MOUSEDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,2)
#define MEM_MOUSEDOWN_X(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,1)
#define MEM_MOUSEDOWN_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define MEM_MOUSEMOVE_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define MEM_MOUSEMOVE_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define MEM_MOUSEMOVE_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define MEM_MOUSEMOVE_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MEM_MOUSEUP_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define MEM_MOUSEUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define MEM_MOUSEUP_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define MEM_MOUSEUP_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define MEM_USERERROR_ERRORCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,1)
#define MEM_USERERROR_AUTOBEEP(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)

#elif fpOWL


// AwareMemo event macros
#define MEM_ADVANCE_DIRECTION(event) VBX_EVENTARGNUM(event,int,0)
#define MEM_ADVANCE_AUTOADVANCE(event) VBX_EVENTARGNUM(event,int,1)
#define MEM_CHANGEMODE_EDITMODE(event) VBX_EVENTARGNUM(event,int,0)
#define MEM_CLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define MEM_DBLCLICK_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define MEM_KEYDOWN_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define MEM_KEYDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define MEM_KEYPRESS_KEYASCII(event) VBX_EVENTARGNUM(event,int,0)
#define MEM_KEYUP_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define MEM_KEYUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define MEM_MOUSEDOWN_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define MEM_MOUSEDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define MEM_MOUSEDOWN_X(event) VBX_EVENTARGNUM(event,float,2)
#define MEM_MOUSEDOWN_Y(event) VBX_EVENTARGNUM(event,float,3)
#define MEM_MOUSEMOVE_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define MEM_MOUSEMOVE_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define MEM_MOUSEMOVE_X(event) VBX_EVENTARGNUM(event,float,2)
#define MEM_MOUSEMOVE_Y(event) VBX_EVENTARGNUM(event,float,3)
#define MEM_MOUSEUP_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define MEM_MOUSEUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define MEM_MOUSEUP_X(event) VBX_EVENTARGNUM(event,float,2)
#define MEM_MOUSEUP_Y(event) VBX_EVENTARGNUM(event,float,3)
#define MEM_USERERROR_ERRORCODE(event) VBX_EVENTARGNUM(event,int,0)
#define MEM_USERERROR_AUTOBEEP(event) VBX_EVENTARGNUM(event,int,1)

#endif


// AwareMemo property values
#define MEM_ACTION_COPY 0
#define MEM_ACTION_CUT 1
#define MEM_ACTION_PASTE 2
#define MEM_ACTION_CLEAR 3
#define MEM_ACTION_UNDO 4
#define MEM_ACTION_SET_NULL 5
#define MEM_BORDERSTYLE_NO_BORDER 0
#define MEM_BORDERSTYLE_SINGLE_LINE 1
#define MEM_BORDERSTYLE_ROUNDED 2
#define MEM_BORDERSTYLE_DASH 3
#define MEM_BORDERSTYLE_DOT 4
#define MEM_BORDERSTYLE_DASH_DOT 5
#define MEM_BORDERSTYLE_DASH_DOT_DOT 6
#define MEM_CARETINSERT_SINGLE 0
#define MEM_CARETINSERT_DOUBLE 1
#define MEM_CARETINSERT_BLOCK 2
#define MEM_CARETINSERT_UNDERLINE 3
#define MEM_CARETINSERT_TRIANGLE 4
#define MEM_CARETOVERWRITE_SINGLE 0
#define MEM_CARETOVERWRITE_DOUBLE 1
#define MEM_CARETOVERWRITE_BLOCK 2
#define MEM_CARETOVERWRITE_UNDERLINE 3
#define MEM_CARETOVERWRITE_TRIANGLE 4
#define MEM_CONTROLTYPE_NORMAL 0
#define MEM_CONTROLTYPE_READ_ONLY 1
#define MEM_CONTROLTYPE_STATIC 2
#define MEM_MOUSEPOINTER_DEFAULT 0
#define MEM_MOUSEPOINTER_ARROW 1
#define MEM_MOUSEPOINTER_CROSS 2
#define MEM_MOUSEPOINTER_I_BEAM 3
#define MEM_MOUSEPOINTER_ICON 4
#define MEM_MOUSEPOINTER_SIZE 5
#define MEM_MOUSEPOINTER_SIZE_NE_SW 6
#define MEM_MOUSEPOINTER_SIZE_N_S 7
#define MEM_MOUSEPOINTER_SIZE_NW_SE 8
#define MEM_MOUSEPOINTER_SIZE_W_E 9
#define MEM_MOUSEPOINTER_UP_ARROW 10
#define MEM_MOUSEPOINTER_HOURGLASS 11
#define MEM_MOUSEPOINTER_NO_DROP 12
#define MEM_NOSPECIALKEYS_ALL_KEYS_ENABLED 0
#define MEM_NOSPECIALKEYS_AWARE_KEYS_DISABLED 1
#define MEM_NOSPECIALKEYS_EDIT_KEYS_DISABLED 2
#define MEM_NOSPECIALKEYS_ALL_KEYS_DISABLED 3
#define MEM_ONFOCUSPOSITION_END 0
#define MEM_ONFOCUSPOSITION_BEGINNING 1
#define MEM_ONFOCUSPOSITION_PREVIOUS 2
#define MEM_ONFOCUSPOSITION_CARET 3
#define MEM_SCROLLBARS_NONE 0
#define MEM_SCROLLBARS_HORIZONTAL_AUTO 1
#define MEM_SCROLLBARS_VERTICAL_AUTO 2
#define MEM_SCROLLBARS_BOTH_AUTO 3
#define MEM_SCROLLBARS_HORIZONTAL_FIXED 4
#define MEM_SCROLLBARS_VERTICAL_FIXED 5
#define MEM_SCROLLBARS_BOTH_FIXED 6
#define MEM_SELMODE_NORMAL 0
#define MEM_SELMODE_EXTENDED 1
#define MEM_SELMODE_LINE 2
#define MEM_TEXTMODE_NORMAL 0
#define MEM_TEXTMODE_FIRST 1
#define MEM_TEXTMODE_NEXT 2
#define MEM_TEXTMODE_LINE 3
#define MEM_THREEDINSIDESTYLE_NONE 0
#define MEM_THREEDINSIDESTYLE_LOWERED 1
#define MEM_THREEDINSIDESTYLE_RAISED 2
#define MEM_THREEDOUTSIDESTYLE_NONE 0
#define MEM_THREEDOUTSIDESTYLE_LOWERED 1
#define MEM_THREEDOUTSIDESTYLE_RAISED 2

// Class representing AwareComboBox control in AWARECB.VBX file

class CAwareComboBox : public CVBControl
{
  public:

#ifdef fpMFC

    BOOL Create(DWORD dwStyle, const RECT& rect,
                CWnd* pParentWnd, UINT nID,
                CFile* pFile = NULL, BOOL bAutoDelete = FALSE)
    {
      return CVBControl::Create(
               "AWARECB.VBX;AwareComboBox;",
               dwStyle, rect,
               pParentWnd, nID,
               pFile, bAutoDelete
             );
    }

#elif fpOWL

    CAwareComboBox(TWindow* parent, int id,
        const char far* title,
        int x, int y, int w, int h,
        long initLen = 0, void far* initData = 0,
        TModule* module = 0)
    : CVBControl(parent, id, "AWARECB.VBX", "AwareComboBox",
          title, x, y, w, h, initLen, initData, module) {};

    CAwareComboBox(TWindow* parent, int resourceId, TModule* module = 0)
    : CVBControl(parent, resourceId, module) {};

#endif

    CStringProperty About() {return CStringProperty(this,87);}
    CColorProperty BackColor() {return CColorProperty(this,2);}
    CLongProperty Col() {return CLongProperty(this,28);}
    CEnumProperty ColAlignH() {return CEnumProperty(this,61);}
    CStringProperty ColDataField() {return CStringProperty(this,62);}
    CEnumProperty ColDataFieldType() {return CEnumProperty(this,63);}
    CStringProperty ColFormat() {return CStringProperty(this,64);}
    CEnumProperty ColHeaderAlignH() {return CEnumProperty(this,66);}
    CStringProperty ColHeaderText() {return CStringProperty(this,65);}
    CBoolProperty ColHide() {return CBoolProperty(this,72);}
    CStringProperty ColList() {return CStringProperty(this,68);}
    CShortProperty ColSortSeq() {return CShortProperty(this,75);}
    CShortProperty ColSorted() {return CShortProperty(this,74);}
    CStringProperty ColText() {return CStringProperty(this,67);}
    CLongProperty ColWidth() {return CLongProperty(this,73);}
    CShortProperty ColumnEdit() {return CShortProperty(this,80);}
    CShortProperty ColumnSearch() {return CShortProperty(this,70);}
    CShortProperty ColumnSeparatorChar() {return CShortProperty(this,69);}
    CEnumProperty ColumnWidthScale() {return CEnumProperty(this,71);}
    CShortProperty Columns() {return CShortProperty(this,32);}
    CBoolProperty Enabled() {return CBoolProperty(this,19);}
    CEnumProperty FieldType() {return CEnumProperty(this,34);}
    CBoolProperty FontBold() {return CBoolProperty(this,10);}
    CBoolProperty FontItalic() {return CBoolProperty(this,11);}
    CStringProperty FontName() {return CStringProperty(this,9);}
    CFloatProperty FontSize() {return CFloatProperty(this,14);}
    CBoolProperty FontStrikethru() {return CBoolProperty(this,12);}
    CBoolProperty FontUnderline() {return CBoolProperty(this,13);}
    CColorProperty ForeColor() {return CColorProperty(this,3);}
    CEnumProperty Header3DStyle() {return CEnumProperty(this,59);}
    CEnumProperty Header3DText() {return CEnumProperty(this,92);}
    CColorProperty Header3DTextHighlightColor() {return CColorProperty(this,93);}
    CShortProperty Header3DTextOffset() {return CShortProperty(this,95);}
    CColorProperty Header3DTextShadowColor() {return CColorProperty(this,94);}
    CShortProperty Header3DWidth() {return CShortProperty(this,60);}
    CColorProperty HeaderBackColor() {return CColorProperty(this,49);}
    CBoolProperty HeaderFontBold() {return CBoolProperty(this,50);}
    CBoolProperty HeaderFontItalic() {return CBoolProperty(this,51);}
    CStringProperty HeaderFontName() {return CStringProperty(this,52);}
    CFloatProperty HeaderFontSize() {return CFloatProperty(this,53);}
    CBoolProperty HeaderFontStrike() {return CBoolProperty(this,54);}
    CBoolProperty HeaderFontUnder() {return CBoolProperty(this,55);}
    CColorProperty HeaderForeColor() {return CColorProperty(this,56);}
    CLongProperty HeaderHeight() {return CLongProperty(this,57);}
    CBoolProperty HeaderShow() {return CBoolProperty(this,58);}
    CLongProperty Height() {return CLongProperty(this,7);}
    CShortProperty Index() {return CShortProperty(this,1);}
    CLongProperty ItemData() {return CLongProperty(this,79);}
    CLongProperty Left() {return CLongProperty(this,4);}
    CColorProperty LineColor() {return CColorProperty(this,38);}
    CColorProperty LineHighlightColor() {return CColorProperty(this,36);}
    CColorProperty LineShadowColor() {return CColorProperty(this,37);}
    CEnumProperty LineStyleH() {return CEnumProperty(this,39);}
    CEnumProperty LineStyleV() {return CEnumProperty(this,40);}
    CShortProperty LineWidth() {return CShortProperty(this,41);}
    CStringProperty List() {return CStringProperty(this,31);}
    CEnumProperty List3DText() {return CEnumProperty(this,88);}
    CColorProperty List3DTextHighlightColor() {return CColorProperty(this,89);}
    CShortProperty List3DTextOffset() {return CShortProperty(this,91);}
    CColorProperty List3DTextShadowColor() {return CColorProperty(this,90);}
    CLongProperty ListCount() {return CLongProperty(this,76);}
    CLongProperty ListIndex() {return CLongProperty(this,77);}
    CLongProperty ListWidth() {return CLongProperty(this,83);}
    CShortProperty MaxDrop() {return CShortProperty(this,82);}
    CEnumProperty MousePointer() {return CEnumProperty(this,8);}
    CStringProperty Name() {return CStringProperty(this,0);}
    CShortProperty Parent() {return CShortProperty(this,20);}
    CLongProperty Row() {return CLongProperty(this,29);}
    CLongProperty RowHeight() {return CLongProperty(this,78);}
    CEnumProperty ScrollBars() {return CEnumProperty(this,27);}
    CEnumProperty Sel3DStyle() {return CEnumProperty(this,42);}
    CShortProperty Sel3DWidth() {return CShortProperty(this,47);}
    CColorProperty SelBackColor() {return CColorProperty(this,43);}
    CBoolProperty SelDrawFocusRect() {return CBoolProperty(this,48);}
    CColorProperty SelForeColor() {return CColorProperty(this,44);}
    CColorProperty SelHighlightColor() {return CColorProperty(this,45);}
    CLongProperty SelLength() {return CLongProperty(this,85);}
    CColorProperty SelShadowColor() {return CColorProperty(this,46);}
    CLongProperty SelStart() {return CLongProperty(this,84);}
    CStringProperty SelText() {return CStringProperty(this,86);}
    CEnumProperty Sorted() {return CEnumProperty(this,33);}
    CEnumProperty Style() {return CEnumProperty(this,81);}
    CShortProperty TabIndex() {return CShortProperty(this,15);}
    CShortProperty TabStop() {return CShortProperty(this,16);}
    CStringProperty Tag() {return CStringProperty(this,21);}
    CStringProperty Text() {return CStringProperty(this,30);}
    CLongProperty Top() {return CLongProperty(this,5);}
    CLongProperty TopIndex() {return CLongProperty(this,35);}
    CLongProperty VRowCount() {return CLongProperty(this,97);}
    CBoolProperty VirtualMode() {return CBoolProperty(this,96);}
    CBoolProperty Visible() {return CBoolProperty(this,22);}
    CLongProperty Width() {return CLongProperty(this,6);}

};

#ifdef fpMFC

inline void AFXAPI
DDX_VBControl(CDataExchange* pDX, int nIDC, CAwareComboBox*& rpAwareComboBox)
{
  CVBControl* pControl = (CVBControl*)rpAwareComboBox;
  DDX_VBControl(pDX, nIDC, pControl);
  rpAwareComboBox = (CAwareComboBox*)pControl;
}
#endif

// AwareComboBox event indices
#define EVENT_CBX_CLICK 0
#define EVENT_CBX_CLOSEUP 1
#define EVENT_CBX_DBLCLICK 2
#define EVENT_CBX_DROPDOWN 5
#define EVENT_CBX_GOTFOUCS 6
#define EVENT_CBX_KEYDOWN 7
#define EVENT_CBX_KEYPRESS 8
#define EVENT_CBX_KEYUP 9
#define EVENT_CBX_LOSTFOCUS 15
#define EVENT_CBX_MOUSEDOWN 16
#define EVENT_CBX_MOUSEMOVE 17
#define EVENT_CBX_MOUSEUP 18
#define EVENT_CBX_SELCHANGE 19

// AwareComboBox property indices
#define PROP_CBX_ABOUT 87
#define PROP_CBX_BACKCOLOR 2
#define PROP_CBX_COL 28
#define PROP_CBX_COLALIGNH 61
#define PROP_CBX_COLDATAFIELD 62
#define PROP_CBX_COLDATAFIELDTYPE 63
#define PROP_CBX_COLFORMAT 64
#define PROP_CBX_COLHEADERALIGNH 66
#define PROP_CBX_COLHEADERTEXT 65
#define PROP_CBX_COLHIDE 72
#define PROP_CBX_COLLIST 68
#define PROP_CBX_COLSORTSEQ 75
#define PROP_CBX_COLSORTED 74
#define PROP_CBX_COLTEXT 67
#define PROP_CBX_COLWIDTH 73
#define PROP_CBX_COLUMNEDIT 80
#define PROP_CBX_COLUMNSEARCH 70
#define PROP_CBX_COLUMNSEPARATORCHAR 69
#define PROP_CBX_COLUMNWIDTHSCALE 71
#define PROP_CBX_COLUMNS 32
#define PROP_CBX_ENABLED 19
#define PROP_CBX_FIELDTYPE 34
#define PROP_CBX_FONTBOLD 10
#define PROP_CBX_FONTITALIC 11
#define PROP_CBX_FONTNAME 9
#define PROP_CBX_FONTSIZE 14
#define PROP_CBX_FONTSTRIKETHRU 12
#define PROP_CBX_FONTUNDERLINE 13
#define PROP_CBX_FORECOLOR 3
#define PROP_CBX_HEADER3DSTYLE 59
#define PROP_CBX_HEADER3DTEXT 92
#define PROP_CBX_HEADER3DTEXTHIGHLIGHTCOLOR 93
#define PROP_CBX_HEADER3DTEXTOFFSET 95
#define PROP_CBX_HEADER3DTEXTSHADOWCOLOR 94
#define PROP_CBX_HEADER3DWIDTH 60
#define PROP_CBX_HEADERBACKCOLOR 49
#define PROP_CBX_HEADERFONTBOLD 50
#define PROP_CBX_HEADERFONTITALIC 51
#define PROP_CBX_HEADERFONTNAME 52
#define PROP_CBX_HEADERFONTSIZE 53
#define PROP_CBX_HEADERFONTSTRIKE 54
#define PROP_CBX_HEADERFONTUNDER 55
#define PROP_CBX_HEADERFORECOLOR 56
#define PROP_CBX_HEADERHEIGHT 57
#define PROP_CBX_HEADERSHOW 58
#define PROP_CBX_HEIGHT 7
#define PROP_CBX_INDEX 1
#define PROP_CBX_ITEMDATA 79
#define PROP_CBX_LEFT 4
#define PROP_CBX_LINECOLOR 38
#define PROP_CBX_LINEHIGHLIGHTCOLOR 36
#define PROP_CBX_LINESHADOWCOLOR 37
#define PROP_CBX_LINESTYLEH 39
#define PROP_CBX_LINESTYLEV 40
#define PROP_CBX_LINEWIDTH 41
#define PROP_CBX_LIST 31
#define PROP_CBX_LIST3DTEXT 88
#define PROP_CBX_LIST3DTEXTHIGHLIGHTCOLOR 89
#define PROP_CBX_LIST3DTEXTOFFSET 91
#define PROP_CBX_LIST3DTEXTSHADOWCOLOR 90
#define PROP_CBX_LISTCOUNT 76
#define PROP_CBX_LISTINDEX 77
#define PROP_CBX_LISTWIDTH 83
#define PROP_CBX_MAXDROP 82
#define PROP_CBX_MOUSEPOINTER 8
#define PROP_CBX_NAME 0
#define PROP_CBX_PARENT 20
#define PROP_CBX_ROW 29
#define PROP_CBX_ROWHEIGHT 78
#define PROP_CBX_SCROLLBARS 27
#define PROP_CBX_SEL3DSTYLE 42
#define PROP_CBX_SEL3DWIDTH 47
#define PROP_CBX_SELBACKCOLOR 43
#define PROP_CBX_SELDRAWFOCUSRECT 48
#define PROP_CBX_SELFORECOLOR 44
#define PROP_CBX_SELHIGHLIGHTCOLOR 45
#define PROP_CBX_SELLENGTH 85
#define PROP_CBX_SELSHADOWCOLOR 46
#define PROP_CBX_SELSTART 84
#define PROP_CBX_SELTEXT 86
#define PROP_CBX_SORTED 33
#define PROP_CBX_STYLE 81
#define PROP_CBX_TABINDEX 15
#define PROP_CBX_TABSTOP 16
#define PROP_CBX_TAG 21
#define PROP_CBX_TEXT 30
#define PROP_CBX_TOP 5
#define PROP_CBX_TOPINDEX 35
#define PROP_CBX_VROWCOUNT 97
#define PROP_CBX_VIRTUALMODE 96
#define PROP_CBX_VISIBLE 22
#define PROP_CBX_WIDTH 6

#ifdef fpMFC


// AwareComboBox event macros
#define CBX_KEYDOWN_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CBX_KEYDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CBX_KEYPRESS_KEYASCII(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define CBX_KEYUP_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CBX_KEYUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CBX_MOUSEDOWN_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define CBX_MOUSEDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define CBX_MOUSEDOWN_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CBX_MOUSEDOWN_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CBX_MOUSEMOVE_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define CBX_MOUSEMOVE_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define CBX_MOUSEMOVE_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CBX_MOUSEMOVE_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CBX_MOUSEUP_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,3)
#define CBX_MOUSEUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,2)
#define CBX_MOUSEUP_X(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define CBX_MOUSEUP_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define CBX_SELCHANGE_CHOICE(lpParams) AFX_HLSTR_EVENTPARAMINDEX(lpParams,0)

#elif fpOWL


// AwareComboBox event macros
#define CBX_KEYDOWN_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define CBX_KEYDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CBX_KEYPRESS_KEYASCII(event) VBX_EVENTARGNUM(event,int,0)
#define CBX_KEYUP_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define CBX_KEYUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CBX_MOUSEDOWN_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define CBX_MOUSEDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CBX_MOUSEDOWN_X(event) VBX_EVENTARGNUM(event,float,2)
#define CBX_MOUSEDOWN_Y(event) VBX_EVENTARGNUM(event,float,3)
#define CBX_MOUSEMOVE_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define CBX_MOUSEMOVE_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CBX_MOUSEMOVE_X(event) VBX_EVENTARGNUM(event,float,2)
#define CBX_MOUSEMOVE_Y(event) VBX_EVENTARGNUM(event,float,3)
#define CBX_MOUSEUP_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define CBX_MOUSEUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define CBX_MOUSEUP_X(event) VBX_EVENTARGNUM(event,float,2)
#define CBX_MOUSEUP_Y(event) VBX_EVENTARGNUM(event,float,3)
#define CBX_SELCHANGE_CHOICE(event) VBX_EVENTARGSTR(event,0)

#endif


// AwareComboBox property values
#define CBX_COLALIGNH_LEFT 0
#define CBX_COLALIGNH_CENTER 1
#define CBX_COLALIGNH_RIGHT 2
#define CBX_COLDATAFIELDTYPE_BOOLEAN 1
#define CBX_COLDATAFIELDTYPE_INTEGER 3
#define CBX_COLDATAFIELDTYPE_LONG 4
#define CBX_COLDATAFIELDTYPE_CURRENCY 5
#define CBX_COLDATAFIELDTYPE_SINGLE 6
#define CBX_COLDATAFIELDTYPE_DOUBLE 7
#define CBX_COLDATAFIELDTYPE_TEXT 10
#define CBX_COLHEADERALIGNH_LEFT 0
#define CBX_COLHEADERALIGNH_CENTER 1
#define CBX_COLHEADERALIGNH_RIGHT 2
#define CBX_COLHEADERALIGNH_DEFAULT 3
#define CBX_COLUMNWIDTHSCALE_TWIPS 0
#define CBX_COLUMNWIDTHSCALE_PIXELS 1
#define CBX_COLUMNWIDTHSCALE_AVG_CHAR_WIDTH 2
#define CBX_COLUMNWIDTHSCALE_MAX_CHAR_WIDTH 3
#define CBX_FIELDTYPE_BOOLEAN 1
#define CBX_FIELDTYPE_INTEGER 3
#define CBX_FIELDTYPE_LONG 4
#define CBX_FIELDTYPE_CURRENCY 5
#define CBX_FIELDTYPE_SINGLE 6
#define CBX_FIELDTYPE_DOUBLE 7
#define CBX_FIELDTYPE_TEXT 10
#define CBX_HEADER3DSTYLE_NONE 0
#define CBX_HEADER3DSTYLE_SOLID 1
#define CBX_HEADER3DSTYLE_3D_LOWERED 2
#define CBX_HEADER3DSTYLE_3D_RAISED 3
#define CBX_HEADER3DTEXT_NONE 0
#define CBX_HEADER3DTEXT_ETCHED 1
#define CBX_HEADER3DTEXT_EMBOSSED 2
#define CBX_HEADER3DTEXT_ETCHED_W_SHADING 3
#define CBX_HEADER3DTEXT_EMBOSSED_W_SHADING 4
#define CBX_LINESTYLEH_NONE 0
#define CBX_LINESTYLEH_SOLID 1
#define CBX_LINESTYLEH_3D_LOWERED 2
#define CBX_LINESTYLEH_3D_RAISED 3
#define CBX_LINESTYLEV_NONE 0
#define CBX_LINESTYLEV_SOLID 1
#define CBX_LINESTYLEV_3D_LOWERED 2
#define CBX_LINESTYLEV_3D_RAISED 3
#define CBX_LIST3DTEXT_NONE 0
#define CBX_LIST3DTEXT_ETCHED 1
#define CBX_LIST3DTEXT_EMBOSSED 2
#define CBX_LIST3DTEXT_ETCHED_W_SHADING 3
#define CBX_LIST3DTEXT_EMBOSSED_W_SHADING 4
#define CBX_MOUSEPOINTER_DEFAULT 0
#define CBX_MOUSEPOINTER_ARROW 1
#define CBX_MOUSEPOINTER_CROSS 2
#define CBX_MOUSEPOINTER_I_BEAM 3
#define CBX_MOUSEPOINTER_ICON 4
#define CBX_MOUSEPOINTER_SIZE 5
#define CBX_MOUSEPOINTER_SIZE_NE_SW 6
#define CBX_MOUSEPOINTER_SIZE_N_S 7
#define CBX_MOUSEPOINTER_SIZE_NW_SE 8
#define CBX_MOUSEPOINTER_SIZE_W_E 9
#define CBX_MOUSEPOINTER_UP_ARROW 10
#define CBX_MOUSEPOINTER_HOURGLASS 11
#define CBX_MOUSEPOINTER_NO_DROP 12
#define CBX_SCROLLBARS_NONE 0
#define CBX_SCROLLBARS_HORIZONTAL 1
#define CBX_SCROLLBARS_VERTICAL 2
#define CBX_SCROLLBARS_BOTH 3
#define CBX_SEL3DSTYLE_NONE 0
#define CBX_SEL3DSTYLE_LOWERED 1
#define CBX_SEL3DSTYLE_RAISED 2
#define CBX_SORTED_NONE 0
#define CBX_SORTED_ASCENDING 1
#define CBX_SORTED_DESCENDING 2
#define CBX_STYLE_DROPDOWN_COMBO 0
#define CBX_STYLE_SIMPLE_COMBO 1
#define CBX_STYLE_DROPDOWN_LIST 2

// Class representing AwareListBox control in AWARELB.VBX file

class CAwareListBox : public CVBControl
{
  public:

#ifdef fpMFC

    BOOL Create(DWORD dwStyle, const RECT& rect,
                CWnd* pParentWnd, UINT nID,
                CFile* pFile = NULL, BOOL bAutoDelete = FALSE)
    {
      return CVBControl::Create(
               "AWARELB.VBX;AwareListBox;",
               dwStyle, rect,
               pParentWnd, nID,
               pFile, bAutoDelete
             );
    }

#elif fpOWL

    CAwareListBox(TWindow* parent, int id,
        const char far* title,
        int x, int y, int w, int h,
        long initLen = 0, void far* initData = 0,
        TModule* module = 0)
    : CVBControl(parent, id, "AWARELB.VBX", "AwareListBox",
          title, x, y, w, h, initLen, initData, module) {};

    CAwareListBox(TWindow* parent, int resourceId, TModule* module = 0)
    : CVBControl(parent, resourceId, module) {};

#endif

    CStringProperty About() {return CStringProperty(this,90);}
    CShortProperty Action() {return CShortProperty(this,84);}
    CEnumProperty AutoSearch() {return CEnumProperty(this,85);}
    CColorProperty BackColor() {return CColorProperty(this,2);}
    CLongProperty Col() {return CLongProperty(this,28);}
    CEnumProperty ColAlignH() {return CEnumProperty(this,61);}
    CStringProperty ColDataField() {return CStringProperty(this,62);}
    CEnumProperty ColDataFieldType() {return CEnumProperty(this,63);}
    CStringProperty ColFormat() {return CStringProperty(this,64);}
    CEnumProperty ColHeaderAlignH() {return CEnumProperty(this,66);}
    CStringProperty ColHeaderText() {return CStringProperty(this,65);}
    CBoolProperty ColHide() {return CBoolProperty(this,72);}
    CStringProperty ColList() {return CStringProperty(this,68);}
    CShortProperty ColSortSeq() {return CShortProperty(this,75);}
    CShortProperty ColSorted() {return CShortProperty(this,74);}
    CStringProperty ColText() {return CStringProperty(this,67);}
    CLongProperty ColWidth() {return CLongProperty(this,73);}
    CShortProperty ColumnSearch() {return CShortProperty(this,70);}
    CShortProperty ColumnSeparatorChar() {return CShortProperty(this,69);}
    CEnumProperty ColumnWidthScale() {return CEnumProperty(this,71);}
    CShortProperty Columns() {return CShortProperty(this,32);}
    CBoolProperty Enabled() {return CBoolProperty(this,19);}
    CEnumProperty FieldType() {return CEnumProperty(this,34);}
    CBoolProperty FontBold() {return CBoolProperty(this,10);}
    CBoolProperty FontItalic() {return CBoolProperty(this,11);}
    CStringProperty FontName() {return CStringProperty(this,9);}
    CFloatProperty FontSize() {return CFloatProperty(this,14);}
    CBoolProperty FontStrikethru() {return CBoolProperty(this,12);}
    CBoolProperty FontUnderline() {return CBoolProperty(this,13);}
    CColorProperty ForeColor() {return CColorProperty(this,3);}
    CEnumProperty Header3DStyle() {return CEnumProperty(this,59);}
    CEnumProperty Header3DText() {return CEnumProperty(this,95);}
    CColorProperty Header3DTextHighlightColor() {return CColorProperty(this,96);}
    CShortProperty Header3DTextOffset() {return CShortProperty(this,98);}
    CColorProperty Header3DTextShadowColor() {return CColorProperty(this,97);}
    CShortProperty Header3DWidth() {return CShortProperty(this,60);}
    CColorProperty HeaderBackColor() {return CColorProperty(this,49);}
    CBoolProperty HeaderFontBold() {return CBoolProperty(this,50);}
    CBoolProperty HeaderFontItalic() {return CBoolProperty(this,51);}
    CStringProperty HeaderFontName() {return CStringProperty(this,52);}
    CFloatProperty HeaderFontSize() {return CFloatProperty(this,53);}
    CBoolProperty HeaderFontStrike() {return CBoolProperty(this,54);}
    CBoolProperty HeaderFontUnder() {return CBoolProperty(this,55);}
    CColorProperty HeaderForeColor() {return CColorProperty(this,56);}
    CLongProperty HeaderHeight() {return CLongProperty(this,57);}
    CBoolProperty HeaderShow() {return CBoolProperty(this,58);}
    CLongProperty Height() {return CLongProperty(this,7);}
    CShortProperty Index() {return CShortProperty(this,1);}
    CLongProperty ItemData() {return CLongProperty(this,79);}
    CLongProperty Left() {return CLongProperty(this,4);}
    CColorProperty LineColor() {return CColorProperty(this,38);}
    CColorProperty LineHighlightColor() {return CColorProperty(this,36);}
    CColorProperty LineShadowColor() {return CColorProperty(this,37);}
    CEnumProperty LineStyleH() {return CEnumProperty(this,39);}
    CEnumProperty LineStyleV() {return CEnumProperty(this,40);}
    CShortProperty LineWidth() {return CShortProperty(this,41);}
    CStringProperty List() {return CStringProperty(this,31);}
    CEnumProperty List3DText() {return CEnumProperty(this,91);}
    CColorProperty List3DTextHighlightColor() {return CColorProperty(this,92);}
    CShortProperty List3DTextOffset() {return CShortProperty(this,94);}
    CColorProperty List3DTextShadowColor() {return CColorProperty(this,93);}
    CLongProperty ListCount() {return CLongProperty(this,76);}
    CLongProperty ListIndex() {return CLongProperty(this,77);}
    CEnumProperty MousePointer() {return CEnumProperty(this,8);}
    CEnumProperty MultiSelect() {return CEnumProperty(this,80);}
    CStringProperty Name() {return CStringProperty(this,0);}
    CLongProperty NewIndex() {return CLongProperty(this,89);}
    CShortProperty Parent() {return CShortProperty(this,20);}
    CLongProperty Row() {return CLongProperty(this,29);}
    CLongProperty RowHeight() {return CLongProperty(this,78);}
    CEnumProperty ScrollBars() {return CEnumProperty(this,27);}
    CLongProperty SearchIndex() {return CLongProperty(this,86);}
    CEnumProperty SearchMethod() {return CEnumProperty(this,87);}
    CStringProperty SearchText() {return CStringProperty(this,88);}
    CEnumProperty Sel3DStyle() {return CEnumProperty(this,42);}
    CShortProperty Sel3DWidth() {return CShortProperty(this,47);}
    CColorProperty SelBackColor() {return CColorProperty(this,43);}
    CBoolProperty SelDrawFocusRect() {return CBoolProperty(this,48);}
    CColorProperty SelForeColor() {return CColorProperty(this,44);}
    CColorProperty SelHighlightColor() {return CColorProperty(this,45);}
    CLongProperty SelMax() {return CLongProperty(this,83);}
    CColorProperty SelShadowColor() {return CColorProperty(this,46);}
    CBoolProperty Selected() {return CBoolProperty(this,82);}
    CEnumProperty Sorted() {return CEnumProperty(this,33);}
    CShortProperty TabIndex() {return CShortProperty(this,15);}
    CShortProperty TabStop() {return CShortProperty(this,16);}
    CStringProperty Tag() {return CStringProperty(this,21);}
    CStringProperty Text() {return CStringProperty(this,30);}
    CLongProperty Top() {return CLongProperty(this,5);}
    CLongProperty TopIndex() {return CLongProperty(this,35);}
    CLongProperty VRowCount() {return CLongProperty(this,100);}
    CBoolProperty VirtualMode() {return CBoolProperty(this,99);}
    CBoolProperty Visible() {return CBoolProperty(this,22);}
    CLongProperty Width() {return CLongProperty(this,6);}
    CBoolProperty WrapList() {return CBoolProperty(this,81);}

};

#ifdef fpMFC

inline void AFXAPI
DDX_VBControl(CDataExchange* pDX, int nIDC, CAwareListBox*& rpAwareListBox)
{
  CVBControl* pControl = (CVBControl*)rpAwareListBox;
  DDX_VBControl(pDX, nIDC, pControl);
  rpAwareListBox = (CAwareListBox*)pControl;
}
#endif

// AwareListBox event indices
#define EVENT_LBX_CLICK 0
#define EVENT_LBX_DBLCLICK 1
#define EVENT_LBX_GOTFOUCS 4
#define EVENT_LBX_KEYDOWN 5
#define EVENT_LBX_KEYPRESS 6
#define EVENT_LBX_KEYUP 7
#define EVENT_LBX_LOSTFOCUS 13
#define EVENT_LBX_MOUSEDOWN 14
#define EVENT_LBX_MOUSEMOVE 15
#define EVENT_LBX_MOUSEUP 16
#define EVENT_LBX_SELCHANGE 17

// AwareListBox property indices
#define PROP_LBX_ABOUT 90
#define PROP_LBX_ACTION 84
#define PROP_LBX_AUTOSEARCH 85
#define PROP_LBX_BACKCOLOR 2
#define PROP_LBX_COL 28
#define PROP_LBX_COLALIGNH 61
#define PROP_LBX_COLDATAFIELD 62
#define PROP_LBX_COLDATAFIELDTYPE 63
#define PROP_LBX_COLFORMAT 64
#define PROP_LBX_COLHEADERALIGNH 66
#define PROP_LBX_COLHEADERTEXT 65
#define PROP_LBX_COLHIDE 72
#define PROP_LBX_COLLIST 68
#define PROP_LBX_COLSORTSEQ 75
#define PROP_LBX_COLSORTED 74
#define PROP_LBX_COLTEXT 67
#define PROP_LBX_COLWIDTH 73
#define PROP_LBX_COLUMNSEARCH 70
#define PROP_LBX_COLUMNSEPARATORCHAR 69
#define PROP_LBX_COLUMNWIDTHSCALE 71
#define PROP_LBX_COLUMNS 32
#define PROP_LBX_ENABLED 19
#define PROP_LBX_FIELDTYPE 34
#define PROP_LBX_FONTBOLD 10
#define PROP_LBX_FONTITALIC 11
#define PROP_LBX_FONTNAME 9
#define PROP_LBX_FONTSIZE 14
#define PROP_LBX_FONTSTRIKETHRU 12
#define PROP_LBX_FONTUNDERLINE 13
#define PROP_LBX_FORECOLOR 3
#define PROP_LBX_HEADER3DSTYLE 59
#define PROP_LBX_HEADER3DTEXT 95
#define PROP_LBX_HEADER3DTEXTHIGHLIGHTCOLOR 96
#define PROP_LBX_HEADER3DTEXTOFFSET 98
#define PROP_LBX_HEADER3DTEXTSHADOWCOLOR 97
#define PROP_LBX_HEADER3DWIDTH 60
#define PROP_LBX_HEADERBACKCOLOR 49
#define PROP_LBX_HEADERFONTBOLD 50
#define PROP_LBX_HEADERFONTITALIC 51
#define PROP_LBX_HEADERFONTNAME 52
#define PROP_LBX_HEADERFONTSIZE 53
#define PROP_LBX_HEADERFONTSTRIKE 54
#define PROP_LBX_HEADERFONTUNDER 55
#define PROP_LBX_HEADERFORECOLOR 56
#define PROP_LBX_HEADERHEIGHT 57
#define PROP_LBX_HEADERSHOW 58
#define PROP_LBX_HEIGHT 7
#define PROP_LBX_INDEX 1
#define PROP_LBX_ITEMDATA 79
#define PROP_LBX_LEFT 4
#define PROP_LBX_LINECOLOR 38
#define PROP_LBX_LINEHIGHLIGHTCOLOR 36
#define PROP_LBX_LINESHADOWCOLOR 37
#define PROP_LBX_LINESTYLEH 39
#define PROP_LBX_LINESTYLEV 40
#define PROP_LBX_LINEWIDTH 41
#define PROP_LBX_LIST 31
#define PROP_LBX_LIST3DTEXT 91
#define PROP_LBX_LIST3DTEXTHIGHLIGHTCOLOR 92
#define PROP_LBX_LIST3DTEXTOFFSET 94
#define PROP_LBX_LIST3DTEXTSHADOWCOLOR 93
#define PROP_LBX_LISTCOUNT 76
#define PROP_LBX_LISTINDEX 77
#define PROP_LBX_MOUSEPOINTER 8
#define PROP_LBX_MULTISELECT 80
#define PROP_LBX_NAME 0
#define PROP_LBX_NEWINDEX 89
#define PROP_LBX_PARENT 20
#define PROP_LBX_ROW 29
#define PROP_LBX_ROWHEIGHT 78
#define PROP_LBX_SCROLLBARS 27
#define PROP_LBX_SEARCHINDEX 86
#define PROP_LBX_SEARCHMETHOD 87
#define PROP_LBX_SEARCHTEXT 88
#define PROP_LBX_SEL3DSTYLE 42
#define PROP_LBX_SEL3DWIDTH 47
#define PROP_LBX_SELBACKCOLOR 43
#define PROP_LBX_SELDRAWFOCUSRECT 48
#define PROP_LBX_SELFORECOLOR 44
#define PROP_LBX_SELHIGHLIGHTCOLOR 45
#define PROP_LBX_SELMAX 83
#define PROP_LBX_SELSHADOWCOLOR 46
#define PROP_LBX_SELECTED 82
#define PROP_LBX_SORTED 33
#define PROP_LBX_TABINDEX 15
#define PROP_LBX_TABSTOP 16
#define PROP_LBX_TAG 21
#define PROP_LBX_TEXT 30
#define PROP_LBX_TOP 5
#define PROP_LBX_TOPINDEX 35
#define PROP_LBX_VROWCOUNT 100
#define PROP_LBX_VIRTUALMODE 99
#define PROP_LBX_VISIBLE 22
#define PROP_LBX_WIDTH 6
#define PROP_LBX_WRAPLIST 81

#ifdef fpMFC


// AwareListBox event macros
#define LBX_KEYDOWN_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,1)
#define LBX_KEYDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define LBX_KEYPRESS_KEYASCII(lpParams) AFX_NUM_EVENTPARAMINDEX(int,lpParams,0)
#define LBX_KEYUP_KEYCODE(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,1)
#define LBX_KEYUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define LBX_MOUSEDOWN_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,3)
#define LBX_MOUSEDOWN_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,2)
#define LBX_MOUSEDOWN_X(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,1)
#define LBX_MOUSEDOWN_Y(lpParams) AFX_NUM_EVENTPARAMINDEX(float,lpParams,0)
#define LBX_MOUSEMOVE_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX((null),lpParams,3)
#define LBX_MOUSEMOVE_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX((null),lpParams,2)
#define LBX_MOUSEMOVE_X(lpParams) AFX_NUM_EVENTPARAMINDEX((null),lpParams,1)
#define LBX_MOUSEMOVE_Y(lpParams) AFX_NUM_EVENTPARAMINDEX((null),lpParams,0)
#define LBX_MOUSEUP_BUTTON(lpParams) AFX_NUM_EVENTPARAMINDEX((null),lpParams,3)
#define LBX_MOUSEUP_SHIFT(lpParams) AFX_NUM_EVENTPARAMINDEX((null),lpParams,2)
#define LBX_MOUSEUP_X(lpParams) AFX_NUM_EVENTPARAMINDEX((null),lpParams,1)
#define LBX_MOUSEUP_Y(lpParams) AFX_NUM_EVENTPARAMINDEX((null),lpParams,0)

#elif fpOWL


// AwareListBox event macros
#define LBX_KEYDOWN_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define LBX_KEYDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define LBX_KEYPRESS_KEYASCII(event) VBX_EVENTARGNUM(event,int,0)
#define LBX_KEYUP_KEYCODE(event) VBX_EVENTARGNUM(event,int,0)
#define LBX_KEYUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define LBX_MOUSEDOWN_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define LBX_MOUSEDOWN_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define LBX_MOUSEDOWN_X(event) VBX_EVENTARGNUM(event,float,2)
#define LBX_MOUSEDOWN_Y(event) VBX_EVENTARGNUM(event,float,3)
#define LBX_MOUSEMOVE_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define LBX_MOUSEMOVE_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define LBX_MOUSEMOVE_X(event) VBX_EVENTARGNUM(event,float,2)
#define LBX_MOUSEMOVE_Y(event) VBX_EVENTARGNUM(event,float,3)
#define LBX_MOUSEUP_BUTTON(event) VBX_EVENTARGNUM(event,int,0)
#define LBX_MOUSEUP_SHIFT(event) VBX_EVENTARGNUM(event,int,1)
#define LBX_MOUSEUP_X(event) VBX_EVENTARGNUM(event,float,2)
#define LBX_MOUSEUP_Y(event) VBX_EVENTARGNUM(event,float,3)

#endif


// AwareListBox property values
#define LBX_AUTOSEARCH_NONE 0
#define LBX_AUTOSEARCH_SINGLE_CHAR 1
#define LBX_AUTOSEARCH_MULTIPLE_CHAR 2
#define LBX_COLALIGNH_LEFT 0
#define LBX_COLALIGNH_CENTER 1
#define LBX_COLALIGNH_RIGHT 2
#define LBX_COLDATAFIELDTYPE_BOOLEAN 1
#define LBX_COLDATAFIELDTYPE_INTEGER 3
#define LBX_COLDATAFIELDTYPE_LONG 4
#define LBX_COLDATAFIELDTYPE_CURRENCY 5
#define LBX_COLDATAFIELDTYPE_SINGLE 6
#define LBX_COLDATAFIELDTYPE_DOUBLE 7
#define LBX_COLDATAFIELDTYPE_TEXT 10
#define LBX_COLHEADERALIGNH_LEFT 0
#define LBX_COLHEADERALIGNH_CENTER 1
#define LBX_COLHEADERALIGNH_RIGHT 2
#define LBX_COLHEADERALIGNH_DEFAULT 3
#define LBX_COLUMNWIDTHSCALE_TWIPS 0
#define LBX_COLUMNWIDTHSCALE_PIXELS 1
#define LBX_COLUMNWIDTHSCALE_AVG_CHAR_WIDTH 2
#define LBX_COLUMNWIDTHSCALE_MAX_CHAR_WIDTH 3
#define LBX_FIELDTYPE_BOOLEAN 1
#define LBX_FIELDTYPE_INTEGER 3
#define LBX_FIELDTYPE_LONG 4
#define LBX_FIELDTYPE_CURRENCY 5
#define LBX_FIELDTYPE_SINGLE 6
#define LBX_FIELDTYPE_DOUBLE 7
#define LBX_FIELDTYPE_TEXT 10
#define LBX_HEADER3DSTYLE_NONE 0
#define LBX_HEADER3DSTYLE_SOLID 1
#define LBX_HEADER3DSTYLE_3D_LOWERED 2
#define LBX_HEADER3DSTYLE_3D_RAISED 3
#define LBX_HEADER3DTEXT_NONE 0
#define LBX_HEADER3DTEXT_ETCHED 1
#define LBX_HEADER3DTEXT_EMBOSSED 2
#define LBX_HEADER3DTEXT_ETCHED_W_SHADING 3
#define LBX_HEADER3DTEXT_EMBOSSED_W_SHADING 4
#define LBX_LINESTYLEH_NONE 0
#define LBX_LINESTYLEH_SOLID 1
#define LBX_LINESTYLEH_3D_LOWERED 2
#define LBX_LINESTYLEH_3D_RAISED 3
#define LBX_LINESTYLEV_NONE 0
#define LBX_LINESTYLEV_SOLID 1
#define LBX_LINESTYLEV_3D_LOWERED 2
#define LBX_LINESTYLEV_3D_RAISED 3
#define LBX_LIST3DTEXT_NONE 0
#define LBX_LIST3DTEXT_ETCHED 1
#define LBX_LIST3DTEXT_EMBOSSED 2
#define LBX_LIST3DTEXT_ETCHED_W_SHADING 3
#define LBX_LIST3DTEXT_EMBOSSED_W_SHADING 4
#define LBX_MOUSEPOINTER_DEFAULT 0
#define LBX_MOUSEPOINTER_ARROW 1
#define LBX_MOUSEPOINTER_CROSS 2
#define LBX_MOUSEPOINTER_I_BEAM 3
#define LBX_MOUSEPOINTER_ICON 4
#define LBX_MOUSEPOINTER_SIZE 5
#define LBX_MOUSEPOINTER_SIZE_NE_SW 6
#define LBX_MOUSEPOINTER_SIZE_N_S 7
#define LBX_MOUSEPOINTER_SIZE_NW_SE 8
#define LBX_MOUSEPOINTER_SIZE_W_E 9
#define LBX_MOUSEPOINTER_UP_ARROW 10
#define LBX_MOUSEPOINTER_HOURGLASS 11
#define LBX_MOUSEPOINTER_NO_DROP 12
#define LBX_MULTISELECT_NONE 0
#define LBX_MULTISELECT_SIMPLE 1
#define LBX_MULTISELECT_EXTENDED 2
#define LBX_SCROLLBARS_NONE 0
#define LBX_SCROLLBARS_HORIZONTAL 1
#define LBX_SCROLLBARS_VERTICAL 2
#define LBX_SCROLLBARS_BOTH 3
#define LBX_SEARCHMETHOD_EXACT_MATCH 0
#define LBX_SEARCHMETHOD_NEXT_GREATEST 1
#define LBX_SEL3DSTYLE_NONE 0
#define LBX_SEL3DSTYLE_LOWERED 1
#define LBX_SEL3DSTYLE_RAISED 2
#define LBX_SORTED_NONE 0
#define LBX_SORTED_ASCENDING 1
#define LBX_SORTED_DESCENDING 2

#endif
